/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 34 "parser.y" /* yacc.c:339  */


#define PARSER_VERSION_STRING "parser_version_3"

#include "config.h"
#include <stdlib.h>
#include <termios.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <setjmp.h>
#include <sys/stat.h>                    /* structure stat       */
#include <unistd.h>                      /* prototype for stat() */
#include <sys/wait.h>
#include <signal.h>
#include <stdarg.h>
#include <pwd.h>
#include <syslog.h>
#include <string.h>
#include <errno.h>
#ifdef __linux__
#include <mntent.h>
#endif

#include "dosemu_config.h"
#include "emu.h"
#ifdef X86_EMULATOR
#include "cpu-emu.h"
#endif
#include "disks.h"
#include "port.h"
#define allow_io	port_allow_io
#include "lpt.h"
#include "video.h"
#include "vc.h"
#include "mouse.h"
#include "serial.h"
#include "timers.h"
#include "keymaps.h"
#include "keyb_server.h"
#include "memory.h"
#include "mapping.h"
#include "utilities.h"
#include "aspi.h"
#include "pktdrvr.h"
#include "iodev.h" /* for TM_BIOS / TM_PIT / TM_LINUX */

#define USERVAR_PREF	"dosemu_"
static int user_scope_level;

static int after_secure_check = 0;
static serial_t *sptr;
static serial_t nullser;
static mouse_t *mptr = &config.mouse;
static int c_ser = 0;

static struct disk *dptr;
static struct disk nulldisk;
static int c_hdisks = 0;
static int c_fdisks = 0;

int dexe_running = 0;
static int dexe_forbid_disk = 1;
char own_hostname[128];

static struct printer nullptr;
static struct printer *pptr = &nullptr;
static int c_printers = 0;

static int ports_permission = IO_RDWR;
static unsigned int ports_ormask = 0;
static unsigned int ports_andmask = 0xFFFF;
static unsigned int portspeed = 0;
static char dev_name[255]= "";

static int errors = 0;
static int warnings = 0;

static int priv_lvl = 0;
static int saved_priv_lvl = 0; 


static char *file_being_parsed;

			/* this to ensure we are parsing a new style */
static int parser_version_3_style_used = 0;
#define CONFNAME_V3USED "version_3_style_used"

	/* local procedures */

static void start_ports(void);
static void start_mouse(void);
static void stop_mouse(void);
static void start_debug(void);
static void start_video(void);
static void stop_video(void);
static void set_vesamodes(int width, int height, int color_bits);
static int detect_vbios_seg(void);
static int detect_vbios_size(void);
static void stop_ttylocks(void);
static void start_serial(void);
static void stop_serial(void);
static void start_printer(void);
static void stop_printer(void);
static void start_keyboard(void);
static void keytable_start(int layout);
static void keytable_stop(void);
static void dump_keytables_to_file(char *name);
static void stop_terminal(void);
static void start_disk(void);
static void do_part(char *);
static void start_bootdisk(void);
static void start_floppy(void);
static void stop_disk(int token);
static void start_vnet(char *);
static FILE* open_file(char* filename);
static void close_file(FILE* file);
static void write_to_syslog(char *message);
static void set_irq_value(int bits, int i1);
static void set_irq_range(int bits, int i1, int i2);
static int undefine_config_variable(char *name);
static void check_user_var(char *name);
static char *run_shell(char *command);
static int for_each_handling(int loopid, char *varname, char *delim, char *list);
static void enter_user_scope(int incstackptr);
static void leave_user_scope(int incstackptr);
static void handle_features(int which, int value);
static void set_joy_device(char *devstring);
static int parse_timemode(const char *);

	/* class stuff */
#define IFCLASS(m) if (is_in_allowed_classes(m))

#define CL_ALL			-1
#define CL_VAR		    0x200
#define CL_VPORT	   0x2000
#define CL_PORT		  0x20000
#define CL_PCI		  0x40000
#define CL_IRQ		 0x200000
#define CL_HARDRAM	0x1000000
#define CL_NET		0x2000000

static int is_in_allowed_classes(int mask);

#define TOF(x) ( x.type == TYPE_REAL ? x.value.r : x.value.i )
#define V_VAL(x,y,z) \
do { x.type = y.type; if (x.type == TYPE_REAL) x.value.r = (z); \
      else x.value.i = (z); } \
while (0)

	/* variables in lexer.l */



#include "translate.h"
#include "dosemu_charset.h"
	/* for translate plugin */

static void set_internal_charset(char *charset_name);
static void set_external_charset(char *charset_name);




	/* for unicode keyboard plugin */
static void keyb_mod(int wich, t_keysym keynum, int unicode);
static void dump_keytable_part(FILE *f, t_keysym *map, int size);


#line 238 "parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.h".  */
#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    INTEGER = 258,
    L_OFF = 259,
    L_ON = 260,
    L_AUTO = 261,
    L_YES = 262,
    L_NO = 263,
    CHIPSET_TYPE = 264,
    KEYB_LAYOUT = 265,
    REAL = 266,
    STRING = 267,
    VARIABLE = 268,
    EXPRTEST = 269,
    INTCAST = 270,
    REALCAST = 271,
    AND_OP = 272,
    OR_OP = 273,
    XOR_OP = 274,
    SHR_OP = 275,
    SHL_OP = 276,
    NOT_OP = 277,
    EQ_OP = 278,
    GE_OP = 279,
    LE_OP = 280,
    NEQ_OP = 281,
    STR_EQ_OP = 282,
    STR_NEQ_OP = 283,
    L_AND_OP = 284,
    L_OR_OP = 285,
    UMINUS = 286,
    UPLUS = 287,
    BIT_NOT_OP = 288,
    STRLEN = 289,
    STRTOL = 290,
    STRNCMP = 291,
    STRCAT = 292,
    STRPBRK = 293,
    STRSPLIT = 294,
    STRCHR = 295,
    STRRCHR = 296,
    STRSTR = 297,
    STRDEL = 298,
    STRSPN = 299,
    STRCSPN = 300,
    SHELL = 301,
    DEFINED = 302,
    DEFINE = 303,
    UNDEF = 304,
    IFSTATEMENT = 305,
    WHILESTATEMENT = 306,
    FOREACHSTATEMENT = 307,
    ENTER_USER_SPACE = 308,
    LEAVE_USER_SPACE = 309,
    CHECKUSERVAR = 310,
    DOSBANNER = 311,
    FASTFLOPPY = 312,
    HOGTHRESH = 313,
    SPEAKER = 314,
    IPXSUPPORT = 315,
    IPXNETWORK = 316,
    NOVELLHACK = 317,
    NETDEV = 318,
    VNET = 319,
    DEBUG = 320,
    MOUSE = 321,
    SERIAL = 322,
    COM = 323,
    KEYBOARD = 324,
    TERMINAL = 325,
    VIDEO = 326,
    EMURETRACE = 327,
    TIMER = 328,
    MATHCO = 329,
    CPU = 330,
    CPUSPEED = 331,
    RDTSC = 332,
    BOOTA = 333,
    BOOTB = 334,
    BOOTC = 335,
    L_XMS = 336,
    L_DPMI = 337,
    DPMI_BASE = 338,
    PM_DOS_API = 339,
    NO_NULL_CHECKS = 340,
    PORTS = 341,
    DISK = 342,
    DOSMEM = 343,
    EXT_MEM = 344,
    L_EMS = 345,
    L_UMB = 346,
    EMS_SIZE = 347,
    EMS_FRAME = 348,
    EMS_UMA_PAGES = 349,
    EMS_CONV_PAGES = 350,
    TTYLOCKS = 351,
    L_SOUND = 352,
    L_SND_OSS = 353,
    L_JOYSTICK = 354,
    FULL_FILE_LOCKS = 355,
    DEXE = 356,
    ALLOWDISK = 357,
    FORCEXDOS = 358,
    XDOSONLY = 359,
    ABORT = 360,
    WARN = 361,
    BOOTDISK = 362,
    L_FLOPPY = 363,
    EMUSYS = 364,
    EMUINI = 365,
    L_X = 366,
    DOSEMUMAP = 367,
    LOGBUFSIZE = 368,
    LOGFILESIZE = 369,
    MAPPINGDRIVER = 370,
    LFN_SUPPORT = 371,
    EMULATED = 372,
    NATIVE = 373,
    CPUEMU = 374,
    VM86 = 375,
    FULL = 376,
    VM86SIM = 377,
    FULLSIM = 378,
    RAWKEYBOARD = 379,
    PRESTROKE = 380,
    KEYTABLE = 381,
    SHIFT_MAP = 382,
    ALT_MAP = 383,
    NUMPAD_MAP = 384,
    DUMP = 385,
    DGRAVE = 386,
    DACUTE = 387,
    DCIRCUM = 388,
    DTILDE = 389,
    DBREVE = 390,
    DABOVED = 391,
    DDIARES = 392,
    DABOVER = 393,
    DDACUTE = 394,
    DCEDILLA = 395,
    DIOTA = 396,
    DOGONEK = 397,
    DCARON = 398,
    NETWORK = 399,
    PKTDRIVER = 400,
    DIRECTORY = 401,
    NAMESTUB = 402,
    BINARY = 403,
    BASE = 404,
    IRQ = 405,
    INTERRUPT = 406,
    DEVICE = 407,
    CHARSET = 408,
    BAUDRATE = 409,
    VIRTUAL = 410,
    MICROSOFT = 411,
    MS3BUTTON = 412,
    LOGITECH = 413,
    MMSERIES = 414,
    MOUSEMAN = 415,
    HITACHI = 416,
    MOUSESYSTEMS = 417,
    BUSMOUSE = 418,
    PS2 = 419,
    IMPS2 = 420,
    INTERNALDRIVER = 421,
    EMULATE3BUTTONS = 422,
    CLEARDTR = 423,
    L_DISPLAY = 424,
    L_TITLE = 425,
    X_TITLE_SHOW_APPNAME = 426,
    ICON_NAME = 427,
    X_KEYCODE = 428,
    X_BLINKRATE = 429,
    X_SHARECMAP = 430,
    X_MITSHM = 431,
    X_FONT = 432,
    X_FIXED_ASPECT = 433,
    X_ASPECT_43 = 434,
    X_LIN_FILT = 435,
    X_BILIN_FILT = 436,
    X_MODE13FACT = 437,
    X_WINSIZE = 438,
    X_GAMMA = 439,
    X_FULLSCREEN = 440,
    VGAEMU_MEMSIZE = 441,
    VESAMODE = 442,
    X_LFB = 443,
    X_PM_INTERFACE = 444,
    X_MGRAB_KEY = 445,
    X_BACKGROUND_PAUSE = 446,
    VGA = 447,
    MGA = 448,
    CGA = 449,
    EGA = 450,
    NONE = 451,
    CONSOLE = 452,
    GRAPHICS = 453,
    CHIPSET = 454,
    FULLREST = 455,
    PARTREST = 456,
    MEMSIZE = 457,
    VBIOS_SIZE_TOK = 458,
    VBIOS_SEG = 459,
    VGAEMUBIOS_FILE = 460,
    VBIOS_FILE = 461,
    VBIOS_COPY = 462,
    VBIOS_MMAP = 463,
    DUALMON = 464,
    VBIOS_POST = 465,
    FORCE_VT_SWITCH = 466,
    PCI = 467,
    UPDATEFREQ = 468,
    UPDATELINES = 469,
    COLOR = 470,
    ESCCHAR = 471,
    XTERM_TITLE = 472,
    IO = 473,
    PORT = 474,
    CONFIG = 475,
    READ = 476,
    WRITE = 477,
    KEYB = 478,
    PRINTER = 479,
    WARNING = 480,
    GENERAL = 481,
    HARDWARE = 482,
    L_IPC = 483,
    SOUND = 484,
    TRACE = 485,
    CLEAR = 486,
    LPT = 487,
    COMMAND = 488,
    TIMEOUT = 489,
    L_FILE = 490,
    L_PARTITION = 491,
    BOOTFILE = 492,
    WHOLEDISK = 493,
    THREEINCH = 494,
    THREEINCH_720 = 495,
    THREEINCH_2880 = 496,
    FIVEINCH = 497,
    ATAPI = 498,
    READONLY = 499,
    LAYOUT = 500,
    SECTORS = 501,
    CYLINDERS = 502,
    TRACKS = 503,
    HEADS = 504,
    OFFSET = 505,
    HDIMAGE = 506,
    DISKCYL4096 = 507,
    RDONLY = 508,
    WRONLY = 509,
    RDWR = 510,
    ORMASK = 511,
    ANDMASK = 512,
    RANGE = 513,
    FAST = 514,
    SLOW = 515,
    SILLYINT = 516,
    USE_SIGIO = 517,
    HARDWARE_RAM = 518,
    SB_BASE = 519,
    SB_IRQ = 520,
    SB_DMA = 521,
    SB_HDMA = 522,
    SB_MIXER = 523,
    SB_DSP = 524,
    MPU_BASE = 525,
    SOUND_DRIVER = 526,
    OSS_MIN_FRAGS = 527,
    OSS_MAX_FRAGS = 528,
    OSS_STALLED_FRAGS = 529,
    OSS_DO_POST = 530,
    OSS_MIN_EXTRA_FRAGS = 531,
    OSS_DAC_FREQ = 532,
    CDROM = 533,
    ASPI = 534,
    DEVICETYPE = 535,
    TARGET = 536,
    FEATURE = 537,
    JOYSTICK = 538,
    JOY_DEVICE = 539,
    JOY_DOS_MIN = 540,
    JOY_DOS_MAX = 541,
    JOY_GRANULARITY = 542,
    JOY_LATENCY = 543,
    CLI_TIMEOUT = 544,
    PIC_WATCHDOG = 545,
    TIMEMODE = 546,
    INTERNAL = 547,
    EXTERNAL = 548,
    UNICODE = 549,
    SHIFT_ALT_MAP = 550,
    CTRL_MAP = 551,
    CTRL_ALT_MAP = 552
  };
#endif
/* Tokens.  */
#define INTEGER 258
#define L_OFF 259
#define L_ON 260
#define L_AUTO 261
#define L_YES 262
#define L_NO 263
#define CHIPSET_TYPE 264
#define KEYB_LAYOUT 265
#define REAL 266
#define STRING 267
#define VARIABLE 268
#define EXPRTEST 269
#define INTCAST 270
#define REALCAST 271
#define AND_OP 272
#define OR_OP 273
#define XOR_OP 274
#define SHR_OP 275
#define SHL_OP 276
#define NOT_OP 277
#define EQ_OP 278
#define GE_OP 279
#define LE_OP 280
#define NEQ_OP 281
#define STR_EQ_OP 282
#define STR_NEQ_OP 283
#define L_AND_OP 284
#define L_OR_OP 285
#define UMINUS 286
#define UPLUS 287
#define BIT_NOT_OP 288
#define STRLEN 289
#define STRTOL 290
#define STRNCMP 291
#define STRCAT 292
#define STRPBRK 293
#define STRSPLIT 294
#define STRCHR 295
#define STRRCHR 296
#define STRSTR 297
#define STRDEL 298
#define STRSPN 299
#define STRCSPN 300
#define SHELL 301
#define DEFINED 302
#define DEFINE 303
#define UNDEF 304
#define IFSTATEMENT 305
#define WHILESTATEMENT 306
#define FOREACHSTATEMENT 307
#define ENTER_USER_SPACE 308
#define LEAVE_USER_SPACE 309
#define CHECKUSERVAR 310
#define DOSBANNER 311
#define FASTFLOPPY 312
#define HOGTHRESH 313
#define SPEAKER 314
#define IPXSUPPORT 315
#define IPXNETWORK 316
#define NOVELLHACK 317
#define NETDEV 318
#define VNET 319
#define DEBUG 320
#define MOUSE 321
#define SERIAL 322
#define COM 323
#define KEYBOARD 324
#define TERMINAL 325
#define VIDEO 326
#define EMURETRACE 327
#define TIMER 328
#define MATHCO 329
#define CPU 330
#define CPUSPEED 331
#define RDTSC 332
#define BOOTA 333
#define BOOTB 334
#define BOOTC 335
#define L_XMS 336
#define L_DPMI 337
#define DPMI_BASE 338
#define PM_DOS_API 339
#define NO_NULL_CHECKS 340
#define PORTS 341
#define DISK 342
#define DOSMEM 343
#define EXT_MEM 344
#define L_EMS 345
#define L_UMB 346
#define EMS_SIZE 347
#define EMS_FRAME 348
#define EMS_UMA_PAGES 349
#define EMS_CONV_PAGES 350
#define TTYLOCKS 351
#define L_SOUND 352
#define L_SND_OSS 353
#define L_JOYSTICK 354
#define FULL_FILE_LOCKS 355
#define DEXE 356
#define ALLOWDISK 357
#define FORCEXDOS 358
#define XDOSONLY 359
#define ABORT 360
#define WARN 361
#define BOOTDISK 362
#define L_FLOPPY 363
#define EMUSYS 364
#define EMUINI 365
#define L_X 366
#define DOSEMUMAP 367
#define LOGBUFSIZE 368
#define LOGFILESIZE 369
#define MAPPINGDRIVER 370
#define LFN_SUPPORT 371
#define EMULATED 372
#define NATIVE 373
#define CPUEMU 374
#define VM86 375
#define FULL 376
#define VM86SIM 377
#define FULLSIM 378
#define RAWKEYBOARD 379
#define PRESTROKE 380
#define KEYTABLE 381
#define SHIFT_MAP 382
#define ALT_MAP 383
#define NUMPAD_MAP 384
#define DUMP 385
#define DGRAVE 386
#define DACUTE 387
#define DCIRCUM 388
#define DTILDE 389
#define DBREVE 390
#define DABOVED 391
#define DDIARES 392
#define DABOVER 393
#define DDACUTE 394
#define DCEDILLA 395
#define DIOTA 396
#define DOGONEK 397
#define DCARON 398
#define NETWORK 399
#define PKTDRIVER 400
#define DIRECTORY 401
#define NAMESTUB 402
#define BINARY 403
#define BASE 404
#define IRQ 405
#define INTERRUPT 406
#define DEVICE 407
#define CHARSET 408
#define BAUDRATE 409
#define VIRTUAL 410
#define MICROSOFT 411
#define MS3BUTTON 412
#define LOGITECH 413
#define MMSERIES 414
#define MOUSEMAN 415
#define HITACHI 416
#define MOUSESYSTEMS 417
#define BUSMOUSE 418
#define PS2 419
#define IMPS2 420
#define INTERNALDRIVER 421
#define EMULATE3BUTTONS 422
#define CLEARDTR 423
#define L_DISPLAY 424
#define L_TITLE 425
#define X_TITLE_SHOW_APPNAME 426
#define ICON_NAME 427
#define X_KEYCODE 428
#define X_BLINKRATE 429
#define X_SHARECMAP 430
#define X_MITSHM 431
#define X_FONT 432
#define X_FIXED_ASPECT 433
#define X_ASPECT_43 434
#define X_LIN_FILT 435
#define X_BILIN_FILT 436
#define X_MODE13FACT 437
#define X_WINSIZE 438
#define X_GAMMA 439
#define X_FULLSCREEN 440
#define VGAEMU_MEMSIZE 441
#define VESAMODE 442
#define X_LFB 443
#define X_PM_INTERFACE 444
#define X_MGRAB_KEY 445
#define X_BACKGROUND_PAUSE 446
#define VGA 447
#define MGA 448
#define CGA 449
#define EGA 450
#define NONE 451
#define CONSOLE 452
#define GRAPHICS 453
#define CHIPSET 454
#define FULLREST 455
#define PARTREST 456
#define MEMSIZE 457
#define VBIOS_SIZE_TOK 458
#define VBIOS_SEG 459
#define VGAEMUBIOS_FILE 460
#define VBIOS_FILE 461
#define VBIOS_COPY 462
#define VBIOS_MMAP 463
#define DUALMON 464
#define VBIOS_POST 465
#define FORCE_VT_SWITCH 466
#define PCI 467
#define UPDATEFREQ 468
#define UPDATELINES 469
#define COLOR 470
#define ESCCHAR 471
#define XTERM_TITLE 472
#define IO 473
#define PORT 474
#define CONFIG 475
#define READ 476
#define WRITE 477
#define KEYB 478
#define PRINTER 479
#define WARNING 480
#define GENERAL 481
#define HARDWARE 482
#define L_IPC 483
#define SOUND 484
#define TRACE 485
#define CLEAR 486
#define LPT 487
#define COMMAND 488
#define TIMEOUT 489
#define L_FILE 490
#define L_PARTITION 491
#define BOOTFILE 492
#define WHOLEDISK 493
#define THREEINCH 494
#define THREEINCH_720 495
#define THREEINCH_2880 496
#define FIVEINCH 497
#define ATAPI 498
#define READONLY 499
#define LAYOUT 500
#define SECTORS 501
#define CYLINDERS 502
#define TRACKS 503
#define HEADS 504
#define OFFSET 505
#define HDIMAGE 506
#define DISKCYL4096 507
#define RDONLY 508
#define WRONLY 509
#define RDWR 510
#define ORMASK 511
#define ANDMASK 512
#define RANGE 513
#define FAST 514
#define SLOW 515
#define SILLYINT 516
#define USE_SIGIO 517
#define HARDWARE_RAM 518
#define SB_BASE 519
#define SB_IRQ 520
#define SB_DMA 521
#define SB_HDMA 522
#define SB_MIXER 523
#define SB_DSP 524
#define MPU_BASE 525
#define SOUND_DRIVER 526
#define OSS_MIN_FRAGS 527
#define OSS_MAX_FRAGS 528
#define OSS_STALLED_FRAGS 529
#define OSS_DO_POST 530
#define OSS_MIN_EXTRA_FRAGS 531
#define OSS_DAC_FREQ 532
#define CDROM 533
#define ASPI 534
#define DEVICETYPE 535
#define TARGET 536
#define FEATURE 537
#define JOYSTICK 538
#define JOY_DEVICE 539
#define JOY_DOS_MIN 540
#define JOY_DOS_MAX 541
#define JOY_GRANULARITY 542
#define JOY_LATENCY 543
#define CLI_TIMEOUT 544
#define PIC_WATCHDOG 545
#define TIMEMODE 546
#define INTERNAL 547
#define EXTERNAL 548
#define UNICODE 549
#define SHIFT_ALT_MAP 550
#define CTRL_MAP 551
#define CTRL_ALT_MAP 552

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 212 "parser.y" /* yacc.c:355  */

	int i_value;
	char *s_value;
	float r_value;
	struct {
		enum {
			TYPE_NONE,
			TYPE_INTEGER,
			TYPE_BOOLEAN,
			TYPE_REAL
		} type;
		union {
			int i;
			float r;
		} value;
	} t_value;

#line 890 "parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (void);

#endif /* !YY_YY_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */
#line 230 "parser.y" /* yacc.c:358  */

#include "lexer.h"

#line 909 "parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  232
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3049

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  311
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  89
/* YYNRULES -- Number of rules.  */
#define YYNRULES  490
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  928

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   552

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     308,   309,    36,    34,   310,    35,     2,    37,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   305,
      27,    26,    28,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   306,     2,   307,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    29,    30,    31,    32,    33,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   360,   360,   361,   362,   365,   366,   369,   371,   372,
     373,   374,   396,   399,   403,   408,   409,   410,   429,   430,
     440,   444,   445,   450,   455,   464,   469,   474,   479,   483,
     487,   492,   502,   511,   526,   536,   546,   552,   558,   562,
     566,   570,   581,   593,   597,   602,   609,   610,   615,   620,
     625,   630,   635,   640,   645,   646,   647,   648,   653,   654,
     662,   663,   664,   665,   680,   679,   683,   684,   687,   692,
     691,   695,   694,   698,   702,   701,   706,   705,   709,   708,
     712,   718,   723,   722,   725,   727,   726,   731,   730,   735,
     734,   738,   751,   765,   764,   768,   769,   770,   770,   771,
     772,   773,   775,   774,   777,   783,   785,   784,   790,   794,
     796,   798,   804,   806,   809,   812,   817,   818,   819,   820,
     822,   824,   826,   830,   832,   834,   838,   842,   854,   857,
     858,   860,   862,   864,   866,   867,   868,   872,   876,   880,
     886,   892,   898,   904,   908,   912,   920,   922,   924,   926,
     928,   930,   932,   934,   936,   938,   940,   941,   942,   943,
     944,   945,   951,   952,   956,   973,   983,   984,   985,   998,
    1010,  1014,  1017,  1018,  1027,  1028,  1037,  1041,  1049,  1050,
    1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1074,  1079,
    1080,  1081,  1082,  1083,  1084,  1085,  1087,  1088,  1089,  1090,
    1093,  1094,  1097,  1098,  1102,  1114,  1115,  1117,  1118,  1119,
    1120,  1121,  1122,  1123,  1124,  1126,  1127,  1129,  1130,  1131,
    1132,  1133,  1134,  1139,  1140,  1142,  1143,  1144,  1145,  1146,
    1151,  1152,  1154,  1155,  1156,  1157,  1158,  1159,  1164,  1165,
    1168,  1171,  1172,  1173,  1176,  1177,  1181,  1185,  1196,  1207,
    1208,  1209,  1210,  1211,  1214,  1219,  1220,  1222,  1223,  1224,
    1225,  1228,  1237,  1238,  1240,  1241,  1242,  1243,  1244,  1245,
    1246,  1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,  1264,  1266,
    1271,  1272,  1274,  1275,  1276,  1277,  1278,  1284,  1289,  1294,
    1300,  1305,  1310,  1315,  1320,  1325,  1330,  1335,  1337,  1342,
    1343,  1345,  1346,  1346,  1347,  1348,  1349,  1350,  1353,  1356,
    1357,  1360,  1360,  1361,  1361,  1362,  1362,  1363,  1363,  1364,
    1364,  1365,  1365,  1366,  1366,  1369,  1370,  1373,  1374,  1375,
    1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,  1384,  1385,
    1386,  1387,  1388,  1389,  1398,  1399,  1401,  1402,  1403,  1404,
    1406,  1411,  1412,  1414,  1416,  1428,  1430,  1431,  1432,  1433,
    1434,  1436,  1441,  1442,  1444,  1445,  1446,  1447,  1448,  1449,
    1451,  1456,  1462,  1465,  1466,  1468,  1469,  1470,  1471,  1472,
    1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,  1486,  1492,
    1500,  1507,  1514,  1521,  1523,  1530,  1532,  1537,  1538,  1540,
    1547,  1553,  1563,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1584,  1587,  1588,  1590,  1592,  1594,  1596,  1598,
    1599,  1602,  1607,  1608,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1620,  1625,  1626,  1628,  1633,  1638,  1643,  1657,
    1661,  1665,  1668,  1673,  1674,  1676,  1682,  1688,  1695,  1702,
    1705,  1710,  1713,  1716,  1724,  1733,  1734,  1735,  1736,  1738,
    1743,  1744,  1745,  1746,  1747,  1748,  1750,  1753,  1754,  1757,
    1758
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INTEGER", "L_OFF", "L_ON", "L_AUTO",
  "L_YES", "L_NO", "CHIPSET_TYPE", "KEYB_LAYOUT", "REAL", "STRING",
  "VARIABLE", "EXPRTEST", "INTCAST", "REALCAST", "AND_OP", "OR_OP",
  "XOR_OP", "SHR_OP", "SHL_OP", "NOT_OP", "EQ_OP", "GE_OP", "LE_OP", "'='",
  "'<'", "'>'", "NEQ_OP", "STR_EQ_OP", "STR_NEQ_OP", "L_AND_OP", "L_OR_OP",
  "'+'", "'-'", "'*'", "'/'", "UMINUS", "UPLUS", "BIT_NOT_OP", "STRLEN",
  "STRTOL", "STRNCMP", "STRCAT", "STRPBRK", "STRSPLIT", "STRCHR",
  "STRRCHR", "STRSTR", "STRDEL", "STRSPN", "STRCSPN", "SHELL", "DEFINED",
  "DEFINE", "UNDEF", "IFSTATEMENT", "WHILESTATEMENT", "FOREACHSTATEMENT",
  "ENTER_USER_SPACE", "LEAVE_USER_SPACE", "CHECKUSERVAR", "DOSBANNER",
  "FASTFLOPPY", "HOGTHRESH", "SPEAKER", "IPXSUPPORT", "IPXNETWORK",
  "NOVELLHACK", "NETDEV", "VNET", "DEBUG", "MOUSE", "SERIAL", "COM",
  "KEYBOARD", "TERMINAL", "VIDEO", "EMURETRACE", "TIMER", "MATHCO", "CPU",
  "CPUSPEED", "RDTSC", "BOOTA", "BOOTB", "BOOTC", "L_XMS", "L_DPMI",
  "DPMI_BASE", "PM_DOS_API", "NO_NULL_CHECKS", "PORTS", "DISK", "DOSMEM",
  "EXT_MEM", "L_EMS", "L_UMB", "EMS_SIZE", "EMS_FRAME", "EMS_UMA_PAGES",
  "EMS_CONV_PAGES", "TTYLOCKS", "L_SOUND", "L_SND_OSS", "L_JOYSTICK",
  "FULL_FILE_LOCKS", "DEXE", "ALLOWDISK", "FORCEXDOS", "XDOSONLY", "ABORT",
  "WARN", "BOOTDISK", "L_FLOPPY", "EMUSYS", "EMUINI", "L_X", "DOSEMUMAP",
  "LOGBUFSIZE", "LOGFILESIZE", "MAPPINGDRIVER", "LFN_SUPPORT", "EMULATED",
  "NATIVE", "CPUEMU", "VM86", "FULL", "VM86SIM", "FULLSIM", "RAWKEYBOARD",
  "PRESTROKE", "KEYTABLE", "SHIFT_MAP", "ALT_MAP", "NUMPAD_MAP", "DUMP",
  "DGRAVE", "DACUTE", "DCIRCUM", "DTILDE", "DBREVE", "DABOVED", "DDIARES",
  "DABOVER", "DDACUTE", "DCEDILLA", "DIOTA", "DOGONEK", "DCARON",
  "NETWORK", "PKTDRIVER", "DIRECTORY", "NAMESTUB", "BINARY", "BASE", "IRQ",
  "INTERRUPT", "DEVICE", "CHARSET", "BAUDRATE", "VIRTUAL", "MICROSOFT",
  "MS3BUTTON", "LOGITECH", "MMSERIES", "MOUSEMAN", "HITACHI",
  "MOUSESYSTEMS", "BUSMOUSE", "PS2", "IMPS2", "INTERNALDRIVER",
  "EMULATE3BUTTONS", "CLEARDTR", "L_DISPLAY", "L_TITLE",
  "X_TITLE_SHOW_APPNAME", "ICON_NAME", "X_KEYCODE", "X_BLINKRATE",
  "X_SHARECMAP", "X_MITSHM", "X_FONT", "X_FIXED_ASPECT", "X_ASPECT_43",
  "X_LIN_FILT", "X_BILIN_FILT", "X_MODE13FACT", "X_WINSIZE", "X_GAMMA",
  "X_FULLSCREEN", "VGAEMU_MEMSIZE", "VESAMODE", "X_LFB", "X_PM_INTERFACE",
  "X_MGRAB_KEY", "X_BACKGROUND_PAUSE", "VGA", "MGA", "CGA", "EGA", "NONE",
  "CONSOLE", "GRAPHICS", "CHIPSET", "FULLREST", "PARTREST", "MEMSIZE",
  "VBIOS_SIZE_TOK", "VBIOS_SEG", "VGAEMUBIOS_FILE", "VBIOS_FILE",
  "VBIOS_COPY", "VBIOS_MMAP", "DUALMON", "VBIOS_POST", "FORCE_VT_SWITCH",
  "PCI", "UPDATEFREQ", "UPDATELINES", "COLOR", "ESCCHAR", "XTERM_TITLE",
  "IO", "PORT", "CONFIG", "READ", "WRITE", "KEYB", "PRINTER", "WARNING",
  "GENERAL", "HARDWARE", "L_IPC", "SOUND", "TRACE", "CLEAR", "LPT",
  "COMMAND", "TIMEOUT", "L_FILE", "L_PARTITION", "BOOTFILE", "WHOLEDISK",
  "THREEINCH", "THREEINCH_720", "THREEINCH_2880", "FIVEINCH", "ATAPI",
  "READONLY", "LAYOUT", "SECTORS", "CYLINDERS", "TRACKS", "HEADS",
  "OFFSET", "HDIMAGE", "DISKCYL4096", "RDONLY", "WRONLY", "RDWR", "ORMASK",
  "ANDMASK", "RANGE", "FAST", "SLOW", "SILLYINT", "USE_SIGIO",
  "HARDWARE_RAM", "SB_BASE", "SB_IRQ", "SB_DMA", "SB_HDMA", "SB_MIXER",
  "SB_DSP", "MPU_BASE", "SOUND_DRIVER", "OSS_MIN_FRAGS", "OSS_MAX_FRAGS",
  "OSS_STALLED_FRAGS", "OSS_DO_POST", "OSS_MIN_EXTRA_FRAGS",
  "OSS_DAC_FREQ", "CDROM", "ASPI", "DEVICETYPE", "TARGET", "FEATURE",
  "JOYSTICK", "JOY_DEVICE", "JOY_DOS_MIN", "JOY_DOS_MAX",
  "JOY_GRANULARITY", "JOY_LATENCY", "CLI_TIMEOUT", "PIC_WATCHDOG",
  "TIMEMODE", "INTERNAL", "EXTERNAL", "UNICODE", "SHIFT_ALT_MAP",
  "CTRL_MAP", "CTRL_ALT_MAP", "';'", "'{'", "'}'", "'('", "')'", "','",
  "$accept", "lines", "optdelim", "line", "$@1", "$@2", "$@3", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "expression", "real_expression", "typed_expr", "int_expr",
  "bool_expr", "real_expr", "variable_content", "string_unquoted",
  "string_expr", "strarglist", "strarglist_item", "check_user_var_list",
  "x_flags", "x_flag", "dexeflags", "dexeflag", "sound_flags",
  "sound_flag", "snd_oss_flags", "snd_oss_flag", "joystick_flags",
  "joystick_flag", "video_flags", "video_flag", "term_flags", "term_flag",
  "debug_flags", "debug_flag", "mouse_flags", "mouse_flag",
  "keyboard_flags", "keyboard_flag", "$@15", "keyboard_mods",
  "keyboard_mod", "$@16", "$@17", "$@18", "$@19", "$@20", "$@21", "$@22",
  "keyboard_modvals", "keyboard_modval", "ttylocks_flags", "ttylocks_flag",
  "serial_flags", "serial_flag", "printer_flags", "printer_flag",
  "optbootfile", "disk_flags", "disk_flag", "port_flags", "port_flag",
  "trace_port_flags", "trace_port_flag", "sillyint_flags", "sillyint_flag",
  "ems_flags", "ems_flag", "hardware_ram_flags", "hardware_ram_flag",
  "bool", "floppy_bool", "int_bool", "irq_bool", "speaker", "cpuemu",
  "charset_flags", "charset_flag", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    61,    60,    62,   281,
     282,   283,   284,   285,    43,    45,    42,    47,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,    59,   123,   125,    40,    41,
      44
};
# endif

#define YYPACT_NINF -762

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-762)))

#define YYTABLE_NINF -323

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2615,  -762,  -762,   -15,  1853,  -292,    17,    17,  -270,    49,
      63,  -762,  -762,    65,  1853,  1853,  1853,    96,  1853,  1853,
    1853,   499,   499,    93,  -762,  -762,  -762,  -225,  -762,  1853,
    1853,  1853,  1639,  1908,  1853,  -762,  -762,  -762,  1853,  1853,
    1853,  1853,  1853,  -762,  -762,  1853,  1853,  1696,  1853,  -219,
    1853,  -217,  1749,  1853,  -212,    93,    93,  -762,  -762,   104,
     399,  -197,   499,  1853,  1853,   499,  1853,   343,   499,    -2,
    1853,  -195,  1853,   499,  -762,    29,  1853,  -762,  -170,  -168,
    -159,  1853,  1853,   499,  1371,  -762,    93,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,    10,  -762,  -141,  -138,  1853,  1853,
    1853,  1853,  -136,  -131,  -130,  -129,  -128,  -119,  -117,  -114,
    -112,  -111,  -108,  -107,   -95,   -94,  1853,  1136,  -762,  -762,
    -762,    44,  -762,    72,    93,  -762,  -762,  -762,  1853,   -92,
     -91,  -762,   -88,  -762,  1136,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  1853,  -157,  -762,   -83,  -762,   -78,   -73,   -59,
      79,   -57,  -762,  -762,  -762,  -762,  -762,   228,  -762,  1136,
    -762,  -762,  -762,  -762,  -762,  -762,   -52,   -46,  -762,  -762,
      27,  -762,  -762,    98,   -41,  -762,   326,  -161,  -762,  -762,
      52,   -83,   -83,   -40,   -38,   499,  -762,   499,  -762,  2828,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,   499,  -762,  -276,  -762,  -762,
     -28,   -12,   -11,  -762,  -762,   -10,   499,   499,  1853,  -762,
    -762,  -762,  -762,  -762,  2364,  -762,   -83,  1853,  1853,   939,
    -762,  -762,  -762,   499,   499,   499,    93,   499,   499,   499,
     499,   499,   499,   499,   499,    93,    17,   405,  1853,  1853,
    1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,
    1853,  1853,  1853,  1853,  1853,   499,   499,  -196,   -54,   -27,
     285,   290,   992,  2713,    93,   874,   435,    76,  -762,  -762,
    1853,  1853,  1853,    41,  -762,  2350,  -762,     9,  2157,  -762,
    -762,  -762,  1853,  1853,  1853,  1853,  1853,    19,  -762,  -762,
    -762,   499,   499,  -762,    70,  -762,   496,  1853,  1853,  1853,
    1853,  1853,  1853,   195,  -762,   499,  1853,  1853,  1853,  1853,
      -7,  -762,  -762,  -762,  -762,   -25,  -762,  2157,  2157,     5,
      30,   499,   499,  1853,   499,  1853,  1853,  -762,  1853,   499,
    1853,  -762,  -762,  -762,  1853,  1965,  1853,  1853,  1853,  2027,
    1853,  1853,   499,  1853,  1853,  1853,  2739,  -762,    28,  -762,
     324,   327,  -263,  -762,   175,    45,    95,    46,    55,    69,
     333,  -762,  -762,  1369,  1599,    59,    66,    53,  -185,    57,
      74,    94,    99,   103,   110,   111,   125,  -169,    67,  -762,
     939,   939,   939,   939,   939,   581,   581,   581,   581,   581,
     581,   149,   149,   108,   108,  -762,  -762,  -762,  -762,  -762,
    -762,  1853,    97,  -762,  -762,  -762,  -762,  -762,  1853,  1853,
    1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,
    1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,
    1853,   711,  -762,  -762,  -762,  -762,   499,  1853,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,    71,  -762,  -762,  -762,  -762,  1853,  1853,  1853,  1853,
     499,  -762,   100,  -762,  -762,  -762,  1853,    54,    78,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,   364,  -762,  -762,  1853,  1853,  1853,
     499,   499,  -762,  -762,  -762,  -762,  -762,  -762,   529,  -762,
    -762,  -762,  -762,   499,  -762,  -762,  -762,  1853,  1853,  2079,
    -762,  -762,  1853,    58,  -762,  -762,  -762,   499,   499,   499,
     499,   499,   362,  -762,  -762,  -762,  -762,  -762,  -762,  1853,
    1853,  1853,  1853,  1853,   499,  -762,   445,  -762,  -762,  -762,
    -762,  -762,   142,  -762,  -762,  -762,  -762,  -762,  -762,  1853,
    1853,  1853,  1853,   499,   499,  1853,   499,   400,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,   877,   947,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
     376,   146,  -762,  -762,  -762,   403,   148,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  1529,  -762,  -762,  -762,  -762,
    -762,  -762,  1853,  1853,   499,  1853,   499,   141,  -762,  -762,
    -762,  -762,  -762,  2131,  1853,    42,  -762,  -762,  -762,  -762,
    2183,  1801,  1853,    92,  -762,  -762,  -762,  -762,  2235,  1853,
      64,  -762,  -762,   499,  1853,  -762,  -762,  -762,  -762,   499,
    -762,   499,  1853,   499,   499,   499,  1853,   499,   499,  -762,
    -762,   144,   499,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,   153,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,   447,   151,   158,  -762,
    -762,  -762,  -762,   218,  -762,     4,   218,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  1853,
     466,  1853,  1853,  1853,  1853,  1853,  1853,  1853,   454,  1218,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,   478,   172,
     177,  -762,  -762,   486,   181,  2296,  -762,   184,  -762,  -762,
     495,   189,   197,  -762,  -762,   114,   200,   194,   204,   199,
     208,   209,   214,   215,   217,   222,  -762,   223,   226,  -762,
    1853,  -762,   499,  -762,   218,  -762,  -762,  -762,  -762,   224,
     498,   509,   516,   518,   520,   521,  -762,  -762,  -762,  -762,
    1853,  -762,  -762,  1853,   545,   240,  -762,  -762,  1853,  -762,
    1853,  -762,  1853,  -762,  1853,  -762,  -762,  -762,  1853,  -762,
    -762,    93,  1529,  -762,  -762,  -762,  1853,  -762,  -762,  -762,
    -762,  -762,  -762,   839,  -762,  -762,  -762,  1853,  -762,   244,
     245,   246,   252,  -158,  1284,  -762,   839,   839,   839,   839,
     839,   839,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  1853,  -762,   243,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,   243,   243,
     243,   243,   243,   243,   256,   839,  -762,  -762
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,   113,   112,     0,     0,     0,     0,     0,     0,     0,
       0,    15,    16,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    69,    71,    74,    76,     0,    64,     0,
       0,     0,     0,     0,     0,    38,    40,    39,     0,     0,
       0,     0,     0,    82,    85,     0,     0,     0,     0,     0,
      97,     0,     0,     0,     0,     0,     0,    87,    89,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    93,     0,   102,   106,     0,     0,
       0,     0,     0,     0,     0,     2,     0,   129,   160,   159,
     134,   157,   158,   162,   145,   164,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    19,   116,   117,
     118,   127,   166,     0,     0,   165,     9,    10,     0,     0,
       0,   176,    18,   471,   114,    44,   472,    30,     8,   479,
     475,   478,   477,   476,    63,    57,   473,    58,    61,   171,
      60,    62,     0,     0,   174,    68,   172,     0,     0,     0,
       0,     0,    45,    41,    56,    32,    31,   129,    34,   115,
      36,    48,    50,    51,    52,    53,     0,     0,    54,    55,
       0,    47,    49,     0,     0,    96,     0,     0,   100,    28,
       0,    20,    21,     0,     0,     0,    22,     0,    26,     0,
      24,    42,    43,    25,    29,   486,   480,   485,   481,   482,
     483,   484,    33,    80,    78,     0,    59,     0,    37,    66,
       0,     0,     0,   474,   104,     0,     0,     0,     0,   109,
     110,   111,     1,     5,     0,     3,    17,     0,     0,   156,
     124,   123,   133,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   271,   270,
       0,     0,     0,     0,   265,     0,    35,     0,     0,   462,
     455,   461,     0,     0,     0,     0,     0,     0,   453,   370,
     369,     0,     0,   368,     0,   364,     0,     0,     0,     0,
       0,     0,     0,     0,   225,     0,     0,     0,     0,     0,
       0,   233,   212,   213,   214,     0,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   188,   189,     0,
       0,   193,   194,   195,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   178,     0,    81,
       0,     0,     0,   487,     0,     0,     0,     0,     0,     0,
       0,     6,     4,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   128,
     130,   131,   132,   125,   126,   146,   148,   149,   150,   151,
     147,   152,   153,   119,   120,   121,   122,   154,   155,    14,
      11,     0,     0,   177,   175,   299,   275,   298,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   272,   173,   318,   317,     0,     0,   307,   308,
     311,   310,   314,   315,   309,   316,   312,   313,   303,   304,
     306,     0,   300,   381,   380,   379,     0,     0,     0,     0,
       0,   374,     0,   371,   328,   327,     0,     0,     0,   319,
     268,   269,   267,    67,   266,   264,   263,   242,   243,   244,
     245,   246,   250,   249,     0,   251,   252,     0,     0,     0,
       0,     0,   255,   256,   260,   259,   261,   262,     0,   240,
     432,   419,   431,     0,   423,   424,   425,     0,     0,     0,
     428,   429,     0,     0,   417,   416,   415,     0,     0,     0,
       0,     0,     0,   396,   398,   397,   400,   399,   395,     0,
       0,     0,     0,     0,     0,   401,     0,   393,   457,   458,
     459,   460,     0,    46,   454,   366,   367,    73,   365,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   215,   227,
     228,   229,   230,   231,   232,    99,   226,   235,   236,   237,
     238,   239,   101,   234,   105,   211,     0,     0,    23,    27,
     182,   183,   184,   185,   186,   187,   190,   191,   192,   196,
     129,     0,   199,   200,   201,   129,     0,   206,   207,   208,
     209,   181,   180,    95,   179,     0,   489,   490,     7,   488,
     390,   389,     0,     0,     0,     0,     0,     0,   382,   441,
     435,   440,   439,     0,     0,     0,   433,   452,   444,   451,
       0,     0,     0,     0,   442,   470,   465,   469,     0,     0,
       0,   463,    91,     0,     0,   135,   163,   137,   136,     0,
     167,     0,     0,     0,     0,     0,     0,     0,     0,   170,
     161,     0,     0,   290,   276,   282,   274,   288,   289,   278,
     293,   295,   294,   284,   285,   277,   279,   280,   281,   283,
     286,   287,   291,   292,   296,   297,    70,   273,   302,   305,
      72,   301,   375,   376,   377,   378,   373,    75,   372,   326,
     325,   324,   321,    77,   320,   247,   248,   258,   257,   254,
     253,    65,   241,   430,   426,   427,   129,     0,     0,    83,
     418,   411,   414,   392,   408,   392,   392,   402,   403,   404,
     405,   406,   409,    86,   394,   456,   217,   220,   218,   219,
     221,   222,   223,   224,    98,   216,    88,    90,   197,     0,
     202,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     329,   388,   384,   385,   386,   387,    94,   383,   129,     0,
       0,    84,   434,   129,     0,     0,   446,     0,   103,   443,
     129,     0,     0,   107,   464,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    12,     0,     0,   421,
       0,   420,     0,   407,   392,   413,   410,   198,   203,   204,
       0,     0,     0,     0,     0,     0,   337,    79,   330,   437,
       0,   436,   447,     0,   129,     0,   445,   467,     0,   466,
       0,   108,     0,   139,     0,   140,   141,   142,     0,   143,
     144,     0,     0,   422,   391,   412,     0,   339,   341,   343,
     333,   331,   335,     0,   438,   448,   449,     0,   468,     0,
       0,     0,     0,     0,     0,   205,     0,     0,     0,     0,
       0,     0,   361,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   347,     0,   363,   338,
     345,   450,    92,   138,   168,   169,    13,   323,   340,   342,
     344,   334,   332,   336,     0,     0,   362,   346
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -762,  -762,  -762,   -75,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,   -13,  -762,
    2720,  -762,  -762,  -762,   143,    -6,   837,   -51,   282,  -762,
    -762,   201,  -762,   260,  -762,    23,  -762,   273,  -762,   271,
    -762,    84,  -762,   310,  -762,   160,  -762,   150,  -762,   136,
    -762,  -237,  -761,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
     -96,  -298,  -762,   314,  -762,   147,  -762,    -5,  -732,  -182,
    -541,  -762,   101,  -762,    -9,  -762,   -20,  -762,   328,  -762,
     -19,   140,  -762,   482,  -762,  -762,  -762,  -762,   268
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    84,   234,    85,   161,   153,   157,   158,   159,   368,
     176,   177,   193,   194,   220,   184,   222,   225,   133,   168,
     134,   118,   119,   120,   121,   122,   123,   155,   156,   132,
     366,   367,   335,   336,   577,   578,   323,   324,   330,   331,
     518,   519,   293,   294,   451,   452,   471,   472,   488,   489,
     818,   779,   780,   890,   889,   891,   873,   886,   887,   888,
     909,   910,   314,   315,   482,   483,   637,   638,   823,   556,
     557,   533,   534,   645,   646,   653,   654,   307,   308,   660,
     661,   135,   137,   147,   224,   144,   212,   372,   373
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     126,   127,   136,   138,   191,   192,   146,   824,   214,   235,
     520,    86,   521,   825,   826,   754,   124,   163,   838,   166,
     299,   522,   300,   370,   371,   146,   146,   146,   299,   125,
     300,   301,   146,   146,   146,   236,   370,   371,   128,   301,
    -165,  -165,   288,   639,   628,   640,   639,   655,   640,   656,
     201,   202,   129,   289,   641,   754,   754,   641,   657,   520,
     720,   521,   721,   223,   722,   655,   130,   656,   146,   146,
     522,   309,   454,   277,  -171,  -171,   657,   484,   131,   484,
     288,   160,   310,   455,   332,   333,   334,   183,   485,   186,
     485,   289,   865,   647,   190,   648,   647,   139,   648,   309,
     140,   473,   275,   276,   649,   125,    95,   649,   141,   199,
     310,   217,   474,   419,   284,   278,   125,    95,   302,   303,
     304,   305,   221,   838,   670,   284,   302,   303,   304,   305,
     325,   326,   327,   328,   329,   215,   226,   105,   227,   107,
     679,   284,   630,   111,   273,   274,   114,   228,   105,   283,
     107,   916,   284,   631,   111,   596,   597,   114,   145,   382,
     148,   332,   333,   334,   149,   149,   149,   237,   523,   162,
     238,   164,   243,   475,   170,   476,   630,   244,   245,   246,
     247,   174,   175,   271,   272,   273,   274,   631,   182,   248,
     185,   249,   188,   189,   250,   388,   251,   252,   149,   149,
     253,   254,   149,   149,   397,   149,   204,   486,   149,   486,
     216,   149,   218,   255,   256,   380,   149,   523,   279,   280,
     142,   143,   281,   311,   312,   313,   149,   284,   285,   149,
     456,   296,   457,   286,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   287,   822,   295,
     398,   311,   312,   313,   297,   420,   477,   478,   479,   480,
     298,   290,   481,   291,   292,   316,   337,   149,   338,   524,
     525,   526,   527,   528,   529,   530,   531,   490,   374,   492,
     642,   421,   594,   642,   325,   326,   327,   328,   329,   558,
     559,   560,   561,   562,   375,   376,   377,   632,   422,   290,
     592,   291,   292,   423,   579,   580,   581,   643,   583,   584,
     643,   658,   598,   588,   589,   590,   591,   532,   524,   525,
     526,   527,   528,   529,   530,   531,   563,   306,   487,   658,
     487,   632,   604,   605,   625,   306,   626,   599,   149,   627,
     149,   609,   611,   612,   205,   614,   616,   206,   493,   791,
     644,   621,   622,   644,   659,   207,   663,   650,   149,   664,
     650,   651,   662,   669,   651,   739,   532,   671,   667,   149,
     149,   803,   659,   725,   746,   668,   680,   567,   710,   768,
     633,   634,   635,   636,   672,   723,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   798,
     652,   152,   850,   652,   673,   682,   770,   717,   681,   674,
     195,   125,    95,   675,   633,   634,   635,   636,   149,   149,
     676,   677,   258,   259,   260,   261,   262,   149,   263,   264,
     265,   491,   266,   267,   268,   678,   473,   269,   270,   271,
     272,   273,   274,   105,   709,   107,   535,   474,   786,   111,
     819,   755,   114,   816,   149,   149,   769,   536,   771,  -322,
     582,   820,   822,   712,   713,   714,   715,   821,   149,   828,
     208,   209,   210,   211,   317,   318,   319,   320,   321,   322,
     836,   839,   840,   602,   149,   149,   841,   149,   606,   842,
     608,   843,   149,   846,   726,   727,   728,   613,   847,   848,
     617,   618,   585,   620,   852,   149,   849,   851,   475,   854,
     476,   125,    95,   853,   734,   735,   737,   855,   856,   738,
     171,   172,   173,   857,   867,   858,   859,   178,   179,   181,
     495,   860,   862,   861,   866,   868,   747,   748,   749,   750,
     751,   496,   869,   105,   870,   107,   871,   872,   876,   111,
     877,   912,   114,   925,   913,   914,   756,   757,   758,   759,
     537,   915,   762,   229,   230,   926,   453,   624,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   477,   478,   479,   480,   595,   586,   481,   538,   149,
     765,   593,   732,   494,   539,   317,   318,   319,   320,   321,
     322,   707,   778,   269,   270,   271,   272,   273,   274,   781,
     782,   711,   784,   149,   724,   884,   719,   927,   568,   718,
     789,   790,   787,   799,   740,   564,   792,   794,   796,   797,
     629,   804,     0,     0,     0,   801,   802,     0,     0,     0,
       0,   806,     0,   149,   149,     0,     0,     0,     0,   809,
       0,     0,     0,   813,     0,     0,   149,     0,     0,     0,
       0,   569,   570,   571,   572,   573,   574,   575,   576,     0,
     149,   149,   149,   149,   149,     0,     0,   540,   541,     0,
     542,   543,   544,   545,   546,   547,   548,   149,   549,   550,
     551,   552,   553,   554,   555,   197,     0,   764,     0,     0,
       0,     0,   425,     0,   399,   426,   149,   149,     0,   149,
       0,     0,     0,   427,     0,     0,     0,     0,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,     0,
       0,     0,   753,     0,     0,     0,   827,     0,   829,   830,
     831,   832,   833,   834,   835,     0,   778,   569,   570,   571,
     572,   573,   574,   575,   576,     0,     0,   149,     0,   149,
       0,     0,   845,     0,   428,   429,     0,   430,     0,   431,
     918,   919,   920,   921,   922,   923,     0,     0,     0,   432,
     433,     0,     0,     0,     0,   434,   149,   863,   435,     0,
     883,     0,   149,     0,   149,     0,   149,   149,   149,     0,
     149,   149,     0,     0,     0,   149,     0,   874,     0,   436,
     875,     0,     0,     0,     0,   878,   731,   879,     0,   880,
       0,   881,   892,     0,     0,   882,     0,     0,     0,   778,
       0,   125,     0,   885,     0,     0,     0,     0,   150,   151,
     154,     0,   437,     0,   911,     0,     0,   908,     0,     0,
       0,   778,     0,     0,     0,   454,     0,     0,   535,     0,
     908,   908,   908,   908,   908,   908,   455,     0,     0,   536,
       0,     0,   154,   154,   924,     0,   196,   198,     0,   200,
       0,     0,   203,     0,     0,   213,     0,     0,     0,     0,
     219,     0,     0,     0,     0,     0,     0,     0,     0,   908,
     231,     0,     0,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   535,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   536,
       0,   154,   263,   264,   265,   149,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,   274,   893,   894,   895,
     896,   897,   898,   899,   900,   901,   902,   903,   904,   905,
       0,     0,   537,     0,     0,     0,     0,     0,     0,     0,
       0,   450,     0,     0,   149,     0,     0,     0,     0,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   706,   266,
     267,   268,     0,     0,   269,   270,   271,   272,   273,   274,
     538,     0,   339,   456,   340,   457,   539,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   369,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   537,   378,   379,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     385,   386,   387,   154,   389,   390,   391,   392,   393,   394,
     395,   396,   154,     0,     0,     0,     0,     0,     0,     0,
     538,     0,     0,     0,     0,     0,   539,     0,     0,     0,
       0,     0,   417,   418,     0,     0,     0,     0,     0,   540,
     541,   154,   542,   543,   544,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,     0,     0,     0,
     906,     0,     0,     0,     0,     0,     0,   907,   565,   566,
       0,     0,     0,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   587,   266,   267,   268,     0,     0,   269,   270,
     271,   272,   273,   274,     0,     0,     0,     0,   600,   601,
       0,   603,     0,     0,   766,     0,   607,     0,     0,   540,
     541,     0,   542,   543,   544,   545,   546,   547,   548,   619,
     549,   550,   551,   552,   553,   554,   555,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    87,    88,    89,    90,    91,    92,     0,     0,    93,
      94,    95,     0,    96,    97,     0,     0,     0,     0,     0,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    99,   100,   767,     0,     0,     0,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    87,    88,    89,
      90,    91,    92,   708,     0,    93,    94,    95,     0,    96,
      97,   424,     0,     0,     0,     0,    98,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   716,    99,   100,
       0,     0,     0,     0,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     0,
       0,     0,     0,     0,     0,     0,     0,   729,   730,     0,
       0,     0,   772,   773,   774,     0,     0,     0,     0,     0,
     733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   232,     1,     0,   741,   742,   743,   744,   745,     0,
       0,     0,     0,     2,     3,     4,   258,   259,   260,   261,
     262,   752,   263,   264,   265,     0,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,   274,     0,     0,     0,
     760,   761,     0,   763,     0,     0,     0,     0,   772,   773,
     774,     0,     0,     0,     5,     0,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,     0,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
       0,   783,     0,   785,    49,    50,    51,    52,    53,    54,
       0,     0,     0,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,     0,     0,    67,     0,     0,
     805,     0,     0,    68,    69,     0,   807,     0,   808,     0,
     810,   811,   812,     0,   814,   815,     0,     0,     0,   817,
     775,   776,   777,    70,     0,   837,   116,     0,     0,     0,
       0,    71,    87,    88,    89,    90,    91,    92,     0,     0,
      93,    94,    95,     0,    96,    97,     0,     0,     0,     0,
       0,    98,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    99,   100,     0,     0,     0,     0,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,     0,     0,   775,   776,   777,     0,
      72,   917,   116,     0,     0,    73,     0,     0,     0,     0,
       0,     0,    74,     0,     0,     0,     0,     0,    75,     0,
       0,     0,     0,     0,     0,     0,   258,   259,   260,   261,
     262,     0,   263,   264,   265,     0,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,   274,     0,     0,    76,
       0,    77,    87,    88,    89,    90,    91,    92,     0,     0,
      93,    94,    95,     0,    96,    97,    78,    79,     0,   864,
      80,    98,     0,   772,   773,   774,     0,    81,    82,    83,
       0,     0,     0,    99,   100,     0,   233,     0,   665,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,     0,     0,     0,     0,   154,    87,
      88,    89,    90,    91,    92,     0,     0,    93,    94,    95,
       0,    96,    97,     0,     0,     0,     0,     0,    98,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      99,   100,     0,     0,     0,     0,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,     0,    87,    88,    89,    90,    91,    92,     0,     0,
      93,    94,    95,   165,    96,    97,     0,     0,     0,     0,
       0,    98,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    99,   100,     0,     0,     0,     0,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,    87,    88,    89,    90,    91,    92,
       0,     0,    93,    94,    95,     0,    96,    97,     0,     0,
       0,     0,     0,    98,     0,     0,     0,     0,     0,     0,
       0,   775,   776,   777,     0,    99,   100,   116,     0,     0,
       0,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,    87,    88,    89,    90,
      91,    92,     0,     0,    93,    94,    95,     0,    96,    97,
       0,     0,     0,     0,     0,    98,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    99,   100,     0,
       0,     0,     0,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   666,     0,
       0,   167,    88,    89,    90,    91,    92,     0,     0,    93,
      94,    95,     0,    96,    97,     0,     0,     0,     0,     0,
      98,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    99,   100,     0,     0,     0,   116,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,     0,     0,   610,    88,
      89,    90,    91,    92,     0,     0,    93,    94,    95,     0,
      96,    97,     0,     0,     0,     0,     0,    98,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    99,
     100,     0,   180,     0,   116,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     615,    88,    89,    90,    91,    92,     0,     0,    93,    94,
      95,     0,    96,    97,     0,     0,     0,     0,     0,    98,
       0,     0,     0,     0,     0,   187,     0,   116,     0,     0,
       0,    99,   100,     0,     0,     0,   795,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   736,    88,    89,    90,    91,    92,     0,     0,
      93,    94,    95,     0,    96,    97,     0,     0,     0,     0,
       0,    98,     0,     0,     0,     0,     0,     0,     0,   116,
       0,     0,     0,    99,   100,     0,     0,     0,     0,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   788,    88,    89,    90,    91,    92,
       0,     0,    93,    94,    95,     0,    96,    97,     0,     0,
       0,     0,     0,    98,     0,     0,     0,     0,   535,     0,
       0,   116,     0,     0,     0,    99,   100,     0,     0,   536,
       0,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   793,    88,    89,    90,
      91,    92,     0,     0,    93,    94,    95,     0,    96,    97,
       0,     0,     0,     0,     0,    98,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   116,    99,   100,     0,
       0,     0,     0,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   800,    88,
      89,    90,    91,    92,     0,     0,    93,    94,    95,     0,
      96,    97,     0,     0,     0,     0,     0,    98,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    99,
     100,     0,   537,   116,     0,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   844,
      88,    89,    90,    91,    92,     0,     0,    93,    94,    95,
     538,    96,    97,     0,     0,     0,   539,     0,    98,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      99,   100,     0,     0,     0,   116,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   496,     0,     0,     1,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,     3,     4,     0,
       0,     0,     0,     0,     0,     0,     0,   116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   540,
     541,     0,   542,   543,   544,   545,   546,   547,   548,     0,
     549,   550,   551,   552,   553,   554,   555,     5,     0,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,   116,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,     0,     0,     0,     0,    49,    50,    51,
      52,    53,    54,     0,     0,     0,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,     0,     0,
      67,   116,     0,     0,     0,     0,    68,    69,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    70,     0,     0,     0,
       0,     0,     0,     0,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   116,     0,     0,     0,     0,     0,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    72,     0,     0,     0,     0,    73,     0,
       0,     0,     0,     0,     0,    74,     0,     0,     0,     0,
       0,    75,     0,     0,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     2,     3,     4,
       0,     0,    76,     0,    77,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,     0,     0,    80,     0,     0,     0,     0,     0,     0,
      81,    82,    83,     0,     0,     0,     0,     0,     5,   381,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
       0,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   425,     0,     0,   426,    49,    50,
      51,    52,    53,    54,   117,   427,     0,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,     0,
       0,    67,     0,     0,     0,     0,     0,    68,    69,     0,
       0,     0,     0,   169,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    70,     0,     0,
       0,     0,     0,     0,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   432,   433,     0,     0,     0,     0,   434,     0,     0,
     435,     0,     0,     0,     0,     0,     0,     0,   239,   240,
     241,   242,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   436,     0,     0,    72,     0,   257,     0,     0,    73,
       0,     0,     0,     0,     0,     0,    74,     0,     0,     0,
       0,     0,    75,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   437,     0,     0,     0,     0,     0,
       0,     0,   282,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    76,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,    79,     0,     0,    80,     0,     0,     0,     0,     0,
       0,    81,    82,    83,     0,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,     0,     0,     0,   383,   384,   364,
     365,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,     0,     0,     0,     0,
       0,     0,     0,   450,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   623,     0,   364,   365
};

static const yytype_int16 yycheck[] =
{
       6,     7,    15,    16,    55,    56,    19,     3,    10,    84,
       1,    26,     3,   745,   746,   556,   308,    30,   779,    32,
       1,    12,     3,   299,   300,    38,    39,    40,     1,    12,
       3,    12,    45,    46,    47,    86,   299,   300,   308,    12,
      30,    31,     1,     1,   307,     3,     1,     1,     3,     3,
      63,    64,     3,    12,    12,   596,   597,    12,    12,     1,
       6,     3,     8,    76,    10,     1,     3,     3,    81,    82,
      12,     1,     1,   124,    30,    31,    12,     1,    13,     1,
       1,   306,    12,    12,   109,   110,   111,   306,    12,   306,
      12,    12,   824,     1,   306,     3,     1,     1,     3,     1,
       4,     1,    30,    31,    12,    12,    13,    12,    12,   306,
      12,   306,    12,   309,   310,   128,    12,    13,    99,   100,
     101,   102,    93,   884,   309,   310,    99,   100,   101,   102,
     291,   292,   293,   294,   295,   137,   306,    44,   306,    46,
     309,   310,     1,    50,    36,    37,    53,   306,    44,   306,
      46,   309,   310,    12,    50,   337,   338,    53,    18,   234,
      20,   109,   110,   111,    21,    22,    23,   308,   159,    29,
     308,    31,   308,    73,    34,    75,     1,   308,   308,   308,
     308,    41,    42,    34,    35,    36,    37,    12,    48,   308,
      50,   308,    52,    53,   308,   246,   308,   308,    55,    56,
     308,   308,    59,    60,   255,    62,    66,   131,    65,   131,
      70,    68,    72,   308,   308,   228,    73,   159,   310,   310,
     124,   125,   310,   153,   154,   155,    83,   310,   306,    86,
     159,     3,   161,   306,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   306,   244,   306,
     256,   153,   154,   155,   306,   309,   156,   157,   158,   159,
     306,   220,   162,   222,   223,   306,   306,   124,   306,   260,
     261,   262,   263,   264,   265,   266,   267,   290,   306,   292,
     238,   308,   307,   238,   291,   292,   293,   294,   295,   302,
     303,   304,   305,   306,   306,   306,   306,   156,    13,   220,
     307,   222,   223,    13,   317,   318,   319,   265,   321,   322,
     265,   265,   307,   326,   327,   328,   329,   308,   260,   261,
     262,   263,   264,   265,   266,   267,   307,   308,   252,   265,
     252,   156,   345,   346,   306,   308,    12,   307,   195,    12,
     197,   354,   355,   356,     1,   358,   359,     4,   307,   307,
     308,   364,   365,   308,   308,    12,   287,   265,   215,    26,
     265,   269,   307,   310,   269,   307,   308,   310,   309,   226,
     227,   307,   308,     9,    12,   309,   309,   307,   307,     3,
     239,   240,   241,   242,   310,   307,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   307,
     308,   308,   288,   308,   310,   308,     3,   307,   421,   310,
     306,    12,    13,   310,   239,   240,   241,   242,   275,   276,
     310,   310,    17,    18,    19,    20,    21,   284,    23,    24,
      25,   291,    27,    28,    29,   310,     1,    32,    33,    34,
      35,    36,    37,    44,   457,    46,     1,    12,   307,    50,
       3,   309,    53,   309,   311,   312,   310,    12,   310,   306,
     320,   310,   244,   476,   477,   478,   479,   309,   325,     3,
     127,   128,   129,   130,   279,   280,   281,   282,   283,   284,
      26,     3,   310,   343,   341,   342,   309,   344,   348,     3,
     350,   310,   349,   309,   507,   508,   509,   357,     3,   310,
     360,   361,   307,   363,   310,   362,   309,   307,    73,   310,
      75,    12,    13,   309,   527,   528,   529,   309,   309,   532,
      38,    39,    40,   309,    26,   310,   309,    45,    46,    47,
       1,   309,   306,   310,   310,    26,   549,   550,   551,   552,
     553,    12,    26,    44,    26,    46,    26,    26,     3,    50,
     310,   307,    53,   310,   309,   309,   569,   570,   571,   572,
     115,   309,   575,    81,    82,   309,   284,   366,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   156,   157,   158,   159,   335,   323,   162,   153,   456,
     577,   330,   518,   293,   159,   279,   280,   281,   282,   283,
     284,   451,   625,    32,    33,    34,    35,    36,    37,   632,
     633,   471,   635,   480,   488,   862,   486,   925,   314,   482,
     643,   644,   637,   653,   533,   307,   645,   650,   651,   652,
     372,   660,    -1,    -1,    -1,   658,   659,    -1,    -1,    -1,
      -1,   664,    -1,   510,   511,    -1,    -1,    -1,    -1,   672,
      -1,    -1,    -1,   676,    -1,    -1,   523,    -1,    -1,    -1,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     537,   538,   539,   540,   541,    -1,    -1,   242,   243,    -1,
     245,   246,   247,   248,   249,   250,   251,   554,   253,   254,
     255,   256,   257,   258,   259,   306,    -1,   307,    -1,    -1,
      -1,    -1,     1,    -1,   309,     4,   573,   574,    -1,   576,
      -1,    -1,    -1,    12,    -1,    -1,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
      -1,    -1,   307,    -1,    -1,    -1,   769,    -1,   771,   772,
     773,   774,   775,   776,   777,    -1,   779,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,    -1,   634,    -1,   636,
      -1,    -1,   795,    -1,    73,    74,    -1,    76,    -1,    78,
     886,   887,   888,   889,   890,   891,    -1,    -1,    -1,    88,
      89,    -1,    -1,    -1,    -1,    94,   663,   820,    97,    -1,
     861,    -1,   669,    -1,   671,    -1,   673,   674,   675,    -1,
     677,   678,    -1,    -1,    -1,   682,    -1,   840,    -1,   118,
     843,    -1,    -1,    -1,    -1,   848,   307,   850,    -1,   852,
      -1,   854,     3,    -1,    -1,   858,    -1,    -1,    -1,   862,
      -1,    12,    -1,   866,    -1,    -1,    -1,    -1,    21,    22,
      23,    -1,   151,    -1,   877,    -1,    -1,   873,    -1,    -1,
      -1,   884,    -1,    -1,    -1,     1,    -1,    -1,     1,    -1,
     886,   887,   888,   889,   890,   891,    12,    -1,    -1,    12,
      -1,    -1,    55,    56,   907,    -1,    59,    60,    -1,    62,
      -1,    -1,    65,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   925,
      83,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,     1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,
      -1,   124,    23,    24,    25,   822,    27,    28,    29,    -1,
      -1,    32,    33,    34,    35,    36,    37,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
      -1,    -1,   115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   290,    -1,    -1,   861,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,   307,    27,
      28,    29,    -1,    -1,    32,    33,    34,    35,    36,    37,
     153,    -1,   195,   159,   197,   161,   159,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
      -1,    -1,   215,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   115,   226,   227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     153,    -1,    -1,    -1,    -1,    -1,   159,    -1,    -1,    -1,
      -1,    -1,   275,   276,    -1,    -1,    -1,    -1,    -1,   242,
     243,   284,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,    -1,    -1,    -1,
     301,    -1,    -1,    -1,    -1,    -1,    -1,   308,   311,   312,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,   325,    27,    28,    29,    -1,    -1,    32,    33,
      34,    35,    36,    37,    -1,    -1,    -1,    -1,   341,   342,
      -1,   344,    -1,    -1,   307,    -1,   349,    -1,    -1,   242,
     243,    -1,   245,   246,   247,   248,   249,   250,   251,   362,
     253,   254,   255,   256,   257,   258,   259,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    34,    35,   307,    -1,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,   456,    -1,    11,    12,    13,    -1,    15,
      16,   309,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   480,    34,    35,
      -1,    -1,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,   511,    -1,
      -1,    -1,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,
     523,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     0,     1,    -1,   537,   538,   539,   540,   541,    -1,
      -1,    -1,    -1,    12,    13,    14,    17,    18,    19,    20,
      21,   554,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    32,    33,    34,    35,    36,    37,    -1,    -1,    -1,
     573,   574,    -1,   576,    -1,    -1,    -1,    -1,   134,   135,
     136,    -1,    -1,    -1,    53,    -1,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   634,    -1,   636,   103,   104,   105,   106,   107,   108,
      -1,    -1,    -1,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,    -1,   126,    -1,    -1,
     663,    -1,    -1,   132,   133,    -1,   669,    -1,   671,    -1,
     673,   674,   675,    -1,   677,   678,    -1,    -1,    -1,   682,
     302,   303,   304,   152,    -1,   307,   308,    -1,    -1,    -1,
      -1,   160,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    35,    -1,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,   302,   303,   304,    -1,
     219,   307,   308,    -1,    -1,   224,    -1,    -1,    -1,    -1,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    32,    33,    34,    35,    36,    37,    -1,    -1,   268,
      -1,   270,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    -1,    15,    16,   285,   286,    -1,   822,
     289,    22,    -1,   134,   135,   136,    -1,   296,   297,   298,
      -1,    -1,    -1,    34,    35,    -1,   305,    -1,   309,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,   861,     3,
       4,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    35,    -1,    -1,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    -1,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,   124,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    35,    -1,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   302,   303,   304,    -1,    34,    35,   308,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,   309,    -1,
      -1,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    34,    35,    -1,    -1,    -1,   308,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,    -1,    -1,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      35,    -1,   306,    -1,   308,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    -1,    -1,   306,    -1,   308,    -1,    -1,
      -1,    34,    35,    -1,    -1,    -1,   265,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,    -1,    34,    35,    -1,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,     1,    -1,
      -1,   308,    -1,    -1,    -1,    34,    35,    -1,    -1,    12,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    34,    35,    -1,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,     3,     4,
       5,     6,     7,     8,    -1,    -1,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      35,    -1,   115,   308,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
     153,    15,    16,    -1,    -1,    -1,   159,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    35,    -1,    -1,    -1,   308,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   242,
     243,    -1,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,   257,   258,   259,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,   308,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,    -1,    -1,    -1,   103,   104,   105,
     106,   107,   108,    -1,    -1,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,    -1,
     126,   308,    -1,    -1,    -1,    -1,   132,   133,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   219,    -1,    -1,    -1,    -1,   224,    -1,
      -1,    -1,    -1,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,   237,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,   268,    -1,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,    -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,
     296,   297,   298,    -1,    -1,    -1,    -1,    -1,    53,   305,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,     1,    -1,    -1,     4,   103,   104,
     105,   106,   107,   108,     4,    12,    -1,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    -1,
      -1,   126,    -1,    -1,    -1,    -1,    -1,   132,   133,    -1,
      -1,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   160,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    -1,    -1,    -1,    -1,    94,    -1,    -1,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   118,    -1,    -1,   219,    -1,   116,    -1,    -1,   224,
      -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   268,    -1,   270,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,    -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,
      -1,   296,   297,   298,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,   238,   220,
     221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   290,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,    -1,   220,   221
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    12,    13,    14,    53,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,   103,
     104,   105,   106,   107,   108,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   126,   132,   133,
     152,   160,   219,   224,   231,   237,   268,   270,   285,   286,
     289,   296,   297,   298,   312,   314,    26,     3,     4,     5,
       6,     7,     8,    11,    12,    13,    15,    16,    22,    34,
      35,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,   308,   331,   332,   333,
     334,   335,   336,   337,   308,    12,   336,   336,   308,     3,
       3,    13,   340,   329,   331,   392,   329,   393,   329,     1,
       4,    12,   124,   125,   396,   392,   329,   394,   392,   335,
     337,   337,   308,   316,   337,   338,   339,   317,   318,   319,
     306,   315,   392,   329,   392,   124,   329,     3,   330,   331,
     392,   394,   394,   394,   392,   392,   321,   322,   394,   394,
     306,   394,   392,   306,   326,   392,   306,   306,   392,   392,
     306,   338,   338,   323,   324,   306,   337,   306,   337,   306,
     337,   329,   329,   337,   392,     1,     4,    12,   127,   128,
     129,   130,   397,   337,    10,   137,   392,   306,   392,   337,
     325,    93,   327,   329,   395,   328,   306,   306,   306,   394,
     394,   337,     0,   305,   313,   314,   338,   308,   308,   331,
     331,   331,   331,   308,   308,   308,   308,   308,   308,   308,
     308,   308,   308,   308,   308,   308,   308,   331,    17,    18,
      19,    20,    21,    23,    24,    25,    27,    28,    29,    32,
      33,    34,    35,    36,    37,    30,    31,   338,   329,   310,
     310,   310,   331,   306,   310,   306,   306,   306,     1,    12,
     220,   222,   223,   353,   354,   306,     3,   306,   306,     1,
       3,    12,    99,   100,   101,   102,   308,   388,   389,     1,
      12,   153,   154,   155,   373,   374,   306,   279,   280,   281,
     282,   283,   284,   347,   348,   291,   292,   293,   294,   295,
     349,   350,   109,   110,   111,   343,   344,   306,   306,   337,
     337,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   220,   221,   341,   342,   320,   337,
     299,   300,   398,   399,   306,   306,   306,   306,   337,   337,
     329,   305,   314,   331,   331,   337,   337,   337,   338,   337,
     337,   337,   337,   337,   337,   337,   337,   338,   336,   309,
     331,   331,   331,   331,   331,   331,   331,   331,   331,   331,
     331,   331,   331,   331,   331,   331,   331,   337,   337,   309,
     309,   308,    13,    13,   309,     1,     4,    12,    73,    74,
      76,    78,    88,    89,    94,    97,   118,   151,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     290,   355,   356,   339,     1,    12,   159,   161,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   357,   358,     1,    12,    73,    75,   156,   157,   158,
     159,   162,   375,   376,     1,    12,   131,   252,   359,   360,
     329,   392,   329,   307,   354,     1,    12,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   351,   352,
       1,     3,    12,   159,   260,   261,   262,   263,   264,   265,
     266,   267,   308,   382,   383,     1,    12,   115,   153,   159,
     242,   243,   245,   246,   247,   248,   249,   250,   251,   253,
     254,   255,   256,   257,   258,   259,   380,   381,   329,   329,
     329,   329,   329,   307,   389,   337,   337,   307,   374,   271,
     272,   273,   274,   275,   276,   277,   278,   345,   346,   329,
     329,   329,   392,   329,   329,   307,   348,   337,   329,   329,
     329,   329,   307,   350,   307,   344,   380,   380,   307,   307,
     337,   337,   392,   337,   329,   329,   392,   337,   392,   329,
       3,   329,   329,   392,   329,     3,   329,   392,   392,   337,
     392,   329,   329,   307,   342,   306,    12,    12,   307,   399,
       1,    12,   156,   239,   240,   241,   242,   377,   378,     1,
       3,    12,   238,   265,   308,   384,   385,     1,     3,    12,
     265,   269,   308,   386,   387,     1,     3,    12,   265,   308,
     390,   391,   307,   287,    26,   309,   309,   309,   309,   310,
     309,   310,   310,   310,   310,   310,   310,   310,   310,   309,
     309,   329,   308,   392,   392,   392,   392,   392,   392,   392,
     392,   392,   392,   392,   392,   392,   392,   392,   392,   392,
     392,   392,   392,   392,   392,   392,   307,   356,   337,   329,
     307,   358,   329,   329,   329,   329,   337,   307,   376,   392,
       6,     8,    10,   307,   360,     9,   329,   329,   329,   337,
     337,   307,   352,   337,   329,   329,     3,   329,   329,   307,
     383,   337,   337,   337,   337,   337,    12,   329,   329,   329,
     329,   329,   337,   307,   381,   309,   329,   329,   329,   329,
     337,   337,   329,   337,   307,   346,   307,   307,     3,   310,
       3,   310,   134,   135,   136,   302,   303,   304,   329,   362,
     363,   329,   329,   337,   329,   337,   307,   378,     3,   329,
     329,   307,   385,     3,   329,   265,   329,   329,   307,   387,
       3,   329,   329,   307,   391,   337,   329,   337,   337,   329,
     337,   337,   337,   329,   337,   337,   309,   337,   361,     3,
     310,   309,   244,   379,     3,   379,   379,   329,     3,   329,
     329,   329,   329,   329,   329,   329,    26,   307,   363,     3,
     310,   309,     3,   310,     3,   329,   309,     3,   310,   309,
     288,   307,   310,   309,   310,   309,   309,   309,   310,   309,
     309,   310,   306,   329,   337,   379,   310,    26,    26,    26,
      26,    26,    26,   367,   329,   329,     3,   310,   329,   329,
     329,   329,   329,   338,   362,   329,   368,   369,   370,   365,
     364,   366,     3,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   301,   308,   336,   371,
     372,   329,   307,   309,   309,   309,   309,   307,   371,   371,
     371,   371,   371,   371,   329,   310,   309,   372
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   311,   312,   312,   312,   313,   313,   314,   314,   314,
     314,   314,   314,   314,   314,   314,   314,   314,   314,   314,
     314,   314,   314,   314,   314,   314,   314,   314,   314,   314,
     314,   314,   314,   314,   314,   314,   314,   314,   314,   314,
     314,   314,   314,   314,   314,   314,   314,   314,   314,   314,
     314,   314,   314,   314,   314,   314,   314,   314,   314,   314,
     314,   314,   314,   314,   315,   314,   314,   314,   314,   316,
     314,   317,   314,   314,   318,   314,   319,   314,   320,   314,
     314,   314,   321,   314,   314,   322,   314,   323,   314,   324,
     314,   314,   314,   325,   314,   314,   314,   326,   314,   314,
     314,   314,   327,   314,   314,   314,   328,   314,   314,   314,
     314,   314,   314,   314,   329,   330,   331,   331,   331,   331,
     331,   331,   331,   331,   331,   331,   331,   331,   331,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   333,   333,   333,   333,
     333,   333,   333,   333,   333,   333,   333,   333,   333,   333,
     333,   333,   334,   334,   335,   336,   337,   337,   337,   337,
     337,   337,   338,   338,   339,   339,   340,   340,   341,   341,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     343,   343,   344,   344,   344,   345,   345,   346,   346,   346,
     346,   346,   346,   346,   346,   347,   347,   348,   348,   348,
     348,   348,   348,   349,   349,   350,   350,   350,   350,   350,
     351,   351,   352,   352,   352,   352,   352,   352,   352,   352,
     352,   352,   352,   352,   352,   352,   352,   352,   352,   352,
     352,   352,   352,   352,   352,   353,   353,   354,   354,   354,
     354,   354,   355,   355,   356,   356,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   356,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   356,   356,   356,   356,   356,
     357,   357,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   358,   358,   358,   359,
     359,   360,   361,   360,   360,   360,   360,   360,   360,   362,
     362,   364,   363,   365,   363,   366,   363,   367,   363,   368,
     363,   369,   363,   370,   363,   371,   371,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   373,   373,   374,   374,   374,   374,
     374,   375,   375,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   377,   377,   378,   378,   378,   378,   378,   378,
     378,   379,   379,   380,   380,   381,   381,   381,   381,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   381,   381,
     381,   381,   381,   381,   381,   381,   381,   382,   382,   383,
     383,   383,   383,   383,   383,   383,   383,   383,   383,   383,
     383,   383,   383,   384,   384,   385,   385,   385,   385,   385,
     385,   385,   386,   386,   387,   387,   387,   387,   387,   387,
     387,   387,   387,   388,   388,   389,   389,   389,   389,   389,
     389,   389,   389,   390,   390,   391,   391,   391,   391,   391,
     391,   392,   393,   394,   395,   396,   396,   396,   396,   396,
     397,   397,   397,   397,   397,   397,   397,   398,   398,   399,
     399
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     3,     1,     2,     4,     2,     2,
       2,     4,     6,     9,     4,     1,     1,     3,     2,     2,
       2,     2,     2,     4,     2,     2,     2,     4,     2,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     1,     1,
       1,     2,     2,     2,     2,     2,     4,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     0,     5,     2,     4,     2,     0,
       5,     0,     5,     4,     0,     5,     0,     5,     0,     6,
       2,     3,     0,     5,     5,     0,     5,     0,     5,     0,
       5,     4,     8,     0,     5,     4,     2,     0,     5,     4,
       2,     4,     0,     5,     2,     4,     0,     5,     6,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     2,     2,     3,     3,     1,     3,     1,
       3,     3,     3,     2,     1,     4,     4,     4,     8,     6,
       6,     6,     6,     6,     6,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     1,     1,     1,
       1,     4,     1,     4,     1,     1,     1,     4,     8,     8,
       4,     1,     1,     3,     1,     3,     1,     3,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       2,     2,     2,     1,     1,     1,     2,     3,     4,     2,
       2,     2,     3,     4,     4,     6,     2,     2,     2,     2,
       1,     2,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     2,     2,     2,     2,
       2,     2,     2,     1,     2,     2,     2,     2,     2,     2,
       1,     2,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     2,     2,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       1,     1,     1,     2,     2,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     2,     2,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     0,     6,     2,     2,     2,     1,     1,     1,
       2,     0,     5,     0,     5,     0,     5,     0,     4,     0,
       5,     0,     5,     0,     5,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     2,     2,     1,     2,     2,     2,     2,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     2,     1,
       1,     2,     0,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     3,     2,     2,
       3,     2,     4,     3,     2,     1,     1,     1,     2,     1,
       3,     3,     4,     1,     1,     1,     2,     2,     1,     1,
       2,     1,     1,     1,     2,     1,     3,     3,     4,     1,
       1,     1,     1,     2,     1,     3,     2,     3,     4,     4,
       5,     1,     1,     1,     2,     1,     3,     2,     2,     2,
       2,     1,     1,     1,     2,     1,     3,     3,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 369 "parser.y" /* yacc.c:1648  */
    {}
#line 3156 "parser.c" /* yacc.c:1648  */
    break;

  case 8:
#line 371 "parser.y" /* yacc.c:1648  */
    { config.hogthreshold = (yyvsp[0].i_value); }
#line 3162 "parser.c" /* yacc.c:1648  */
    break;

  case 9:
#line 372 "parser.y" /* yacc.c:1648  */
    { IFCLASS(CL_VAR){ define_config_variable((yyvsp[0].s_value));} free((yyvsp[0].s_value)); }
#line 3168 "parser.c" /* yacc.c:1648  */
    break;

  case 10:
#line 373 "parser.y" /* yacc.c:1648  */
    { IFCLASS(CL_VAR){ undefine_config_variable((yyvsp[0].s_value));} free((yyvsp[0].s_value)); }
#line 3174 "parser.c" /* yacc.c:1648  */
    break;

  case 11:
#line 374 "parser.y" /* yacc.c:1648  */
    {
			/* NOTE:
			 * We _need_ absolutely to return to state stack 0
			 * because we 'backward' modify the input stream for
			 * the parser (in lexer). Hence, _if_ the parser needs
			 * to read one token more than needed, we are lost,
			 * because we can't discard it. So please, don't
			 * play with the grammar without knowing what you do.
			 * The ')' _will_ return to state stack 0, but fiddling
			 * with brackets '()' in the underlaying 'expression'
			 * rules may distroy this.
			 *                          -- Hans 971231
			 */
			tell_lexer_if((yyvsp[-1].i_value));
		}
#line 3194 "parser.c" /* yacc.c:1648  */
    break;

  case 12:
#line 396 "parser.y" /* yacc.c:1648  */
    {
			tell_lexer_loop((yyvsp[-4].i_value), (yyvsp[-1].i_value));
		}
#line 3202 "parser.c" /* yacc.c:1648  */
    break;

  case 13:
#line 399 "parser.y" /* yacc.c:1648  */
    {
			tell_lexer_loop((yyvsp[-7].i_value), for_each_handling((yyvsp[-7].i_value),(yyvsp[-5].s_value),(yyvsp[-3].s_value),(yyvsp[-1].s_value)));
			free((yyvsp[-5].s_value)); free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3211 "parser.c" /* yacc.c:1648  */
    break;

  case 14:
#line 403 "parser.y" /* yacc.c:1648  */
    {
			char *s = run_shell((yyvsp[-1].s_value));
			if (s) free(s);
			free((yyvsp[-1].s_value));
		}
#line 3221 "parser.c" /* yacc.c:1648  */
    break;

  case 15:
#line 408 "parser.y" /* yacc.c:1648  */
    { enter_user_scope((yyvsp[0].i_value)); }
#line 3227 "parser.c" /* yacc.c:1648  */
    break;

  case 16:
#line 409 "parser.y" /* yacc.c:1648  */
    { leave_user_scope((yyvsp[0].i_value)); }
#line 3233 "parser.c" /* yacc.c:1648  */
    break;

  case 17:
#line 410 "parser.y" /* yacc.c:1648  */
    {
		    if (!parser_version_3_style_used) {
			parser_version_3_style_used = 1;
			define_config_variable(CONFNAME_V3USED);
		    }
		    if ((strpbrk((yyvsp[-2].s_value), "uhc") == (yyvsp[-2].s_value)) && ((yyvsp[-2].s_value)[1] == '_'))
			yyerror("reserved variable %s can't be set\n", (yyvsp[-2].s_value));
		    else {
			if (user_scope_level) {
			    char *s = malloc(strlen((yyvsp[-2].s_value))+sizeof(USERVAR_PREF));
			    strcpy(s, USERVAR_PREF);
			    strcat(s,(yyvsp[-2].s_value));
			    setenv(s, (yyvsp[0].s_value), 1);
			    free(s);
			}
			else IFCLASS(CL_VAR) setenv((yyvsp[-2].s_value), (yyvsp[0].s_value), 1);
		    }
		    free((yyvsp[-2].s_value)); free((yyvsp[0].s_value));
		}
#line 3257 "parser.c" /* yacc.c:1648  */
    break;

  case 19:
#line 430 "parser.y" /* yacc.c:1648  */
    {
		    if ((yyvsp[0].t_value).type == TYPE_REAL)
			c_printf("CONF TESTING: exprtest real %f\n", (yyvsp[0].t_value).value.r);
		    else
			c_printf("CONF TESTING: exprtest int %d\n", (yyvsp[0].t_value).value.i);
		}
#line 3268 "parser.c" /* yacc.c:1648  */
    break;

  case 20:
#line 441 "parser.y" /* yacc.c:1648  */
    { if ((yyvsp[0].s_value)[0]) fprintf(stderr,"CONF aborted with: %s\n", (yyvsp[0].s_value));
			exit(99);
		    }
#line 3276 "parser.c" /* yacc.c:1648  */
    break;

  case 21:
#line 444 "parser.y" /* yacc.c:1648  */
    { c_printf("CONF: %s\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3282 "parser.c" /* yacc.c:1648  */
    break;

  case 22:
#line 446 "parser.y" /* yacc.c:1648  */
    {
		    free(config.emusys); config.emusys = (yyvsp[0].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[0].s_value));
		    }
#line 3291 "parser.c" /* yacc.c:1648  */
    break;

  case 23:
#line 451 "parser.y" /* yacc.c:1648  */
    {
		    free(config.emusys); config.emusys = (yyvsp[-1].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[-1].s_value));
		    }
#line 3300 "parser.c" /* yacc.c:1648  */
    break;

  case 24:
#line 456 "parser.y" /* yacc.c:1648  */
    {
#ifdef USE_MHPDBG
		    free(DOSEMU_MAP_PATH); DOSEMU_MAP_PATH = (yyvsp[0].s_value);
		    c_printf("CONF: dosemu.map path = '%s'\n", (yyvsp[0].s_value));
#else
		    free((yyvsp[0].s_value));
#endif
		    }
#line 3313 "parser.c" /* yacc.c:1648  */
    break;

  case 25:
#line 465 "parser.y" /* yacc.c:1648  */
    {
		    free(config.mappingdriver); config.mappingdriver = (yyvsp[0].s_value);
		    c_printf("CONF: mapping driver = '%s'\n", (yyvsp[0].s_value));
		    }
#line 3322 "parser.c" /* yacc.c:1648  */
    break;

  case 26:
#line 470 "parser.y" /* yacc.c:1648  */
    {
                    free(config.emuini); config.emuini = (yyvsp[0].s_value);
                    c_printf("CONF: config.emuini = '%s'\n", (yyvsp[0].s_value));
                    }
#line 3331 "parser.c" /* yacc.c:1648  */
    break;

  case 27:
#line 475 "parser.y" /* yacc.c:1648  */
    {
                    free(config.emuini); config.emuini = (yyvsp[-1].s_value);
                    c_printf("CONF: config.emuini = '%s'\n", (yyvsp[-1].s_value));
		    }
#line 3340 "parser.c" /* yacc.c:1648  */
    break;

  case 28:
#line 480 "parser.y" /* yacc.c:1648  */
    {
		    config.full_file_locks = ((yyvsp[0].i_value)!=0);
		    }
#line 3348 "parser.c" /* yacc.c:1648  */
    break;

  case 29:
#line 484 "parser.y" /* yacc.c:1648  */
    {
		    config.lfn = ((yyvsp[0].i_value)!=0);
		    }
#line 3356 "parser.c" /* yacc.c:1648  */
    break;

  case 30:
#line 488 "parser.y" /* yacc.c:1648  */
    {
			config.fastfloppy = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: fastfloppy = %d\n", config.fastfloppy);
			}
#line 3365 "parser.c" /* yacc.c:1648  */
    break;

  case 31:
#line 493 "parser.y" /* yacc.c:1648  */
    {
			int cpu = cpu_override (((yyvsp[0].i_value)%100)==86?((yyvsp[0].i_value)/100)%10:0);
			if (cpu > 0) {
				c_printf("CONF: CPU set to %d86\n",cpu);
				vm86s.cpu_type = cpu;
			}
			else
				yyerror("error in CPU user override\n");
			}
#line 3379 "parser.c" /* yacc.c:1648  */
    break;

  case 32:
#line 503 "parser.y" /* yacc.c:1648  */
    {
			vm86s.cpu_type = 5;
#ifdef X86_EMULATOR
			config.cpuemu = 1;
			c_printf("CONF: CPUEMU set to %d for %d86\n",
				config.cpuemu, vm86s.cpu_type);
#endif
			}
#line 3392 "parser.c" /* yacc.c:1648  */
    break;

  case 33:
#line 512 "parser.y" /* yacc.c:1648  */
    {
#ifdef X86_EMULATOR
			config.cpuemu = (yyvsp[0].i_value);
			if (config.cpuemu > 4) {
				config.cpuemu -= 2;
#ifdef HOST_ARCH_X86
				config.cpusim = 1;
#endif
			}
			c_printf("CONF: %s CPUEMU set to %d for %d86\n",
				CONFIG_CPUSIM ? "simulated" : "JIT",
				config.cpuemu, vm86s.cpu_type);
#endif
			}
#line 3411 "parser.c" /* yacc.c:1648  */
    break;

  case 34:
#line 527 "parser.y" /* yacc.c:1648  */
    { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = ((double)LLF_US)/(yyvsp[0].r_value);
			  config.cpu_tick_spd = ((double)LLF_TICKS)/(yyvsp[0].r_value);
			  c_printf("CONF: CPU speed = %g\n", ((double)(yyvsp[0].r_value)));
			}
#endif
			}
#line 3425 "parser.c" /* yacc.c:1648  */
    break;

  case 35:
#line 537 "parser.y" /* yacc.c:1648  */
    { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = (LLF_US*(yyvsp[0].i_value))/(yyvsp[-1].i_value);
			  config.cpu_tick_spd = (LLF_TICKS*(yyvsp[0].i_value))/(yyvsp[-1].i_value);
			  c_printf("CONF: CPU speed = %d/%d\n", (yyvsp[-1].i_value), (yyvsp[0].i_value));
			}
#endif
			}
#line 3439 "parser.c" /* yacc.c:1648  */
    break;

  case 36:
#line 547 "parser.y" /* yacc.c:1648  */
    {
			config.rdtsc = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: %sabling use of pentium timer\n",
				(config.rdtsc?"En":"Dis"));
		    }
#line 3449 "parser.c" /* yacc.c:1648  */
    break;

  case 37:
#line 553 "parser.y" /* yacc.c:1648  */
    { 
		      config.pci_video = ((yyvsp[0].i_value)!=0);
		      IFCLASS(CL_PCI) {}
		      config.pci = (abs((yyvsp[0].i_value))==2); 
		    }
#line 3459 "parser.c" /* yacc.c:1648  */
    break;

  case 38:
#line 559 "parser.y" /* yacc.c:1648  */
    {
		      config.hdiskboot = 0;
		    }
#line 3467 "parser.c" /* yacc.c:1648  */
    break;

  case 39:
#line 563 "parser.y" /* yacc.c:1648  */
    {
		      config.hdiskboot = 1;
		    }
#line 3475 "parser.c" /* yacc.c:1648  */
    break;

  case 40:
#line 567 "parser.y" /* yacc.c:1648  */
    {
		      config.hdiskboot = 2;
		    }
#line 3483 "parser.c" /* yacc.c:1648  */
    break;

  case 41:
#line 571 "parser.y" /* yacc.c:1648  */
    {
		    config.freq = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value)) {
		        config.update = 1000000 / (yyvsp[0].i_value);
		    } else {
			config.update = 54925;
			config.freq = 18;
		    }
		    c_printf("CONF: timer freq=%d, update=%d\n",config.freq,config.update);
		    }
#line 3498 "parser.c" /* yacc.c:1648  */
    break;

  case 42:
#line 582 "parser.y" /* yacc.c:1648  */
    {
		      char *b;
		      flush_log();
		      b = malloc((yyvsp[0].i_value)+1024);
		      if (!b) {
			error("cannot get logbuffer\n");
			exit(1);
		      }
		      logptr = logbuf = b;
		      logbuf_size = (yyvsp[0].i_value);
		    }
#line 3514 "parser.c" /* yacc.c:1648  */
    break;

  case 43:
#line 594 "parser.y" /* yacc.c:1648  */
    {
		      logfile_limit = (yyvsp[0].i_value);
		    }
#line 3522 "parser.c" /* yacc.c:1648  */
    break;

  case 44:
#line 598 "parser.y" /* yacc.c:1648  */
    {
		    config.dosbanner = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: dosbanner %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3531 "parser.c" /* yacc.c:1648  */
    break;

  case 45:
#line 603 "parser.y" /* yacc.c:1648  */
    { IFCLASS(CL_VPORT){
		    if ((yyvsp[0].i_value) && !config.emuretrace && priv_lvl)
		      yyerror("Can not modify video port access in user config file");
		    config.emuretrace = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: emu_retrace %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }}
#line 3542 "parser.c" /* yacc.c:1648  */
    break;

  case 47:
#line 611 "parser.y" /* yacc.c:1648  */
    {
		    if ((yyvsp[0].i_value) >= 0) config.ems_size = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
		    }
#line 3551 "parser.c" /* yacc.c:1648  */
    break;

  case 48:
#line 616 "parser.y" /* yacc.c:1648  */
    {
		    if ((yyvsp[0].i_value) >= 0) config.xms_size = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes XMS memory\n", (yyvsp[0].i_value));
		    }
#line 3560 "parser.c" /* yacc.c:1648  */
    break;

  case 49:
#line 621 "parser.y" /* yacc.c:1648  */
    {
		    config.max_umb = ((yyvsp[0].i_value)!=0);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: maximize umb's %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3569 "parser.c" /* yacc.c:1648  */
    break;

  case 50:
#line 626 "parser.y" /* yacc.c:1648  */
    {
		    if ((yyvsp[0].i_value)>=0) config.dpmi = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI-Server %s (%#x)\n", ((yyvsp[0].i_value)) ? "on" : "off", ((yyvsp[0].i_value)));
		    }
#line 3578 "parser.c" /* yacc.c:1648  */
    break;

  case 51:
#line 631 "parser.y" /* yacc.c:1648  */
    {
		    config.dpmi_base = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI base addr = %#x\n", (yyvsp[0].i_value));
		    }
#line 3587 "parser.c" /* yacc.c:1648  */
    break;

  case 52:
#line 636 "parser.y" /* yacc.c:1648  */
    {
		    config.pm_dos_api = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: PM DOS API Translator %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3596 "parser.c" /* yacc.c:1648  */
    break;

  case 53:
#line 641 "parser.y" /* yacc.c:1648  */
    {
		    config.no_null_checks = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: No DJGPP NULL deref checks: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3605 "parser.c" /* yacc.c:1648  */
    break;

  case 54:
#line 645 "parser.y" /* yacc.c:1648  */
    { if ((yyvsp[0].i_value)>=0) config.mem_size = (yyvsp[0].i_value); }
#line 3611 "parser.c" /* yacc.c:1648  */
    break;

  case 55:
#line 646 "parser.y" /* yacc.c:1648  */
    { if ((yyvsp[0].i_value)>=0) config.ext_mem = (yyvsp[0].i_value); }
#line 3617 "parser.c" /* yacc.c:1648  */
    break;

  case 56:
#line 647 "parser.y" /* yacc.c:1648  */
    { config.mathco = ((yyvsp[0].i_value)!=0); }
#line 3623 "parser.c" /* yacc.c:1648  */
    break;

  case 57:
#line 649 "parser.y" /* yacc.c:1648  */
    {
		    config.ipxsup = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: IPX support %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3632 "parser.c" /* yacc.c:1648  */
    break;

  case 58:
#line 653 "parser.y" /* yacc.c:1648  */
    { config.ipx_net = (yyvsp[0].i_value); }
#line 3638 "parser.c" /* yacc.c:1648  */
    break;

  case 59:
#line 655 "parser.y" /* yacc.c:1648  */
    {
		      if (config.vnet == VNET_TYPE_TAP || (yyvsp[0].i_value) == 0 || is_in_allowed_classes(CL_NET)) {
			config.pktdrv = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: Packet Driver %s.\n", 
				((yyvsp[0].i_value)) ? "enabled" : "disabled");
		      }
		    }
#line 3650 "parser.c" /* yacc.c:1648  */
    break;

  case 60:
#line 662 "parser.y" /* yacc.c:1648  */
    { free(config.netdev); config.netdev = (yyvsp[0].s_value); }
#line 3656 "parser.c" /* yacc.c:1648  */
    break;

  case 61:
#line 663 "parser.y" /* yacc.c:1648  */
    { config.pktflags = ((yyvsp[0].i_value)!=0); }
#line 3662 "parser.c" /* yacc.c:1648  */
    break;

  case 62:
#line 664 "parser.y" /* yacc.c:1648  */
    { start_vnet((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3668 "parser.c" /* yacc.c:1648  */
    break;

  case 63:
#line 666 "parser.y" /* yacc.c:1648  */
    {
		    if ((yyvsp[0].i_value) == SPKR_NATIVE) {
		      if (can_do_root_stuff) {
                        c_printf("CONF: allowing speaker port access!\n");
		      } else {
                        c_printf("CONF: native speaker not allowed: emulate\n");
			(yyvsp[0].i_value) = SPKR_EMULATED;
		      }
		    }
		    else
                      c_printf("CONF: not allowing speaker port access\n");
		    config.speaker = (yyvsp[0].i_value);
		    }
#line 3686 "parser.c" /* yacc.c:1648  */
    break;

  case 64:
#line 680 "parser.y" /* yacc.c:1648  */
    { start_video(); }
#line 3692 "parser.c" /* yacc.c:1648  */
    break;

  case 65:
#line 682 "parser.y" /* yacc.c:1648  */
    { stop_video(); }
#line 3698 "parser.c" /* yacc.c:1648  */
    break;

  case 66:
#line 683 "parser.y" /* yacc.c:1648  */
    { free(config.xterm_title); config.xterm_title = (yyvsp[0].s_value); }
#line 3704 "parser.c" /* yacc.c:1648  */
    break;

  case 67:
#line 686 "parser.y" /* yacc.c:1648  */
    { stop_terminal(); }
#line 3710 "parser.c" /* yacc.c:1648  */
    break;

  case 68:
#line 687 "parser.y" /* yacc.c:1648  */
    {
			parse_debugflags((yyvsp[0].s_value), 1);
			free((yyvsp[0].s_value));
		}
#line 3719 "parser.c" /* yacc.c:1648  */
    break;

  case 69:
#line 692 "parser.y" /* yacc.c:1648  */
    { start_debug(); }
#line 3725 "parser.c" /* yacc.c:1648  */
    break;

  case 71:
#line 695 "parser.y" /* yacc.c:1648  */
    { start_mouse(); }
#line 3731 "parser.c" /* yacc.c:1648  */
    break;

  case 72:
#line 697 "parser.y" /* yacc.c:1648  */
    { stop_mouse(); }
#line 3737 "parser.c" /* yacc.c:1648  */
    break;

  case 73:
#line 700 "parser.y" /* yacc.c:1648  */
    { stop_ttylocks(); }
#line 3743 "parser.c" /* yacc.c:1648  */
    break;

  case 74:
#line 702 "parser.y" /* yacc.c:1648  */
    { start_serial(); }
#line 3749 "parser.c" /* yacc.c:1648  */
    break;

  case 75:
#line 704 "parser.y" /* yacc.c:1648  */
    { stop_serial(); }
#line 3755 "parser.c" /* yacc.c:1648  */
    break;

  case 76:
#line 706 "parser.y" /* yacc.c:1648  */
    { start_keyboard(); }
#line 3761 "parser.c" /* yacc.c:1648  */
    break;

  case 78:
#line 709 "parser.y" /* yacc.c:1648  */
    {keytable_start((yyvsp[0].i_value));}
#line 3767 "parser.c" /* yacc.c:1648  */
    break;

  case 79:
#line 711 "parser.y" /* yacc.c:1648  */
    {keytable_stop();}
#line 3773 "parser.c" /* yacc.c:1648  */
    break;

  case 80:
#line 713 "parser.y" /* yacc.c:1648  */
    {
		    append_pre_strokes((yyvsp[0].s_value));
		    c_printf("CONF: appending pre-strokes '%s'\n", (yyvsp[0].s_value));
		    free((yyvsp[0].s_value));
		    }
#line 3783 "parser.c" /* yacc.c:1648  */
    break;

  case 81:
#line 718 "parser.y" /* yacc.c:1648  */
    {
			dump_keytables_to_file((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		    }
#line 3792 "parser.c" /* yacc.c:1648  */
    break;

  case 82:
#line 723 "parser.y" /* yacc.c:1648  */
    { IFCLASS(CL_PORT) start_ports(); }
#line 3798 "parser.c" /* yacc.c:1648  */
    break;

  case 85:
#line 727 "parser.y" /* yacc.c:1648  */
    { start_disk(); }
#line 3804 "parser.c" /* yacc.c:1648  */
    break;

  case 86:
#line 729 "parser.y" /* yacc.c:1648  */
    { stop_disk(DISK); }
#line 3810 "parser.c" /* yacc.c:1648  */
    break;

  case 87:
#line 731 "parser.y" /* yacc.c:1648  */
    { start_bootdisk(); }
#line 3816 "parser.c" /* yacc.c:1648  */
    break;

  case 88:
#line 733 "parser.y" /* yacc.c:1648  */
    { stop_disk(BOOTDISK); }
#line 3822 "parser.c" /* yacc.c:1648  */
    break;

  case 89:
#line 735 "parser.y" /* yacc.c:1648  */
    { start_floppy(); }
#line 3828 "parser.c" /* yacc.c:1648  */
    break;

  case 90:
#line 737 "parser.y" /* yacc.c:1648  */
    { stop_disk(L_FLOPPY); }
#line 3834 "parser.c" /* yacc.c:1648  */
    break;

  case 91:
#line 739 "parser.y" /* yacc.c:1648  */
    {
		    static int which = 0;
		    if (which >= 3) {
			c_printf("CONF: too many cdrom drives defined\n");
			free((yyvsp[-1].s_value));
		    }
		    else {
			Path_cdrom[which] = (yyvsp[-1].s_value);
			c_printf("CONF: cdrom MSCD000%d on %s\n", which+1 ,(yyvsp[-1].s_value));
			which++;
		    }
		    }
#line 3851 "parser.c" /* yacc.c:1648  */
    break;

  case 92:
#line 752 "parser.y" /* yacc.c:1648  */
    {
#ifdef ASPI_SUPPORT
		    char *s = aspi_add_device((yyvsp[-5].s_value), (yyvsp[-3].s_value), (yyvsp[-1].i_value));
		    if (s) {
			c_printf("CONF: aspi available for %s\n", s);
			free(s);
		    }
		    else c_printf("CONF: aspi device %s not available\n", (yyvsp[-5].s_value));
#endif
		    free((yyvsp[-5].s_value));
		    free((yyvsp[-3].s_value));
		    }
#line 3868 "parser.c" /* yacc.c:1648  */
    break;

  case 93:
#line 765 "parser.y" /* yacc.c:1648  */
    { start_printer(); }
#line 3874 "parser.c" /* yacc.c:1648  */
    break;

  case 94:
#line 767 "parser.y" /* yacc.c:1648  */
    { stop_printer(); }
#line 3880 "parser.c" /* yacc.c:1648  */
    break;

  case 96:
#line 769 "parser.y" /* yacc.c:1648  */
    { config.sound = (yyvsp[0].i_value)==2 ? 2 : (yyvsp[0].i_value)==0 ? 0 : 1; }
#line 3886 "parser.c" /* yacc.c:1648  */
    break;

  case 97:
#line 770 "parser.y" /* yacc.c:1648  */
    { config.sound = 1; }
#line 3892 "parser.c" /* yacc.c:1648  */
    break;

  case 100:
#line 772 "parser.y" /* yacc.c:1648  */
    { if (! (yyvsp[0].i_value)) { config.joy_device[0] = config.joy_device[1] = NULL; } }
#line 3898 "parser.c" /* yacc.c:1648  */
    break;

  case 102:
#line 775 "parser.y" /* yacc.c:1648  */
    { IFCLASS(CL_IRQ) config.sillyint=0; }
#line 3904 "parser.c" /* yacc.c:1648  */
    break;

  case 104:
#line 778 "parser.y" /* yacc.c:1648  */
    { IFCLASS(CL_IRQ) if ((yyvsp[0].i_value)) {
		        config.sillyint = 1 << (yyvsp[0].i_value);
		        c_printf("CONF: IRQ %d for irqpassing\n", (yyvsp[0].i_value));
		      }
		    }
#line 3914 "parser.c" /* yacc.c:1648  */
    break;

  case 106:
#line 785 "parser.y" /* yacc.c:1648  */
    { IFCLASS(CL_HARDRAM) {}
		    if (priv_lvl)
		      yyerror("Can not change hardware ram access settings in user config file");
		    }
#line 3923 "parser.c" /* yacc.c:1648  */
    break;

  case 108:
#line 791 "parser.y" /* yacc.c:1648  */
    {
			handle_features((yyvsp[-3].i_value), (yyvsp[-1].i_value));
		    }
#line 3931 "parser.c" /* yacc.c:1648  */
    break;

  case 109:
#line 795 "parser.y" /* yacc.c:1648  */
    { config.cli_timeout = (yyvsp[0].i_value); }
#line 3937 "parser.c" /* yacc.c:1648  */
    break;

  case 110:
#line 797 "parser.y" /* yacc.c:1648  */
    { config.pic_watchdog = (yyvsp[0].i_value); }
#line 3943 "parser.c" /* yacc.c:1648  */
    break;

  case 111:
#line 799 "parser.y" /* yacc.c:1648  */
    {
		    config.timemode = parse_timemode((yyvsp[0].s_value));
		    c_printf("CONF: time mode = '%s'\n", (yyvsp[0].s_value));
		    free((yyvsp[0].s_value));
		    }
#line 3953 "parser.c" /* yacc.c:1648  */
    break;

  case 112:
#line 805 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized command '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3959 "parser.c" /* yacc.c:1648  */
    break;

  case 114:
#line 809 "parser.y" /* yacc.c:1648  */
    { (yyval.i_value) = TOF((yyvsp[0].t_value)); }
#line 3965 "parser.c" /* yacc.c:1648  */
    break;

  case 115:
#line 812 "parser.y" /* yacc.c:1648  */
    { (yyval.r_value) = TOF((yyvsp[0].t_value)); }
#line 3971 "parser.c" /* yacc.c:1648  */
    break;

  case 116:
#line 817 "parser.y" /* yacc.c:1648  */
    {(yyval.t_value).type = TYPE_INTEGER; (yyval.t_value).value.i=(yyvsp[0].i_value);}
#line 3977 "parser.c" /* yacc.c:1648  */
    break;

  case 117:
#line 818 "parser.y" /* yacc.c:1648  */
    {(yyval.t_value).type = TYPE_BOOLEAN; (yyval.t_value).value.i=(yyvsp[0].i_value);}
#line 3983 "parser.c" /* yacc.c:1648  */
    break;

  case 118:
#line 819 "parser.y" /* yacc.c:1648  */
    {(yyval.t_value).type = TYPE_REAL; (yyval.t_value).value.r=(yyvsp[0].r_value);}
#line 3989 "parser.c" /* yacc.c:1648  */
    break;

  case 119:
#line 821 "parser.y" /* yacc.c:1648  */
    {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) + TOF((yyvsp[0].t_value))); }
#line 3995 "parser.c" /* yacc.c:1648  */
    break;

  case 120:
#line 823 "parser.y" /* yacc.c:1648  */
    {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) - TOF((yyvsp[0].t_value))); }
#line 4001 "parser.c" /* yacc.c:1648  */
    break;

  case 121:
#line 825 "parser.y" /* yacc.c:1648  */
    {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) * TOF((yyvsp[0].t_value))); }
#line 4007 "parser.c" /* yacc.c:1648  */
    break;

  case 122:
#line 826 "parser.y" /* yacc.c:1648  */
    {
			if (TOF((yyvsp[0].t_value)))	V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) / TOF((yyvsp[0].t_value)));
			else V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[0].t_value)));
		}
#line 4016 "parser.c" /* yacc.c:1648  */
    break;

  case 123:
#line 831 "parser.y" /* yacc.c:1648  */
    {V_VAL((yyval.t_value),(yyvsp[0].t_value),-TOF((yyvsp[0].t_value))); }
#line 4022 "parser.c" /* yacc.c:1648  */
    break;

  case 124:
#line 833 "parser.y" /* yacc.c:1648  */
    {V_VAL((yyval.t_value),(yyvsp[0].t_value),TOF((yyvsp[0].t_value))); }
#line 4028 "parser.c" /* yacc.c:1648  */
    break;

  case 125:
#line 835 "parser.y" /* yacc.c:1648  */
    { unsigned int shift = (1 << (int)TOF((yyvsp[0].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[-2].t_value);
			else V_VAL((yyval.t_value), (yyvsp[-2].t_value), TOF((yyvsp[-2].t_value)) / shift);}
#line 4036 "parser.c" /* yacc.c:1648  */
    break;

  case 126:
#line 839 "parser.y" /* yacc.c:1648  */
    { unsigned int shift = (1 << (int)TOF((yyvsp[0].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[-2].t_value);
			else V_VAL((yyval.t_value), (yyvsp[-2].t_value), TOF((yyvsp[-2].t_value)) * shift);}
#line 4044 "parser.c" /* yacc.c:1648  */
    break;

  case 127:
#line 842 "parser.y" /* yacc.c:1648  */
    {
			char *s;
			(yyval.t_value).type = TYPE_INTEGER;
			(yyval.t_value).value.i = strtoul((yyvsp[0].s_value),&s,0);
			switch (*s) {
				case '.':  case 'e':  case 'E':
				/* we assume a real number */
				(yyval.t_value).type = TYPE_REAL;
				(yyval.t_value).value.r = strtod((yyvsp[0].s_value),0);
			}
			free((yyvsp[0].s_value));
		}
#line 4061 "parser.c" /* yacc.c:1648  */
    break;

  case 128:
#line 854 "parser.y" /* yacc.c:1648  */
    {(yyval.t_value) = (yyvsp[-1].t_value);}
#line 4067 "parser.c" /* yacc.c:1648  */
    break;

  case 130:
#line 859 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) & (int)TOF((yyvsp[0].t_value)); }
#line 4073 "parser.c" /* yacc.c:1648  */
    break;

  case 131:
#line 861 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) | (int)TOF((yyvsp[0].t_value)); }
#line 4079 "parser.c" /* yacc.c:1648  */
    break;

  case 132:
#line 863 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) ^ (int)TOF((yyvsp[0].t_value)); }
#line 4085 "parser.c" /* yacc.c:1648  */
    break;

  case 133:
#line 865 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = (int)TOF((yyvsp[0].t_value)) ^ (-1); }
#line 4091 "parser.c" /* yacc.c:1648  */
    break;

  case 134:
#line 866 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = -1; }
#line 4097 "parser.c" /* yacc.c:1648  */
    break;

  case 135:
#line 867 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = TOF((yyvsp[-1].t_value));}
#line 4103 "parser.c" /* yacc.c:1648  */
    break;

  case 136:
#line 868 "parser.y" /* yacc.c:1648  */
    {
			(yyval.i_value) = strtol((yyvsp[-1].s_value),0,0);
			free((yyvsp[-1].s_value));
		}
#line 4112 "parser.c" /* yacc.c:1648  */
    break;

  case 137:
#line 872 "parser.y" /* yacc.c:1648  */
    {
			(yyval.i_value) = strlen((yyvsp[-1].s_value));
			free((yyvsp[-1].s_value));
		}
#line 4121 "parser.c" /* yacc.c:1648  */
    break;

  case 138:
#line 876 "parser.y" /* yacc.c:1648  */
    {
			(yyval.i_value) = strncmp((yyvsp[-5].s_value),(yyvsp[-3].s_value),(yyvsp[-1].i_value));
			free((yyvsp[-5].s_value)); free((yyvsp[-3].s_value));
		}
#line 4130 "parser.c" /* yacc.c:1648  */
    break;

  case 139:
#line 880 "parser.y" /* yacc.c:1648  */
    {
			char *s = strpbrk((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4141 "parser.c" /* yacc.c:1648  */
    break;

  case 140:
#line 886 "parser.y" /* yacc.c:1648  */
    {
			char *s = strchr((yyvsp[-3].s_value),(yyvsp[-1].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4152 "parser.c" /* yacc.c:1648  */
    break;

  case 141:
#line 892 "parser.y" /* yacc.c:1648  */
    {
			char *s = strrchr((yyvsp[-3].s_value),(yyvsp[-1].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4163 "parser.c" /* yacc.c:1648  */
    break;

  case 142:
#line 898 "parser.y" /* yacc.c:1648  */
    {
			char *s = strstr((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4174 "parser.c" /* yacc.c:1648  */
    break;

  case 143:
#line 904 "parser.y" /* yacc.c:1648  */
    {
			(yyval.i_value) = strspn((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4183 "parser.c" /* yacc.c:1648  */
    break;

  case 144:
#line 908 "parser.y" /* yacc.c:1648  */
    {
			(yyval.i_value) = strcspn((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4192 "parser.c" /* yacc.c:1648  */
    break;

  case 145:
#line 912 "parser.y" /* yacc.c:1648  */
    {
			if ( (yyvsp[0].s_value)[0] == '\'' && (yyvsp[0].s_value)[1] && (yyvsp[0].s_value)[2] == '\'' && !(yyvsp[0].s_value)[3] )
				(yyval.i_value) = (yyvsp[0].s_value)[1];
			else	yyerror("unrecognized expression '%s'", (yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4203 "parser.c" /* yacc.c:1648  */
    break;

  case 146:
#line 921 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) == TOF((yyvsp[0].t_value)); }
#line 4209 "parser.c" /* yacc.c:1648  */
    break;

  case 147:
#line 923 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) != TOF((yyvsp[0].t_value)); }
#line 4215 "parser.c" /* yacc.c:1648  */
    break;

  case 148:
#line 925 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) >= TOF((yyvsp[0].t_value)); }
#line 4221 "parser.c" /* yacc.c:1648  */
    break;

  case 149:
#line 927 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) <= TOF((yyvsp[0].t_value)); }
#line 4227 "parser.c" /* yacc.c:1648  */
    break;

  case 150:
#line 929 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) < TOF((yyvsp[0].t_value)); }
#line 4233 "parser.c" /* yacc.c:1648  */
    break;

  case 151:
#line 931 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) > TOF((yyvsp[0].t_value)); }
#line 4239 "parser.c" /* yacc.c:1648  */
    break;

  case 152:
#line 933 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) && TOF((yyvsp[0].t_value)); }
#line 4245 "parser.c" /* yacc.c:1648  */
    break;

  case 153:
#line 935 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) || TOF((yyvsp[0].t_value)); }
#line 4251 "parser.c" /* yacc.c:1648  */
    break;

  case 154:
#line 937 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = strcmp((yyvsp[-2].s_value),(yyvsp[0].s_value)) == 0; free((yyvsp[-2].s_value)); free((yyvsp[0].s_value)); }
#line 4257 "parser.c" /* yacc.c:1648  */
    break;

  case 155:
#line 939 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = strcmp((yyvsp[-2].s_value),(yyvsp[0].s_value)) != 0; free((yyvsp[-2].s_value)); free((yyvsp[0].s_value)); }
#line 4263 "parser.c" /* yacc.c:1648  */
    break;

  case 156:
#line 940 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = (TOF((yyvsp[0].t_value)) ? 0:1); }
#line 4269 "parser.c" /* yacc.c:1648  */
    break;

  case 157:
#line 941 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = -2; }
#line 4275 "parser.c" /* yacc.c:1648  */
    break;

  case 158:
#line 942 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = 0; }
#line 4281 "parser.c" /* yacc.c:1648  */
    break;

  case 159:
#line 943 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = -2; }
#line 4287 "parser.c" /* yacc.c:1648  */
    break;

  case 160:
#line 944 "parser.y" /* yacc.c:1648  */
    {(yyval.i_value) = 0; }
#line 4293 "parser.c" /* yacc.c:1648  */
    break;

  case 161:
#line 945 "parser.y" /* yacc.c:1648  */
    {
			(yyval.i_value) = get_config_variable((yyvsp[-1].s_value)) !=0;
			free((yyvsp[-1].s_value));
		}
#line 4302 "parser.c" /* yacc.c:1648  */
    break;

  case 163:
#line 952 "parser.y" /* yacc.c:1648  */
    {(yyval.r_value) = TOF((yyvsp[-1].t_value));}
#line 4308 "parser.c" /* yacc.c:1648  */
    break;

  case 164:
#line 956 "parser.y" /* yacc.c:1648  */
    {
			char *s = (yyvsp[0].s_value);
			if (get_config_variable(s))
				s = "1";
			else if (strncmp("c_",s,2)
					&& strncmp("u_",s,2)
					&& strncmp("h_",s,2) ) {
				s = checked_getenv(s);
				if (!s) s = "";
			}
			else
				s = "0";
			(yyval.s_value) = strdup(s);
			free((yyvsp[0].s_value));
		}
#line 4328 "parser.c" /* yacc.c:1648  */
    break;

  case 165:
#line 973 "parser.y" /* yacc.c:1648  */
    {
			(yyval.s_value) = (yyvsp[0].s_value);
			if ((yyval.s_value)[0] == '\'' || (yyval.s_value)[0] == '\"') {
				size_t len = strlen((yyvsp[0].s_value)) - 2;
				memmove((yyval.s_value), (yyval.s_value)+1, len);
				(yyval.s_value)[len] = '\0';
			}
		}
#line 4341 "parser.c" /* yacc.c:1648  */
    break;

  case 167:
#line 984 "parser.y" /* yacc.c:1648  */
    {(yyval.s_value) = (yyvsp[-1].s_value); }
#line 4347 "parser.c" /* yacc.c:1648  */
    break;

  case 168:
#line 985 "parser.y" /* yacc.c:1648  */
    {
			int i = (yyvsp[-3].i_value);
			int len = (yyvsp[-1].i_value);
			int slen = strlen((yyvsp[-5].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) len = slen - i;
				(yyvsp[-5].s_value)[i+len] = 0;
				(yyval.s_value) = strdup((yyvsp[-5].s_value) + i);
			}
			else
				(yyval.s_value) = strdup("");
			free((yyvsp[-5].s_value));
		}
#line 4365 "parser.c" /* yacc.c:1648  */
    break;

  case 169:
#line 998 "parser.y" /* yacc.c:1648  */
    {
			int i = (yyvsp[-3].i_value);
			int len = (yyvsp[-1].i_value);
			int slen = strlen((yyvsp[-5].s_value));
			char *s = strdup((yyvsp[-5].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) s[i] = 0;
				else memmove(s+i, s+i+len, slen-i-len+1);
			}
			free((yyvsp[-5].s_value));
			(yyval.s_value) = s;
		}
#line 4382 "parser.c" /* yacc.c:1648  */
    break;

  case 170:
#line 1010 "parser.y" /* yacc.c:1648  */
    {
			(yyval.s_value) = run_shell((yyvsp[-1].s_value));
			free((yyvsp[-1].s_value));
		}
#line 4391 "parser.c" /* yacc.c:1648  */
    break;

  case 171:
#line 1014 "parser.y" /* yacc.c:1648  */
    {(yyval.s_value) = (yyvsp[0].s_value);}
#line 4397 "parser.c" /* yacc.c:1648  */
    break;

  case 173:
#line 1018 "parser.y" /* yacc.c:1648  */
    {
			char *s = malloc(strlen((yyvsp[-2].s_value))+strlen((yyvsp[0].s_value))+1);
			strcpy(s, (yyvsp[-2].s_value));
			strcat(s, (yyvsp[0].s_value));
			(yyval.s_value) = s;
			free((yyvsp[-2].s_value)); free((yyvsp[0].s_value));
		}
#line 4409 "parser.c" /* yacc.c:1648  */
    break;

  case 175:
#line 1028 "parser.y" /* yacc.c:1648  */
    {
			if ((yyvsp[-1].t_value).type == TYPE_REAL)
				asprintf(&(yyval.s_value), "%g", (yyvsp[-1].t_value).value.r);
			else
				asprintf(&(yyval.s_value), "%d", (yyvsp[-1].t_value).value.i);
		}
#line 4420 "parser.c" /* yacc.c:1648  */
    break;

  case 176:
#line 1037 "parser.y" /* yacc.c:1648  */
    {
			check_user_var((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4429 "parser.c" /* yacc.c:1648  */
    break;

  case 177:
#line 1041 "parser.y" /* yacc.c:1648  */
    {
			check_user_var((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4438 "parser.c" /* yacc.c:1648  */
    break;

  case 180:
#line 1052 "parser.y" /* yacc.c:1648  */
    { config.X_updatelines = (yyvsp[0].i_value); }
#line 4444 "parser.c" /* yacc.c:1648  */
    break;

  case 181:
#line 1053 "parser.y" /* yacc.c:1648  */
    { config.X_updatefreq = (yyvsp[0].i_value); }
#line 4450 "parser.c" /* yacc.c:1648  */
    break;

  case 182:
#line 1054 "parser.y" /* yacc.c:1648  */
    { free(config.X_display); config.X_display = (yyvsp[0].s_value); }
#line 4456 "parser.c" /* yacc.c:1648  */
    break;

  case 183:
#line 1055 "parser.y" /* yacc.c:1648  */
    { free(config.X_title); config.X_title = (yyvsp[0].s_value); }
#line 4462 "parser.c" /* yacc.c:1648  */
    break;

  case 184:
#line 1056 "parser.y" /* yacc.c:1648  */
    { config.X_title_show_appname = ((yyvsp[0].i_value)!=0); }
#line 4468 "parser.c" /* yacc.c:1648  */
    break;

  case 185:
#line 1057 "parser.y" /* yacc.c:1648  */
    { free(config.X_icon_name); config.X_icon_name = (yyvsp[0].s_value); }
#line 4474 "parser.c" /* yacc.c:1648  */
    break;

  case 186:
#line 1058 "parser.y" /* yacc.c:1648  */
    { config.X_keycode = (yyvsp[0].i_value); }
#line 4480 "parser.c" /* yacc.c:1648  */
    break;

  case 187:
#line 1059 "parser.y" /* yacc.c:1648  */
    { config.X_blinkrate = (yyvsp[0].i_value); }
#line 4486 "parser.c" /* yacc.c:1648  */
    break;

  case 188:
#line 1060 "parser.y" /* yacc.c:1648  */
    { config.X_sharecmap = 1; }
#line 4492 "parser.c" /* yacc.c:1648  */
    break;

  case 189:
#line 1061 "parser.y" /* yacc.c:1648  */
    { config.X_mitshm = 1; }
#line 4498 "parser.c" /* yacc.c:1648  */
    break;

  case 190:
#line 1062 "parser.y" /* yacc.c:1648  */
    { config.X_mitshm = ((yyvsp[0].i_value)!=0); }
#line 4504 "parser.c" /* yacc.c:1648  */
    break;

  case 191:
#line 1063 "parser.y" /* yacc.c:1648  */
    { free(config.X_font); config.X_font = (yyvsp[0].s_value); }
#line 4510 "parser.c" /* yacc.c:1648  */
    break;

  case 192:
#line 1064 "parser.y" /* yacc.c:1648  */
    { config.X_fixed_aspect = ((yyvsp[0].i_value)!=0); }
#line 4516 "parser.c" /* yacc.c:1648  */
    break;

  case 193:
#line 1065 "parser.y" /* yacc.c:1648  */
    { config.X_aspect_43 = 1; }
#line 4522 "parser.c" /* yacc.c:1648  */
    break;

  case 194:
#line 1066 "parser.y" /* yacc.c:1648  */
    { config.X_lin_filt = 1; }
#line 4528 "parser.c" /* yacc.c:1648  */
    break;

  case 195:
#line 1067 "parser.y" /* yacc.c:1648  */
    { config.X_bilin_filt = 1; }
#line 4534 "parser.c" /* yacc.c:1648  */
    break;

  case 196:
#line 1068 "parser.y" /* yacc.c:1648  */
    { config.X_mode13fact = (yyvsp[0].i_value); }
#line 4540 "parser.c" /* yacc.c:1648  */
    break;

  case 197:
#line 1070 "parser.y" /* yacc.c:1648  */
    {
                     config.X_winsize_x = (yyvsp[-1].i_value);
                     config.X_winsize_y = (yyvsp[0].i_value);
                   }
#line 4549 "parser.c" /* yacc.c:1648  */
    break;

  case 198:
#line 1075 "parser.y" /* yacc.c:1648  */
    {
                     config.X_winsize_x = (yyvsp[-2].i_value);
                     config.X_winsize_y = (yyvsp[0].i_value);
                   }
#line 4558 "parser.c" /* yacc.c:1648  */
    break;

  case 199:
#line 1079 "parser.y" /* yacc.c:1648  */
    { config.X_gamma = (yyvsp[0].i_value); }
#line 4564 "parser.c" /* yacc.c:1648  */
    break;

  case 200:
#line 1080 "parser.y" /* yacc.c:1648  */
    { config.X_fullscreen = (yyvsp[0].i_value); }
#line 4570 "parser.c" /* yacc.c:1648  */
    break;

  case 201:
#line 1081 "parser.y" /* yacc.c:1648  */
    { config.vgaemu_memsize = (yyvsp[0].i_value); }
#line 4576 "parser.c" /* yacc.c:1648  */
    break;

  case 202:
#line 1082 "parser.y" /* yacc.c:1648  */
    { set_vesamodes((yyvsp[-1].i_value),(yyvsp[0].i_value),0);}
#line 4582 "parser.c" /* yacc.c:1648  */
    break;

  case 203:
#line 1083 "parser.y" /* yacc.c:1648  */
    { set_vesamodes((yyvsp[-2].i_value),(yyvsp[-1].i_value),(yyvsp[0].i_value));}
#line 4588 "parser.c" /* yacc.c:1648  */
    break;

  case 204:
#line 1084 "parser.y" /* yacc.c:1648  */
    { set_vesamodes((yyvsp[-2].i_value),(yyvsp[0].i_value),0);}
#line 4594 "parser.c" /* yacc.c:1648  */
    break;

  case 205:
#line 1086 "parser.y" /* yacc.c:1648  */
    { set_vesamodes((yyvsp[-4].i_value),(yyvsp[-2].i_value),(yyvsp[0].i_value));}
#line 4600 "parser.c" /* yacc.c:1648  */
    break;

  case 206:
#line 1087 "parser.y" /* yacc.c:1648  */
    { config.X_lfb = ((yyvsp[0].i_value)!=0); }
#line 4606 "parser.c" /* yacc.c:1648  */
    break;

  case 207:
#line 1088 "parser.y" /* yacc.c:1648  */
    { config.X_pm_interface = ((yyvsp[0].i_value)!=0); }
#line 4612 "parser.c" /* yacc.c:1648  */
    break;

  case 208:
#line 1089 "parser.y" /* yacc.c:1648  */
    { free(config.X_mgrab_key); config.X_mgrab_key = (yyvsp[0].s_value); }
#line 4618 "parser.c" /* yacc.c:1648  */
    break;

  case 209:
#line 1090 "parser.y" /* yacc.c:1648  */
    { config.X_background_pause = ((yyvsp[0].i_value)!=0); }
#line 4624 "parser.c" /* yacc.c:1648  */
    break;

  case 212:
#line 1097 "parser.y" /* yacc.c:1648  */
    { if (!priv_lvl) dexe_forbid_disk = 0; }
#line 4630 "parser.c" /* yacc.c:1648  */
    break;

  case 213:
#line 1098 "parser.y" /* yacc.c:1648  */
    {
			char *env = getenv("DISPLAY");
			if (env && env[0] && dexe_running) config.X = 1;
		}
#line 4639 "parser.c" /* yacc.c:1648  */
    break;

  case 214:
#line 1102 "parser.y" /* yacc.c:1648  */
    {
			char *env = getenv("DISPLAY");
			if (env && env[0] && dexe_running) config.X = 1;
			else if (dexe_running) {
			  yyerror("this DEXE requires X, giving up");
			  exit(99);
			}
		}
#line 4652 "parser.c" /* yacc.c:1648  */
    break;

  case 217:
#line 1117 "parser.y" /* yacc.c:1648  */
    { config.sb_base = (yyvsp[0].i_value); }
#line 4658 "parser.c" /* yacc.c:1648  */
    break;

  case 218:
#line 1118 "parser.y" /* yacc.c:1648  */
    { config.sb_dma = (yyvsp[0].i_value); }
#line 4664 "parser.c" /* yacc.c:1648  */
    break;

  case 219:
#line 1119 "parser.y" /* yacc.c:1648  */
    { config.sb_hdma = (yyvsp[0].i_value); }
#line 4670 "parser.c" /* yacc.c:1648  */
    break;

  case 220:
#line 1120 "parser.y" /* yacc.c:1648  */
    { config.sb_irq = (yyvsp[0].i_value); }
#line 4676 "parser.c" /* yacc.c:1648  */
    break;

  case 221:
#line 1121 "parser.y" /* yacc.c:1648  */
    { free(config.sb_mixer); config.sb_mixer = (yyvsp[0].s_value); }
#line 4682 "parser.c" /* yacc.c:1648  */
    break;

  case 222:
#line 1122 "parser.y" /* yacc.c:1648  */
    { free(config.sb_dsp); config.sb_dsp = (yyvsp[0].s_value); }
#line 4688 "parser.c" /* yacc.c:1648  */
    break;

  case 223:
#line 1123 "parser.y" /* yacc.c:1648  */
    { config.mpu401_base = (yyvsp[0].i_value); }
#line 4694 "parser.c" /* yacc.c:1648  */
    break;

  case 224:
#line 1124 "parser.y" /* yacc.c:1648  */
    { free(config.sound_driver); config.sound_driver = (yyvsp[0].s_value); }
#line 4700 "parser.c" /* yacc.c:1648  */
    break;

  case 227:
#line 1129 "parser.y" /* yacc.c:1648  */
    { config.oss_min_frags = (yyvsp[0].i_value); }
#line 4706 "parser.c" /* yacc.c:1648  */
    break;

  case 228:
#line 1130 "parser.y" /* yacc.c:1648  */
    { config.oss_max_frags = (yyvsp[0].i_value); }
#line 4712 "parser.c" /* yacc.c:1648  */
    break;

  case 229:
#line 1131 "parser.y" /* yacc.c:1648  */
    { config.oss_stalled_frags = (yyvsp[0].i_value); }
#line 4718 "parser.c" /* yacc.c:1648  */
    break;

  case 230:
#line 1132 "parser.y" /* yacc.c:1648  */
    { config.oss_do_post = (yyvsp[0].i_value); }
#line 4724 "parser.c" /* yacc.c:1648  */
    break;

  case 231:
#line 1133 "parser.y" /* yacc.c:1648  */
    { config.oss_min_extra_frags = (yyvsp[0].i_value); }
#line 4730 "parser.c" /* yacc.c:1648  */
    break;

  case 232:
#line 1134 "parser.y" /* yacc.c:1648  */
    { config.oss_dac_freq = (yyvsp[0].i_value); }
#line 4736 "parser.c" /* yacc.c:1648  */
    break;

  case 235:
#line 1142 "parser.y" /* yacc.c:1648  */
    { set_joy_device((yyvsp[0].s_value)); }
#line 4742 "parser.c" /* yacc.c:1648  */
    break;

  case 236:
#line 1143 "parser.y" /* yacc.c:1648  */
    { config.joy_dos_min = (yyvsp[0].i_value); }
#line 4748 "parser.c" /* yacc.c:1648  */
    break;

  case 237:
#line 1144 "parser.y" /* yacc.c:1648  */
    { config.joy_dos_max = (yyvsp[0].i_value); }
#line 4754 "parser.c" /* yacc.c:1648  */
    break;

  case 238:
#line 1145 "parser.y" /* yacc.c:1648  */
    { config.joy_granularity = (yyvsp[0].i_value); }
#line 4760 "parser.c" /* yacc.c:1648  */
    break;

  case 239:
#line 1146 "parser.y" /* yacc.c:1648  */
    { config.joy_latency = (yyvsp[0].i_value); }
#line 4766 "parser.c" /* yacc.c:1648  */
    break;

  case 242:
#line 1154 "parser.y" /* yacc.c:1648  */
    { config.cardtype = CARD_VGA; }
#line 4772 "parser.c" /* yacc.c:1648  */
    break;

  case 243:
#line 1155 "parser.y" /* yacc.c:1648  */
    { config.cardtype = CARD_MDA; }
#line 4778 "parser.c" /* yacc.c:1648  */
    break;

  case 244:
#line 1156 "parser.y" /* yacc.c:1648  */
    { config.cardtype = CARD_CGA; }
#line 4784 "parser.c" /* yacc.c:1648  */
    break;

  case 245:
#line 1157 "parser.y" /* yacc.c:1648  */
    { config.cardtype = CARD_EGA; }
#line 4790 "parser.c" /* yacc.c:1648  */
    break;

  case 246:
#line 1158 "parser.y" /* yacc.c:1648  */
    { config.cardtype = CARD_NONE; }
#line 4796 "parser.c" /* yacc.c:1648  */
    break;

  case 247:
#line 1160 "parser.y" /* yacc.c:1648  */
    {
		    config.chipset = (yyvsp[0].i_value);
                    c_printf("CHIPSET: %d\n", (yyvsp[0].i_value));
		    }
#line 4805 "parser.c" /* yacc.c:1648  */
    break;

  case 248:
#line 1164 "parser.y" /* yacc.c:1648  */
    { config.gfxmemsize = (yyvsp[0].i_value); }
#line 4811 "parser.c" /* yacc.c:1648  */
    break;

  case 249:
#line 1166 "parser.y" /* yacc.c:1648  */
    { config.vga = 1;
		    }
#line 4818 "parser.c" /* yacc.c:1648  */
    break;

  case 250:
#line 1169 "parser.y" /* yacc.c:1648  */
    { config.console_video = 1;
		    }
#line 4825 "parser.c" /* yacc.c:1648  */
    break;

  case 251:
#line 1171 "parser.y" /* yacc.c:1648  */
    { config.fullrestore = 1; }
#line 4831 "parser.c" /* yacc.c:1648  */
    break;

  case 252:
#line 1172 "parser.y" /* yacc.c:1648  */
    { config.fullrestore = 0; }
#line 4837 "parser.c" /* yacc.c:1648  */
    break;

  case 253:
#line 1173 "parser.y" /* yacc.c:1648  */
    { free(config.vbios_file); config.vbios_file = (yyvsp[0].s_value);
					  config.mapped_bios = 1;
					  config.vbios_copy = 0; }
#line 4845 "parser.c" /* yacc.c:1648  */
    break;

  case 254:
#line 1176 "parser.y" /* yacc.c:1648  */
    { free(config.vgaemubios_file); config.vgaemubios_file = (yyvsp[0].s_value); }
#line 4851 "parser.c" /* yacc.c:1648  */
    break;

  case 255:
#line 1177 "parser.y" /* yacc.c:1648  */
    { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
#line 4860 "parser.c" /* yacc.c:1648  */
    break;

  case 256:
#line 1181 "parser.y" /* yacc.c:1648  */
    { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
#line 4869 "parser.c" /* yacc.c:1648  */
    break;

  case 257:
#line 1186 "parser.y" /* yacc.c:1648  */
    {
		   config.vbios_seg = (yyvsp[0].i_value);
		   c_printf("CONF: VGA-BIOS-Segment %x\n", (yyvsp[0].i_value));
		   if (((yyvsp[0].i_value) != 0xe000) && ((yyvsp[0].i_value) != 0xc000))
		      {
		      config.vbios_seg = detect_vbios_seg();
		      if (config.vbios_seg == -1) config.vbios_seg = 0xc000;
		      c_printf("CONF: VGA-BIOS-Segment set to 0x%x\n", config.vbios_seg);
		      }
		   }
#line 4884 "parser.c" /* yacc.c:1648  */
    break;

  case 258:
#line 1197 "parser.y" /* yacc.c:1648  */
    {
		   config.vbios_size = (yyvsp[0].i_value);
		   c_printf("CONF: VGA-BIOS-Size %x\n", (yyvsp[0].i_value));
		   if (((yyvsp[0].i_value) != 0x8000) && ((yyvsp[0].i_value) != 0x10000))
		      {
		      config.vbios_size = detect_vbios_size();
		      if (config.vbios_size == -1) config.vbios_size = 0x10000;
		      c_printf("CONF: VGA-BIOS-Size set to 0x%x\n", config.vbios_size);
		      }
		   }
#line 4899 "parser.c" /* yacc.c:1648  */
    break;

  case 259:
#line 1207 "parser.y" /* yacc.c:1648  */
    { config.vbios_post = 1; }
#line 4905 "parser.c" /* yacc.c:1648  */
    break;

  case 260:
#line 1208 "parser.y" /* yacc.c:1648  */
    { config.dualmon = 1; }
#line 4911 "parser.c" /* yacc.c:1648  */
    break;

  case 261:
#line 1209 "parser.y" /* yacc.c:1648  */
    { config.force_vt_switch = 1; }
#line 4917 "parser.c" /* yacc.c:1648  */
    break;

  case 262:
#line 1210 "parser.y" /* yacc.c:1648  */
    { config.pci_video = 1; }
#line 4923 "parser.c" /* yacc.c:1648  */
    break;

  case 263:
#line 1212 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized video option '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 4930 "parser.c" /* yacc.c:1648  */
    break;

  case 267:
#line 1222 "parser.y" /* yacc.c:1648  */
    { config.term_esc_char = (yyvsp[0].i_value); }
#line 4936 "parser.c" /* yacc.c:1648  */
    break;

  case 268:
#line 1223 "parser.y" /* yacc.c:1648  */
    { config.term_updatefreq = (yyvsp[0].i_value); }
#line 4942 "parser.c" /* yacc.c:1648  */
    break;

  case 269:
#line 1224 "parser.y" /* yacc.c:1648  */
    { config.term_color = ((yyvsp[0].i_value)!=0); }
#line 4948 "parser.c" /* yacc.c:1648  */
    break;

  case 270:
#line 1226 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized terminal option '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 4955 "parser.c" /* yacc.c:1648  */
    break;

  case 274:
#line 1240 "parser.y" /* yacc.c:1648  */
    { set_debug_level('v', ((yyvsp[0].i_value)!=0)); }
#line 4961 "parser.c" /* yacc.c:1648  */
    break;

  case 275:
#line 1241 "parser.y" /* yacc.c:1648  */
    { set_debug_level('a', 0); }
#line 4967 "parser.c" /* yacc.c:1648  */
    break;

  case 276:
#line 1242 "parser.y" /* yacc.c:1648  */
    { set_debug_level('s', ((yyvsp[0].i_value)!=0)); }
#line 4973 "parser.c" /* yacc.c:1648  */
    break;

  case 277:
#line 1243 "parser.y" /* yacc.c:1648  */
    { set_debug_level('c', ((yyvsp[0].i_value)!=0)); }
#line 4979 "parser.c" /* yacc.c:1648  */
    break;

  case 278:
#line 1244 "parser.y" /* yacc.c:1648  */
    { set_debug_level('d', ((yyvsp[0].i_value)!=0)); }
#line 4985 "parser.c" /* yacc.c:1648  */
    break;

  case 279:
#line 1245 "parser.y" /* yacc.c:1648  */
    { set_debug_level('R', ((yyvsp[0].i_value)!=0)); }
#line 4991 "parser.c" /* yacc.c:1648  */
    break;

  case 280:
#line 1246 "parser.y" /* yacc.c:1648  */
    { set_debug_level('W', ((yyvsp[0].i_value)!=0)); }
#line 4997 "parser.c" /* yacc.c:1648  */
    break;

  case 281:
#line 1247 "parser.y" /* yacc.c:1648  */
    { set_debug_level('k', ((yyvsp[0].i_value)!=0)); }
#line 5003 "parser.c" /* yacc.c:1648  */
    break;

  case 282:
#line 1248 "parser.y" /* yacc.c:1648  */
    { set_debug_level('k', ((yyvsp[0].i_value)!=0)); }
#line 5009 "parser.c" /* yacc.c:1648  */
    break;

  case 283:
#line 1249 "parser.y" /* yacc.c:1648  */
    { set_debug_level('p', ((yyvsp[0].i_value)!=0)); }
#line 5015 "parser.c" /* yacc.c:1648  */
    break;

  case 284:
#line 1250 "parser.y" /* yacc.c:1648  */
    { set_debug_level('i', ((yyvsp[0].i_value)!=0)); }
#line 5021 "parser.c" /* yacc.c:1648  */
    break;

  case 285:
#line 1251 "parser.y" /* yacc.c:1648  */
    { set_debug_level('i', ((yyvsp[0].i_value)!=0)); }
#line 5027 "parser.c" /* yacc.c:1648  */
    break;

  case 286:
#line 1252 "parser.y" /* yacc.c:1648  */
    { set_debug_level('w', ((yyvsp[0].i_value)!=0)); }
#line 5033 "parser.c" /* yacc.c:1648  */
    break;

  case 287:
#line 1253 "parser.y" /* yacc.c:1648  */
    { set_debug_level('g', ((yyvsp[0].i_value)!=0)); }
#line 5039 "parser.c" /* yacc.c:1648  */
    break;

  case 288:
#line 1254 "parser.y" /* yacc.c:1648  */
    { set_debug_level('X', ((yyvsp[0].i_value)!=0)); }
#line 5045 "parser.c" /* yacc.c:1648  */
    break;

  case 289:
#line 1255 "parser.y" /* yacc.c:1648  */
    { set_debug_level('M', ((yyvsp[0].i_value)!=0)); }
#line 5051 "parser.c" /* yacc.c:1648  */
    break;

  case 290:
#line 1256 "parser.y" /* yacc.c:1648  */
    { set_debug_level('m', ((yyvsp[0].i_value)!=0)); }
#line 5057 "parser.c" /* yacc.c:1648  */
    break;

  case 291:
#line 1257 "parser.y" /* yacc.c:1648  */
    { set_debug_level('h', ((yyvsp[0].i_value)!=0)); }
#line 5063 "parser.c" /* yacc.c:1648  */
    break;

  case 292:
#line 1258 "parser.y" /* yacc.c:1648  */
    { set_debug_level('I', ((yyvsp[0].i_value)!=0)); }
#line 5069 "parser.c" /* yacc.c:1648  */
    break;

  case 293:
#line 1259 "parser.y" /* yacc.c:1648  */
    { set_debug_level('E', ((yyvsp[0].i_value)!=0)); }
#line 5075 "parser.c" /* yacc.c:1648  */
    break;

  case 294:
#line 1260 "parser.y" /* yacc.c:1648  */
    { set_debug_level('n', ((yyvsp[0].i_value)!=0)); }
#line 5081 "parser.c" /* yacc.c:1648  */
    break;

  case 295:
#line 1261 "parser.y" /* yacc.c:1648  */
    { set_debug_level('X', ((yyvsp[0].i_value)!=0)); }
#line 5087 "parser.c" /* yacc.c:1648  */
    break;

  case 296:
#line 1262 "parser.y" /* yacc.c:1648  */
    { set_debug_level('S', ((yyvsp[0].i_value)!=0)); }
#line 5093 "parser.c" /* yacc.c:1648  */
    break;

  case 297:
#line 1263 "parser.y" /* yacc.c:1648  */
    { set_debug_level('j', ((yyvsp[0].i_value)!=0)); }
#line 5099 "parser.c" /* yacc.c:1648  */
    break;

  case 298:
#line 1265 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized debug flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5105 "parser.c" /* yacc.c:1648  */
    break;

  case 302:
#line 1274 "parser.y" /* yacc.c:1648  */
    { free(mptr->dev); mptr->dev = (yyvsp[0].s_value); }
#line 5111 "parser.c" /* yacc.c:1648  */
    break;

  case 303:
#line 1275 "parser.y" /* yacc.c:1648  */
    { mptr->intdrv = TRUE; }
#line 5117 "parser.c" /* yacc.c:1648  */
    break;

  case 304:
#line 1276 "parser.y" /* yacc.c:1648  */
    { mptr->emulate3buttons = TRUE; }
#line 5123 "parser.c" /* yacc.c:1648  */
    break;

  case 305:
#line 1277 "parser.y" /* yacc.c:1648  */
    { mptr->baudRate = (yyvsp[0].i_value); }
#line 5129 "parser.c" /* yacc.c:1648  */
    break;

  case 306:
#line 1279 "parser.y" /* yacc.c:1648  */
    { if (mptr->type == MOUSE_MOUSESYSTEMS)
			 mptr->cleardtr = TRUE;
		      else
			 yyerror("option CLEARDTR is only valid for MicroSystems-mice");
		    }
#line 5139 "parser.c" /* yacc.c:1648  */
    break;

  case 307:
#line 1285 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_MICROSOFT;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 5148 "parser.c" /* yacc.c:1648  */
    break;

  case 308:
#line 1290 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_MS3BUTTON;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 5157 "parser.c" /* yacc.c:1648  */
    break;

  case 309:
#line 1295 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_MOUSESYSTEMS;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
/* is cstopb needed?  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL; */
		  }
#line 5167 "parser.c" /* yacc.c:1648  */
    break;

  case 310:
#line 1301 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_MMSERIES;
		  mptr->flags = CS8 | PARENB | PARODD | CREAD | CLOCAL | HUPCL;
		  }
#line 5176 "parser.c" /* yacc.c:1648  */
    break;

  case 311:
#line 1306 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_LOGITECH;
		  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL;
		  }
#line 5185 "parser.c" /* yacc.c:1648  */
    break;

  case 312:
#line 1311 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_PS2;
		  mptr->flags = 0;
		  }
#line 5194 "parser.c" /* yacc.c:1648  */
    break;

  case 313:
#line 1316 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_IMPS2;
		  mptr->flags = 0;
		  }
#line 5203 "parser.c" /* yacc.c:1648  */
    break;

  case 314:
#line 1321 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_MOUSEMAN;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 5212 "parser.c" /* yacc.c:1648  */
    break;

  case 315:
#line 1326 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_HITACHI;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
		  }
#line 5221 "parser.c" /* yacc.c:1648  */
    break;

  case 316:
#line 1331 "parser.y" /* yacc.c:1648  */
    {
		  mptr->type = MOUSE_BUSMOUSE;
		  mptr->flags = 0;
		  }
#line 5230 "parser.c" /* yacc.c:1648  */
    break;

  case 317:
#line 1336 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized mouse flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5236 "parser.c" /* yacc.c:1648  */
    break;

  case 321:
#line 1345 "parser.y" /* yacc.c:1648  */
    { keyb_layout((yyvsp[0].i_value)); }
#line 5242 "parser.c" /* yacc.c:1648  */
    break;

  case 322:
#line 1346 "parser.y" /* yacc.c:1648  */
    {keyb_layout((yyvsp[0].i_value));}
#line 5248 "parser.c" /* yacc.c:1648  */
    break;

  case 324:
#line 1347 "parser.y" /* yacc.c:1648  */
    { keyb_layout(KEYB_NO); }
#line 5254 "parser.c" /* yacc.c:1648  */
    break;

  case 325:
#line 1348 "parser.y" /* yacc.c:1648  */
    { keyb_layout(-1); }
#line 5260 "parser.c" /* yacc.c:1648  */
    break;

  case 326:
#line 1349 "parser.y" /* yacc.c:1648  */
    { config.console_keyb = (yyvsp[0].i_value); }
#line 5266 "parser.c" /* yacc.c:1648  */
    break;

  case 327:
#line 1351 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized keyboard flag '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value));}
#line 5273 "parser.c" /* yacc.c:1648  */
    break;

  case 331:
#line 1360 "parser.y" /* yacc.c:1648  */
    { keyb_mod('C', (yyvsp[-1].i_value), 0); }
#line 5279 "parser.c" /* yacc.c:1648  */
    break;

  case 333:
#line 1361 "parser.y" /* yacc.c:1648  */
    { keyb_mod('a', (yyvsp[-1].i_value), 0); }
#line 5285 "parser.c" /* yacc.c:1648  */
    break;

  case 335:
#line 1362 "parser.y" /* yacc.c:1648  */
    { keyb_mod('c', (yyvsp[-1].i_value), 0); }
#line 5291 "parser.c" /* yacc.c:1648  */
    break;

  case 337:
#line 1363 "parser.y" /* yacc.c:1648  */
    { keyb_mod(' ', (yyvsp[-1].i_value), 0); }
#line 5297 "parser.c" /* yacc.c:1648  */
    break;

  case 339:
#line 1364 "parser.y" /* yacc.c:1648  */
    { keyb_mod('S', (yyvsp[-1].i_value), 0); }
#line 5303 "parser.c" /* yacc.c:1648  */
    break;

  case 341:
#line 1365 "parser.y" /* yacc.c:1648  */
    { keyb_mod('A', (yyvsp[-1].i_value), 0); }
#line 5309 "parser.c" /* yacc.c:1648  */
    break;

  case 343:
#line 1366 "parser.y" /* yacc.c:1648  */
    { keyb_mod('N', (yyvsp[-1].i_value), 0); }
#line 5315 "parser.c" /* yacc.c:1648  */
    break;

  case 347:
#line 1373 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, (yyvsp[0].i_value), 1); }
#line 5321 "parser.c" /* yacc.c:1648  */
    break;

  case 348:
#line 1374 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_GRAVE, 1); }
#line 5327 "parser.c" /* yacc.c:1648  */
    break;

  case 349:
#line 1375 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_ACUTE, 1); }
#line 5333 "parser.c" /* yacc.c:1648  */
    break;

  case 350:
#line 1376 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_CIRCUMFLEX, 1); }
#line 5339 "parser.c" /* yacc.c:1648  */
    break;

  case 351:
#line 1377 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_TILDE, 1); }
#line 5345 "parser.c" /* yacc.c:1648  */
    break;

  case 352:
#line 1378 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_BREVE, 1); }
#line 5351 "parser.c" /* yacc.c:1648  */
    break;

  case 353:
#line 1379 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_ABOVEDOT, 1); }
#line 5357 "parser.c" /* yacc.c:1648  */
    break;

  case 354:
#line 1380 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_DIAERESIS, 1); }
#line 5363 "parser.c" /* yacc.c:1648  */
    break;

  case 355:
#line 1381 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_ABOVERING, 1); }
#line 5369 "parser.c" /* yacc.c:1648  */
    break;

  case 356:
#line 1382 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_DOUBLEACUTE, 1); }
#line 5375 "parser.c" /* yacc.c:1648  */
    break;

  case 357:
#line 1383 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_CEDILLA, 1); }
#line 5381 "parser.c" /* yacc.c:1648  */
    break;

  case 358:
#line 1384 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_VOID, 1); }
#line 5387 "parser.c" /* yacc.c:1648  */
    break;

  case 359:
#line 1385 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0,KEY_DEAD_OGONEK, 1); }
#line 5393 "parser.c" /* yacc.c:1648  */
    break;

  case 360:
#line 1386 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, KEY_DEAD_CARON, 1); }
#line 5399 "parser.c" /* yacc.c:1648  */
    break;

  case 361:
#line 1387 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, (yyvsp[0].i_value), 0); }
#line 5405 "parser.c" /* yacc.c:1648  */
    break;

  case 362:
#line 1388 "parser.y" /* yacc.c:1648  */
    { keyb_mod(0, (yyvsp[-1].i_value), 0); }
#line 5411 "parser.c" /* yacc.c:1648  */
    break;

  case 363:
#line 1389 "parser.y" /* yacc.c:1648  */
    {
			char *p = (yyvsp[0].s_value);
			while (*p) keyb_mod(0, *p++, 0);
			free((yyvsp[0].s_value));
		}
#line 5421 "parser.c" /* yacc.c:1648  */
    break;

  case 366:
#line 1401 "parser.y" /* yacc.c:1648  */
    { free(config.tty_lockdir); config.tty_lockdir = (yyvsp[0].s_value); }
#line 5427 "parser.c" /* yacc.c:1648  */
    break;

  case 367:
#line 1402 "parser.y" /* yacc.c:1648  */
    { free(config.tty_lockfile); config.tty_lockfile = (yyvsp[0].s_value); }
#line 5433 "parser.c" /* yacc.c:1648  */
    break;

  case 368:
#line 1403 "parser.y" /* yacc.c:1648  */
    { config.tty_lockbinary = TRUE; }
#line 5439 "parser.c" /* yacc.c:1648  */
    break;

  case 369:
#line 1405 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized ttylocks flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5445 "parser.c" /* yacc.c:1648  */
    break;

  case 373:
#line 1414 "parser.y" /* yacc.c:1648  */
    { free(sptr->dev); sptr->dev = (yyvsp[0].s_value);
					  if (!strcmp("/dev/mouse",sptr->dev)) sptr->mouse=1; }
#line 5452 "parser.c" /* yacc.c:1648  */
    break;

  case 374:
#line 1416 "parser.y" /* yacc.c:1648  */
    {
					   if (isatty(0)) {
					     sptr->virtual = TRUE;
					     sptr->pseudo = TRUE;
					     no_local_video = 1;
					     sptr->dev = strdup(ttyname(0));
					   } else {
					     error("FD 0 is not a tty, can't "
					           "use a virtual com port\n");
					     exit(1);
					   }
					  }
#line 5469 "parser.c" /* yacc.c:1648  */
    break;

  case 375:
#line 1428 "parser.y" /* yacc.c:1648  */
    { sptr->real_comport = (yyvsp[0].i_value);
					  com_port_used[(yyvsp[0].i_value)] = 1; }
#line 5476 "parser.c" /* yacc.c:1648  */
    break;

  case 376:
#line 1430 "parser.y" /* yacc.c:1648  */
    { sptr->base_port = (yyvsp[0].i_value); }
#line 5482 "parser.c" /* yacc.c:1648  */
    break;

  case 377:
#line 1431 "parser.y" /* yacc.c:1648  */
    { sptr->interrupt = (yyvsp[0].i_value); }
#line 5488 "parser.c" /* yacc.c:1648  */
    break;

  case 378:
#line 1432 "parser.y" /* yacc.c:1648  */
    { sptr->interrupt = (yyvsp[0].i_value); }
#line 5494 "parser.c" /* yacc.c:1648  */
    break;

  case 379:
#line 1433 "parser.y" /* yacc.c:1648  */
    { sptr->mouse = 1; }
#line 5500 "parser.c" /* yacc.c:1648  */
    break;

  case 380:
#line 1435 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized serial flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5506 "parser.c" /* yacc.c:1648  */
    break;

  case 384:
#line 1444 "parser.y" /* yacc.c:1648  */
    { c_printers = (yyvsp[0].i_value) - 1; }
#line 5512 "parser.c" /* yacc.c:1648  */
    break;

  case 385:
#line 1445 "parser.y" /* yacc.c:1648  */
    { pptr->prtcmd = (yyvsp[0].s_value); }
#line 5518 "parser.c" /* yacc.c:1648  */
    break;

  case 386:
#line 1446 "parser.y" /* yacc.c:1648  */
    { pptr->delay = (yyvsp[0].i_value); }
#line 5524 "parser.c" /* yacc.c:1648  */
    break;

  case 387:
#line 1447 "parser.y" /* yacc.c:1648  */
    { pptr->dev = (yyvsp[0].s_value); }
#line 5530 "parser.c" /* yacc.c:1648  */
    break;

  case 388:
#line 1448 "parser.y" /* yacc.c:1648  */
    { pptr->base_port = (yyvsp[0].i_value); }
#line 5536 "parser.c" /* yacc.c:1648  */
    break;

  case 389:
#line 1450 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized printer flag %s", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5542 "parser.c" /* yacc.c:1648  */
    break;

  case 391:
#line 1457 "parser.y" /* yacc.c:1648  */
    {
		  if (dptr->boot_name != NULL)
		    yyerror("Two names for a boot-image file or device given.");
		  dptr->boot_name = (yyvsp[0].s_value);
                  }
#line 5552 "parser.c" /* yacc.c:1648  */
    break;

  case 395:
#line 1468 "parser.y" /* yacc.c:1648  */
    { dptr->wantrdonly = 1; }
#line 5558 "parser.c" /* yacc.c:1648  */
    break;

  case 396:
#line 1469 "parser.y" /* yacc.c:1648  */
    { dptr->default_cmos = THREE_INCH_FLOPPY; }
#line 5564 "parser.c" /* yacc.c:1648  */
    break;

  case 397:
#line 1470 "parser.y" /* yacc.c:1648  */
    { dptr->default_cmos = THREE_INCH_288MFLOP; }
#line 5570 "parser.c" /* yacc.c:1648  */
    break;

  case 398:
#line 1471 "parser.y" /* yacc.c:1648  */
    { dptr->default_cmos = THREE_INCH_720KFLOP; }
#line 5576 "parser.c" /* yacc.c:1648  */
    break;

  case 399:
#line 1472 "parser.y" /* yacc.c:1648  */
    { dptr->default_cmos = ATAPI_FLOPPY; }
#line 5582 "parser.c" /* yacc.c:1648  */
    break;

  case 400:
#line 1473 "parser.y" /* yacc.c:1648  */
    { dptr->default_cmos = FIVE_INCH_FLOPPY; }
#line 5588 "parser.c" /* yacc.c:1648  */
    break;

  case 401:
#line 1474 "parser.y" /* yacc.c:1648  */
    { dptr->diskcyl4096 = 1; }
#line 5594 "parser.c" /* yacc.c:1648  */
    break;

  case 402:
#line 1475 "parser.y" /* yacc.c:1648  */
    { dptr->sectors = (yyvsp[0].i_value); }
#line 5600 "parser.c" /* yacc.c:1648  */
    break;

  case 403:
#line 1476 "parser.y" /* yacc.c:1648  */
    { dptr->tracks = (yyvsp[0].i_value); }
#line 5606 "parser.c" /* yacc.c:1648  */
    break;

  case 404:
#line 1477 "parser.y" /* yacc.c:1648  */
    { dptr->tracks = (yyvsp[0].i_value); }
#line 5612 "parser.c" /* yacc.c:1648  */
    break;

  case 405:
#line 1478 "parser.y" /* yacc.c:1648  */
    { dptr->heads = (yyvsp[0].i_value); }
#line 5618 "parser.c" /* yacc.c:1648  */
    break;

  case 406:
#line 1479 "parser.y" /* yacc.c:1648  */
    { dptr->header = (yyvsp[0].i_value); }
#line 5624 "parser.c" /* yacc.c:1648  */
    break;

  case 407:
#line 1481 "parser.y" /* yacc.c:1648  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[-1].s_value);
		  }
#line 5634 "parser.c" /* yacc.c:1648  */
    break;

  case 408:
#line 1487 "parser.y" /* yacc.c:1648  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5644 "parser.c" /* yacc.c:1648  */
    break;

  case 409:
#line 1493 "parser.y" /* yacc.c:1648  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk-image file given.");
		  dptr->type = IMAGE;
		  dptr->header = HEADER_SIZE;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5656 "parser.c" /* yacc.c:1648  */
    break;

  case 410:
#line 1501 "parser.y" /* yacc.c:1648  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk given.");
		  dptr->type = HDISK;
		  dptr->dev_name = (yyvsp[-1].s_value);
		  }
#line 5667 "parser.c" /* yacc.c:1648  */
    break;

  case 411:
#line 1508 "parser.y" /* yacc.c:1648  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a floppy-device given.");
		  dptr->type = FLOPPY;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5678 "parser.c" /* yacc.c:1648  */
    break;

  case 412:
#line 1515 "parser.y" /* yacc.c:1648  */
    {
                  yywarn("{ partition \"%s\" %d } the"
			 " token '%d' is ignored and can be removed.",
			 (yyvsp[-2].s_value),(yyvsp[-1].i_value),(yyvsp[-1].i_value));
		  do_part((yyvsp[-2].s_value));
		  }
#line 5689 "parser.c" /* yacc.c:1648  */
    break;

  case 413:
#line 1522 "parser.y" /* yacc.c:1648  */
    { do_part((yyvsp[-1].s_value)); }
#line 5695 "parser.c" /* yacc.c:1648  */
    break;

  case 414:
#line 1524 "parser.y" /* yacc.c:1648  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a directory given.");
		  dptr->type = DIR_TYPE;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5706 "parser.c" /* yacc.c:1648  */
    break;

  case 415:
#line 1531 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized disk flag '%s'\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5712 "parser.c" /* yacc.c:1648  */
    break;

  case 419:
#line 1541 "parser.y" /* yacc.c:1648  */
    {
		   c_printf("CONF: I/O port 0x%04x\n", (unsigned short)(yyvsp[0].i_value));
	           allow_io((yyvsp[0].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (abs(portspeed)) portspeed += ((portspeed>0) ? 1 : -1);
	           }
#line 5723 "parser.c" /* yacc.c:1648  */
    break;

  case 420:
#line 1548 "parser.y" /* yacc.c:1648  */
    {
	           allow_io((yyvsp[-1].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (abs(portspeed)) portspeed += ((portspeed>0) ? 1 : -1);
	           }
#line 5733 "parser.c" /* yacc.c:1648  */
    break;

  case 421:
#line 1554 "parser.y" /* yacc.c:1648  */
    {
		   if (abs(portspeed) > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[-1].i_value), (unsigned short)(yyvsp[0].i_value));
		   allow_io((yyvsp[-1].i_value), (yyvsp[0].i_value) - (yyvsp[-1].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
#line 5747 "parser.c" /* yacc.c:1648  */
    break;

  case 422:
#line 1564 "parser.y" /* yacc.c:1648  */
    {
		   if (abs(portspeed) > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[-2].i_value), (unsigned short)(yyvsp[0].i_value));
		   allow_io((yyvsp[-2].i_value), (yyvsp[0].i_value) - (yyvsp[-2].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
#line 5761 "parser.c" /* yacc.c:1648  */
    break;

  case 423:
#line 1573 "parser.y" /* yacc.c:1648  */
    { ports_permission = IO_READ; }
#line 5767 "parser.c" /* yacc.c:1648  */
    break;

  case 424:
#line 1574 "parser.y" /* yacc.c:1648  */
    { ports_permission = IO_WRITE; }
#line 5773 "parser.c" /* yacc.c:1648  */
    break;

  case 425:
#line 1575 "parser.y" /* yacc.c:1648  */
    { ports_permission = IO_RDWR; }
#line 5779 "parser.c" /* yacc.c:1648  */
    break;

  case 426:
#line 1576 "parser.y" /* yacc.c:1648  */
    { ports_ormask = (yyvsp[0].i_value); }
#line 5785 "parser.c" /* yacc.c:1648  */
    break;

  case 427:
#line 1577 "parser.y" /* yacc.c:1648  */
    { ports_andmask = (yyvsp[0].i_value); }
#line 5791 "parser.c" /* yacc.c:1648  */
    break;

  case 428:
#line 1578 "parser.y" /* yacc.c:1648  */
    { portspeed = 1; }
#line 5797 "parser.c" /* yacc.c:1648  */
    break;

  case 429:
#line 1579 "parser.y" /* yacc.c:1648  */
    { portspeed = -1; }
#line 5803 "parser.c" /* yacc.c:1648  */
    break;

  case 430:
#line 1580 "parser.y" /* yacc.c:1648  */
    { strcpy(dev_name,(yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5809 "parser.c" /* yacc.c:1648  */
    break;

  case 431:
#line 1582 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized port command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5816 "parser.c" /* yacc.c:1648  */
    break;

  case 435:
#line 1591 "parser.y" /* yacc.c:1648  */
    { register_port_traceing((yyvsp[0].i_value), (yyvsp[0].i_value)); }
#line 5822 "parser.c" /* yacc.c:1648  */
    break;

  case 436:
#line 1593 "parser.y" /* yacc.c:1648  */
    { register_port_traceing((yyvsp[-1].i_value), (yyvsp[-1].i_value)); }
#line 5828 "parser.c" /* yacc.c:1648  */
    break;

  case 437:
#line 1595 "parser.y" /* yacc.c:1648  */
    { register_port_traceing((yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5834 "parser.c" /* yacc.c:1648  */
    break;

  case 438:
#line 1597 "parser.y" /* yacc.c:1648  */
    { register_port_traceing((yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5840 "parser.c" /* yacc.c:1648  */
    break;

  case 439:
#line 1598 "parser.y" /* yacc.c:1648  */
    { clear_port_traceing(); }
#line 5846 "parser.c" /* yacc.c:1648  */
    break;

  case 440:
#line 1600 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized port trace command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5853 "parser.c" /* yacc.c:1648  */
    break;

  case 444:
#line 1610 "parser.y" /* yacc.c:1648  */
    { set_irq_value(1, (yyvsp[0].i_value)); }
#line 5859 "parser.c" /* yacc.c:1648  */
    break;

  case 445:
#line 1611 "parser.y" /* yacc.c:1648  */
    { set_irq_value(1, (yyvsp[-1].i_value)); }
#line 5865 "parser.c" /* yacc.c:1648  */
    break;

  case 446:
#line 1612 "parser.y" /* yacc.c:1648  */
    { set_irq_value(0x10001, (yyvsp[0].i_value)); }
#line 5871 "parser.c" /* yacc.c:1648  */
    break;

  case 447:
#line 1613 "parser.y" /* yacc.c:1648  */
    { set_irq_range(1, (yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5877 "parser.c" /* yacc.c:1648  */
    break;

  case 448:
#line 1614 "parser.y" /* yacc.c:1648  */
    { set_irq_range(1, (yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5883 "parser.c" /* yacc.c:1648  */
    break;

  case 449:
#line 1615 "parser.y" /* yacc.c:1648  */
    { set_irq_range(0x10001, (yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5889 "parser.c" /* yacc.c:1648  */
    break;

  case 450:
#line 1616 "parser.y" /* yacc.c:1648  */
    { set_irq_range(0x10001, (yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5895 "parser.c" /* yacc.c:1648  */
    break;

  case 451:
#line 1618 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized irqpassing command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5902 "parser.c" /* yacc.c:1648  */
    break;

  case 455:
#line 1629 "parser.y" /* yacc.c:1648  */
    {
		     config.ems_size = (yyvsp[0].i_value);
		     if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
	           }
#line 5911 "parser.c" /* yacc.c:1648  */
    break;

  case 456:
#line 1634 "parser.y" /* yacc.c:1648  */
    {
		     config.ems_size = (yyvsp[-1].i_value);
		     if ((yyvsp[-1].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[-1].i_value));
	           }
#line 5920 "parser.c" /* yacc.c:1648  */
    break;

  case 457:
#line 1639 "parser.y" /* yacc.c:1648  */
    {
		     config.ems_size = (yyvsp[0].i_value);
		     if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
		   }
#line 5929 "parser.c" /* yacc.c:1648  */
    break;

  case 458:
#line 1644 "parser.y" /* yacc.c:1648  */
    {
/* is there a technical reason why the EMS frame can't be at 0xC0000 or
   0xA0000 if there's space? */
#if 0
		     if ( (((yyvsp[0].i_value) & 0xfc00)>=0xc800) && (((yyvsp[0].i_value) & 0xfc00)<=0xe000) ) {
		       config.ems_frame = (yyvsp[0].i_value) & 0xfc00;
		       c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		     }
		     else yyerror("wrong EMS-frame: 0x%04x", (yyvsp[0].i_value));
#endif
	             config.ems_frame = (yyvsp[0].i_value) & 0xfc00;
		     c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		   }
#line 5947 "parser.c" /* yacc.c:1648  */
    break;

  case 459:
#line 1658 "parser.y" /* yacc.c:1648  */
    {
		     config.ems_uma_pages = (yyvsp[0].i_value);
		   }
#line 5955 "parser.c" /* yacc.c:1648  */
    break;

  case 460:
#line 1662 "parser.y" /* yacc.c:1648  */
    {
		     config.ems_cnv_pages = (yyvsp[0].i_value);
		   }
#line 5963 "parser.c" /* yacc.c:1648  */
    break;

  case 461:
#line 1666 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized ems command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5970 "parser.c" /* yacc.c:1648  */
    break;

  case 465:
#line 1677 "parser.y" /* yacc.c:1648  */
    {
                     if (!register_hardware_ram('h', (yyvsp[0].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[0].i_value));
                     }
	           }
#line 5980 "parser.c" /* yacc.c:1648  */
    break;

  case 466:
#line 1683 "parser.y" /* yacc.c:1648  */
    {
                     if (!register_hardware_ram('h', (yyvsp[-1].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-1].i_value));
                     }
	           }
#line 5990 "parser.c" /* yacc.c:1648  */
    break;

  case 467:
#line 1689 "parser.y" /* yacc.c:1648  */
    {
                     if (register_hardware_ram('h', (yyvsp[-1].i_value), (yyvsp[0].i_value) - (yyvsp[-1].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[-1].i_value), (yyvsp[0].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-1].i_value));
		   }
#line 6001 "parser.c" /* yacc.c:1648  */
    break;

  case 468:
#line 1696 "parser.y" /* yacc.c:1648  */
    {
                     if (register_hardware_ram('h', (yyvsp[-2].i_value), (yyvsp[0].i_value) - (yyvsp[-2].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[-2].i_value), (yyvsp[0].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-2].i_value));
		   }
#line 6012 "parser.c" /* yacc.c:1648  */
    break;

  case 469:
#line 1703 "parser.y" /* yacc.c:1648  */
    { yyerror("unrecognized hardware ram command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 6019 "parser.c" /* yacc.c:1648  */
    break;

  case 473:
#line 1717 "parser.y" /* yacc.c:1648  */
    {
			if ((yyvsp[0].i_value) == -2) {
				yyerror("got 'on', expected 'off' or an integer");
			}
		}
#line 6029 "parser.c" /* yacc.c:1648  */
    break;

  case 474:
#line 1724 "parser.y" /* yacc.c:1648  */
    {
			if ( (yyvsp[0].i_value) && (((yyvsp[0].i_value) < 2) || ((yyvsp[0].i_value) > 15)) ) {
				yyerror("got '%d', expected 'off' or an integer 2..15", (yyvsp[0].i_value));
			} 
		}
#line 6039 "parser.c" /* yacc.c:1648  */
    break;

  case 475:
#line 1733 "parser.y" /* yacc.c:1648  */
    { (yyval.i_value) = SPKR_OFF; }
#line 6045 "parser.c" /* yacc.c:1648  */
    break;

  case 476:
#line 1734 "parser.y" /* yacc.c:1648  */
    { (yyval.i_value) = SPKR_NATIVE; }
#line 6051 "parser.c" /* yacc.c:1648  */
    break;

  case 477:
#line 1735 "parser.y" /* yacc.c:1648  */
    { (yyval.i_value) = SPKR_EMULATED; }
#line 6057 "parser.c" /* yacc.c:1648  */
    break;

  case 478:
#line 1736 "parser.y" /* yacc.c:1648  */
    { yyerror("got '%s', expected 'emulated' or 'native'", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 6064 "parser.c" /* yacc.c:1648  */
    break;

  case 479:
#line 1738 "parser.y" /* yacc.c:1648  */
    { yyerror("expected 'emulated' or 'native'"); }
#line 6070 "parser.c" /* yacc.c:1648  */
    break;

  case 480:
#line 1743 "parser.y" /* yacc.c:1648  */
    { (yyval.i_value) = 0; }
#line 6076 "parser.c" /* yacc.c:1648  */
    break;

  case 481:
#line 1744 "parser.y" /* yacc.c:1648  */
    { (yyval.i_value) = 3; }
#line 6082 "parser.c" /* yacc.c:1648  */
    break;

  case 482:
#line 1745 "parser.y" /* yacc.c:1648  */
    { (yyval.i_value) = 4; }
#line 6088 "parser.c" /* yacc.c:1648  */
    break;

  case 483:
#line 1746 "parser.y" /* yacc.c:1648  */
    { (yyval.i_value) = 5; }
#line 6094 "parser.c" /* yacc.c:1648  */
    break;

  case 484:
#line 1747 "parser.y" /* yacc.c:1648  */
    { (yyval.i_value) = 6; }
#line 6100 "parser.c" /* yacc.c:1648  */
    break;

  case 485:
#line 1748 "parser.y" /* yacc.c:1648  */
    { yyerror("got '%s', expected 'off', 'vm86' or 'full'", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 6107 "parser.c" /* yacc.c:1648  */
    break;

  case 486:
#line 1750 "parser.y" /* yacc.c:1648  */
    { yyerror("expected 'off', 'vm86' or 'full'"); }
#line 6113 "parser.c" /* yacc.c:1648  */
    break;

  case 489:
#line 1757 "parser.y" /* yacc.c:1648  */
    { set_internal_charset ((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 6119 "parser.c" /* yacc.c:1648  */
    break;

  case 490:
#line 1758 "parser.y" /* yacc.c:1648  */
    { set_external_charset ((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 6125 "parser.c" /* yacc.c:1648  */
    break;


#line 6129 "parser.c" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1761 "parser.y" /* yacc.c:1907  */


	/* features */

static void handle_features(int which, int value)
{
  if ((which < 0)
	|| (which >= (sizeof(config.features) / sizeof(config.features[0])))) {
    c_printf("CONF: wrong feature number %d\n", which);
    return;
  }
  config.features[which] = value;
  c_printf("CONF: feature %d set to %d\n", which, value);
}

	/* joystick */

static void set_joy_device(char *devstring)
{
  char *spacepos;

  free(config.joy_device[0]);
  config.joy_device[0] = devstring;
  config.joy_device[1] = NULL;
  spacepos = strchr(devstring, ' ');
  if (spacepos != NULL) {
    *spacepos = '\0';
    config.joy_device[1] = spacepos + 1;
  }
}

	/* mouse */

static void start_mouse(void)
{
  mptr = &config.mouse;
  mptr->fd = -1;
}

static void stop_mouse(void)
{
  c_printf("MOUSE: %s, type %x using internaldriver: %s, emulate3buttons: %s baudrate: %d\n", 
        mptr->dev && mptr->dev[0] ? mptr->dev : "no device specified",
        mptr->type, mptr->intdrv ? "yes" : "no", 
        mptr->emulate3buttons ? "yes" : "no", mptr->baudRate);
}

	/* debug */

static void start_ports(void)
{
  if (priv_lvl)
    yyerror("Can not change port privileges in user config file");
  ports_permission = IO_RDWR;
  ports_ormask = 0;
  ports_andmask = 0xFFFF;
}

	/* debug */

static void start_debug(void)
{
  set_debug_level('a', 0);	      /* Default is no debugging output at all */
}

	/* video */

static void start_video(void)
{
  free(config.vbios_file);
  config.vbios_file = NULL;
  config.vbios_copy = 0;
  config.vbios_seg  = 0xc000;
  config.vbios_size = 0x10000;
  config.console_video = 0;
  config.cardtype = CARD_NONE;
  config.chipset = PLAINVGA;
  config.mapped_bios = 0;
  config.vga = 0;
  config.gfxmemsize = 256;
  config.fullrestore = 0;
  config.dualmon = 0;
  config.force_vt_switch = 0;
}

static void stop_video(void)
{
  if (priv_lvl)
    config.console_video = 0;

  if ((config.cardtype != CARD_VGA) || !config.console_video) {
    config.vga = 0;
  }
}

	/* vesa modes */
static void set_vesamodes(int width, int height, int color_bits)
{
  vesamode_type *vmt = malloc(sizeof *vmt);
  if(vmt != NULL) {
    vmt->width = width;
    vmt->height = height;
    vmt->color_bits = color_bits;
    vmt->next = config.vesamode_list;
    config.vesamode_list = vmt;
  }
}

	/* vbios detection */
static int auto_vbios_seg = -1;
static int auto_vbios_size = -1;

static void detect_vbios(void)
{
  unsigned char c[0x21];
  int foffset;

  if (auto_vbios_seg != -1) return;
  if (!can_do_root_stuff || config.vbios_file) return;
  for (foffset = 0xc0000; foffset < 0xf0000; foffset += 0x800) {
    load_file("/dev/mem", foffset, c, sizeof(c));
    if (c[0]==0x55 && c[1]==0xaa
        && c[0x1e]=='I' && c[0x1f]=='B' && c[0x20]=='M') {
      auto_vbios_seg = foffset >> 4;
      auto_vbios_size = c[2]*0x200;
      break;
    }
  }
}

static int detect_vbios_seg(void)
{
  detect_vbios();
  return auto_vbios_seg;
}

static int detect_vbios_size(void)
{
  detect_vbios();
  return auto_vbios_size;
}

static void stop_ttylocks(void)
{
  c_printf("SER: directory %s namestub %s binary %s\n", config.tty_lockdir,
	   config.tty_lockfile,(config.tty_lockbinary?"Yes":"No"));
}

	/* serial */

static void start_serial(void)
{
  if (c_ser >= MAX_SER)
    sptr = &nullser;
  else {
    /* The defaults for interrupt, base_port, real_comport and dev are 
    ** automatically filled in inside the do_ser_init routine of serial.c
    */
    sptr = &com[c_ser];
    sptr->dev = NULL;
    sptr->interrupt = 0; 
    sptr->base_port = 0;
    sptr->real_comport = 0;
    sptr->fd = -1;
    sptr->mouse = 0;
    sptr->virtual = FALSE;
    sptr->pseudo = FALSE;
  }
}


static void stop_serial(void)
{
  if (sptr->dev[0] == '\0')
    return;
  if (c_ser >= MAX_SER) {
    c_printf("SER: too many ports, ignoring %s\n", sptr->dev);
    return;
  }
  c_ser++;
  config.num_ser = c_ser;
  c_printf("SER: %s port %x int %x\n", sptr->dev, sptr->base_port,
	   sptr->interrupt);
}

	/* keyboard */

static int keyboard_statement_already = 0;

static void start_keyboard(void)
{
  keyb_layout(KEYB_USER); /* NOTE: the default has changed, --Hans, 971204 */
  config.console_keyb = 0;
  keyboard_statement_already = 1;
}

static void stop_terminal(void)
{
  if (config.term_updatefreq > 100) {
    yywarn("terminal updatefreq too large (too slow)!");
    config.term_updatefreq = 100;
  } 
}

	/* printer */

static void start_printer(void)
{
  pptr->prtcmd = NULL;
  pptr->dev = NULL;
  pptr->file = NULL;
  pptr->remaining = -1;
  pptr->delay = 10;
}

static void stop_printer(void)
{
  printer_config(c_printers, pptr);
  c_printf("CONF(LPT%d) f: %s   c: %s  t: %d  port: %x\n",
           c_printers, pptr->dev, pptr->prtcmd,
           pptr->delay, pptr->base_port);
  c_printers++;
  if (c_printers > config.num_lpt)
    config.num_lpt = c_printers;
}

	/* disk */

static void start_bootdisk(void)
{
  if (config.bootdisk)           /* Already a bootdisk configured ? */
    yyerror("There is already a bootdisk configured");
      
  dptr = &bootdisk;              /* set pointer do bootdisk-struct */
      
  dptr->diskcyl4096 = 0;
  dptr->sectors = 0;             /* setup default-values           */
  dptr->heads   = 0;
  dptr->tracks  = 0;
  dptr->type    = FLOPPY;
  dptr->default_cmos = THREE_INCH_FLOPPY;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->boot_name = NULL;
  dptr->wantrdonly = 0;
  dptr->header = 0;
}

static void start_floppy(void)
{
  if (c_fdisks >= MAX_FDISKS)
    {
    yyerror("There are too many floppy disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &disktab[c_fdisks];

  dptr->sectors = 0;             /* setup default values */
  dptr->heads   = 0;
  dptr->tracks  = 0;
  dptr->type    = FLOPPY;
  dptr->default_cmos = THREE_INCH_FLOPPY;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->boot_name = NULL;
  dptr->wantrdonly = 0;
  dptr->header = 0;
}

static void start_disk(void)
{
  if (c_hdisks >= MAX_HDISKS) 
    {
    yyerror("There are too many hard disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &hdisktab[c_hdisks];
      
  dptr->type    =  NODISK;
  dptr->sectors = -1;
  dptr->heads   = -1;
  dptr->tracks  = -1;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->boot_name = NULL;
  dptr->wantrdonly = 0;
  dptr->header = 0;
  dptr->dexeflags = 0;
}

static void start_vnet(char *mode) {
  if (strcmp(mode, "tap") == 0) {
    config.vnet = VNET_TYPE_TAP;
    return;
  }
  IFCLASS(CL_NET) {}
  if (strlen(mode) == 0 || strcmp(mode, "direct") == 0)
    config.vnet = VNET_TYPE_ETH;
  else if (strcmp(mode, "dosnet") == 0)
    config.vnet = VNET_TYPE_DSN;
  else {
    error("Unknown vnet mode \"%s\"\n", mode);
    config.exitearly = 1;
  } 
}

static void do_part(char *dev)
{
  if (dptr->dev_name != NULL)
    yyerror("Two names for a partition given.");
  dptr->type = PARTITION;
  dptr->dev_name = dev;
#ifdef __linux__
  dptr->part_info.number = atoi(dptr->dev_name+8);
#endif
  if (dptr->part_info.number == 0) 
    yyerror("%s must be a PARTITION, can't find number suffix!\n",
   	    dptr->dev_name);
}

static void stop_disk(int token)
{
#ifdef __linux__
  FILE   *f;
  struct mntent *mtab;
#endif
  int    mounted_rw;

  if (dexe_running && dexe_forbid_disk)
    return;
  if (dptr == &nulldisk)              /* is there any disk? */
    return;                           /* no, nothing to do */

  if (!dptr->dev_name)                /* Is there a file/device-name? */
    yyerror("disk: no device/file-name given!");
  else                                /* check the file/device for existance */
    {
      struct stat file_status;        /* date for checking that file */

      c_printf("device: %s ", dptr->dev_name);
      if (stat(dptr->dev_name,&file_status) != 0) { /* Does this file exist? */
	 if (config.install ||
	     strcmp(dptr->dev_name, DOSEMUHDIMAGE_DEFAULT"/drives/*") == 0) {
	    /* default setting: display a menu */
	    dptr->type = DIR_TYPE;
	    if (!config.install)
	       config.install = "";
	 } else
	    yyerror("Disk-device/file %s doesn't exist.",dptr->dev_name);
      }
    }

  if (dptr->type == NODISK)    /* Is it one of bootdisk, floppy, harddisk ? */
    yyerror("disk: no device/file-name given!"); /* No, error */
  else
    c_printf("type %d ", dptr->type);

  if (dptr->type == PARTITION) {
    c_printf("partition# %d ", dptr->part_info.number);
#ifdef __linux__
    mtab = NULL;
    if ((f = setmntent(MOUNTED, "r")) != NULL) {
      while ((mtab = getmntent(f)))
        if (!strcmp(dptr->dev_name, mtab->mnt_fsname)) break;
      endmntent(f);
    }
    if (mtab) {
      mounted_rw = ( hasmntopt(mtab, MNTOPT_RW) != NULL );
      if (mounted_rw && !dptr->wantrdonly) 
        yyerror("\n\nYou specified '%s' for read-write Direct Partition Access,"
                "\nit is currently mounted read-write on '%s' !!!\n",
                dptr->dev_name, mtab->mnt_dir);
      else if (mounted_rw) 
        yywarn("You specified '%s' for read-only Direct Partition Access,"
               "\n         it is currently mounted read-write on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
      else if (!dptr->wantrdonly) 
        yywarn("You specified '%s' for read-write Direct Partition Access,"
               "\n         it is currently mounted read-only on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
    }
#endif
  }

  if (dptr->header)
    c_printf("header_size: %ld ", (long) dptr->header);

  c_printf("h: %d  s: %d   t: %d", dptr->heads, dptr->sectors,
	   dptr->tracks);

  if (token == BOOTDISK) {
    config.bootdisk = 1;
    use_bootdisk = 1;
    c_printf(" bootdisk\n");
  }
  else if (token == L_FLOPPY) {
    c_printf(" floppy %c:\n", 'A'+c_fdisks);
    c_fdisks++;
    config.fdisks = c_fdisks;
  }
  else {
    c_printf(" drive %c:\n", 'C'+c_hdisks);
    c_hdisks++;
    config.hdisks = c_hdisks;
  }
}

	/* keyboard */

void keyb_layout(int layout)
{
  struct keytable_entry *kt = keytable_list;
  if (layout == -1) {
    /* auto: do it later */
    config.keytable = NULL;
    return;
  }
  while (kt->name) {
    if (kt->keyboard == layout) {
      if (kt->flags & KT_ALTERNATE) {
        c_printf("CONF: Alternate keyboard-layout %s\n", kt->name);
        config.altkeytable = kt;
      } else {
      c_printf("CONF: Keyboard-layout %s\n", kt->name);
      config.keytable = kt;
      }
      return;
    }
    kt++;
  }
  c_printf("CONF: ERROR -- Keyboard has incorrect number!!!\n");
}

static void keytable_start(int layout)
{
  static struct keytable_entry *saved_kt = 0;
  if (layout == -1) {
    if (keyboard_statement_already) {
      if (config.keytable != saved_kt) {
        yywarn("keytable changed to %s table, but previously was defined %s\n",
                config.keytable->name, saved_kt->name);
      }
    }
  }
  else {
    saved_kt = config.keytable;
    keyb_layout(layout);
  }
}

static void keytable_stop(void)
{
  keytable_start(-1);
}

static void dump_keytables_to_file(char *name)
{
  FILE * f;
  struct keytable_entry *kt = keytable_list;

  f = fopen(name, "w");
  if (!f) {
    error("cannot create keytable file %s\n", name);
    exit(1);
  }
  
  while (kt->name) {
    dump_keytable(f, kt);
    kt++;
  }
  fclose(f);
  exit(0);
}

static void set_irq_value(int bits, int i1)
{
  if ((i1>2) && (i1<=15)) {
    config.sillyint |= (bits << i1);
    c_printf("CONF: IRQ %d for irqpassing", i1);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
  else yyerror("wrong IRQ for irqpassing command: %d", i1);
}

static void set_irq_range(int bits, int i1, int i2) {
  int i;
  if ( (i1<3) || (i1>15) || (i2<3) || (i2>15) || (i1 > i2 ) ) {
    yyerror("wrong IRQ range for irqpassing command: %d .. %d", i1, i2);
  }
  else {
    for (i=i1; i<=i2; i++) config.sillyint |= (bits << i);
    c_printf("CONF: range of IRQs for irqpassing %d .. %d", i1, i2);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
}


	/* errors & warnings */

void yywarn(char* string, ...)
{
  va_list vars;
  va_start(vars, string);
  fprintf(stderr, "Warning: ");
  vfprintf(stderr, string, vars);
  fprintf(stderr, "\n");
  va_end(vars);
  warnings++;
}

void yyerror(char* string, ...)
{
  va_list vars;
  va_start(vars, string);
  if (include_stack_ptr != 0 && !last_include) {
	  int i;
	  fprintf(stderr, "In file included from %s:%d\n",
		  include_fnames[0], include_lines[0]);
	  for(i = 1; i < include_stack_ptr; i++) {
		  fprintf(stderr, "                 from %s:%d\n",
			  include_fnames[i], include_lines[i]);
	  }
	  last_include = 1;
  }
  fprintf(stderr, "Error in %s: (line %.3d) ", 
	  include_fnames[include_stack_ptr], line_count);
  vfprintf(stderr, string, vars);
  fprintf(stderr, "\n");
  va_end(vars);
  errors++;
}


/*
 * open_file - opens the configuration-file named *filename and returns
 *             a file-pointer. The error/warning-counters are reset to zero.
 */

static FILE *open_file(char *filename)
{
  errors   = 0;                  /* Reset error counter */
  warnings = 0;                  /* Reset counter for warnings */

  if (!filename) return 0;
  return fopen(filename, "r"); /* Open config-file */
}

/*
 * close_file - Close the configuration file and issue a message about
 *              errors/warnings that occured. If there were errors, the
 *              flag early-exit is that, so dosemu won't really.
 */

static void close_file(FILE * file)
{
  if (file) fclose(file);                  /* Close the config-file */

  if(errors)
    fprintf(stderr, "%d error(s) detected while parsing the configuration-file\n",
	    errors);
  if(warnings)
    fprintf(stderr, "%d warning(s) detected while parsing the configuration-file\n",
	    warnings);

  if (errors != 0)               /* Exit dosemu on errors */
    {
      config.exitearly = TRUE;
    }
}

/* write_to_syslog */
static void write_to_syslog(char *message)
{
  openlog("dosemu", LOG_PID, LOG_USER | LOG_NOTICE);
  syslog(LOG_PID | LOG_USER | LOG_NOTICE, "%s", message);
  closelog();
}

static void move_dosemu_lib_dir(char *path)
{
  if (dosemu_lib_dir_path != path) {
    if (dosemu_lib_dir_path != dosemulib_default)
      free(dosemu_lib_dir_path);
    dosemu_lib_dir_path = strdup(path);
  }
  setenv("DOSEMU_LIB_DIR", dosemu_lib_dir_path, 1);
  if (keymap_load_base_path != keymaploadbase_default)
    free(keymap_load_base_path);
  keymap_load_base_path = assemble_path(path, "", 0);
}

static FILE *open_dosemu_users(void)
{
  FILE *fp;
  fp = open_file(DOSEMU_USERS_FILE);
  if (fp) return fp;
  return 0;
}

static void setup_home_directories(void)
{
  setenv("DOSEMU_HDIMAGE_DIR", dosemu_hdimage_dir_path, 1);
  LOCALDIR = get_dosemu_local_home();
  RUNDIR = mkdir_under(LOCALDIR, "run", 0);
  DOSEMU_MIDI_PATH = assemble_path(RUNDIR, DOSEMU_MIDI, 0);
  DOSEMU_MIDI_IN_PATH = assemble_path(RUNDIR, DOSEMU_MIDI_IN, 0);
}

static void lax_user_checking(void)
{
  char *p;
  define_config_variable("c_all");
  p = getenv("USER");
  if (!p) p = "guest";
  setenv("DOSEMU_USER", p, 1);
  setenv("DOSEMU_REAL_USER", p, 1);
  setup_home_directories();
}

/* Parse TimeMode, Paul Crawford and Andrew Brooks 2004-08-01 */
/* Accepts "bios", "pit", "linux", default is "bios". Use with TIMEMODE token */
int parse_timemode(const char *timemodestr)
{
   if (timemodestr == NULL || timemodestr[0] == '\0')
     return(TM_BIOS); /* default */
   if (strcmp(timemodestr, "linux")==0)
     return(TM_LINUX);
   if (strcmp(timemodestr, "pit")==0)
     return(TM_PIT);
   if (strcmp(timemodestr, "bios")==0)
     return(TM_BIOS);
   yyerror("Unrecognised time mode (not bios, pit or linux)");
   return(TM_BIOS);
}

/* Parse Users for DOSEMU, by Alan Hourihane, alanh@fairlite.demon.co.uk */
/* Jan-17-1996: Erik Mouw (J.A.K.Mouw@et.tudelft.nl)
 *  - added logging facilities
 * In 1998:     Hans
 *  - havy changes and re-arangments
 */
void
parse_dosemu_users(void)
{
#define ALL_USERS "all"
#define PBUFLEN 256

  FILE *volatile fp;
  struct passwd *pwd;
  char buf[PBUFLEN];
  int userok = 0;
  char *ustr;
  int uid;
  int have_vars=0;

  /* We come here _very_ early (at top of main()) to avoid security conflicts.
   * priv_init() has already been called, but nothing more.
   *
   * We will exit, if /etc/dosemu.users says that the user has no right
   * to run a suid root dosemu (and we are on), but will continue, if the user
   * is running a non-suid copy _and_ is mentioned in dosemu users.
   * The dosemu.users entry for such a user is:
   *
   *      joeodd  ... nosuidroot
   *
   * The functions we call rely on the following setting:
   */
  after_secure_check = 0;
  priv_lvl = 0;

  /* We first have to find out where the dosemu.users file is placed
   * by the system administrator.
   * We first look for /etc/dosemu.users, then for /etc/dosemu/dosemu.users
   * Once we know that, most other pathes are runtime configurable:
   *
   *  - dosemu.users tells were to find the dosemu-lib-dir
   *    (DOSEMULIB_DEFAULT per default)
   *  - global.conf includes $DOSEMU_CONF_DIR/dosemu.conf
   *    (which could be changed by the owner of global.conf).
   */

  if (DOSEMU_USERS_FILE == NULL) {
    setenv("DOSEMU_CONF_DIR", "", 1);
  } else if (!exists_file(DOSEMU_USERS_FILE)) {
    DOSEMU_USERS_FILE = ALTERNATE_ETC "/" DOSEMU_USERS;
    DOSEMU_LOGLEVEL_FILE = ALTERNATE_ETC "/" DOSEMU_LOGLEVEL;
    setenv("DOSEMU_CONF_DIR", ALTERNATE_ETC, 1);
  }
  else setenv("DOSEMU_CONF_DIR", "/etc", 1);
	
  /* we check for some vital global settings
   * which we need before proceeding
   */
  setenv("DOSEMU_LIB_DIR", dosemulib_default, 1);
  move_dosemu_lib_dir(dosemu_lib_dir_path);

  fp = open_dosemu_users();
  if (fp) while (fgets(buf, PBUFLEN, fp) != NULL) {
    int l = strlen(buf);
    if (l && (buf[l-1] == '\n')) buf[l-1] = 0;
    ustr = strtok(buf, " \t\n=,;:");
    if (ustr && (ustr[0] != '#')) {
      if (!strcmp(ustr, "default_lib_dir")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          if (!exists_dir(ustr)) {
            char *tx = "default_lib_dir %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
          move_dosemu_lib_dir(ustr);
        }
      }
      if (!strcmp(ustr, "default_hdimage_dir")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          if (!exists_dir(ustr)) {
            char *tx = "default_hdimage_dir %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
          if (dosemu_hdimage_dir_path != dosemuhdimage_default)
            free(dosemu_hdimage_dir_path);
          dosemu_hdimage_dir_path = strdup(ustr);
	  dexe_load_path = dosemu_hdimage_dir_path;
        }
      }
      else if (!strcmp(ustr, "log_level")) {
        int ll = 0;
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          ll = atoi(ustr);
          if (ll < 0) ll = 0;
          if (ll > 2) ll = 2;
        }
      }
      else if (!strcmp(ustr, "config_script")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr && strcmp(ustr, DEFAULT_CONFIG_SCRIPT)) {
          config_script_path = strdup(ustr);
          if (!exists_file(config_script_path)) {
            char *tx = "config_script %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
	  config_script_name = strdup(ustr);
	}
      }
    }
  }
  if (fp) fclose(fp);

  if (!can_do_root_stuff || under_root_login) {
     /* simply ignore -- we're not suid-root */
     lax_user_checking();
     after_secure_check = 1;
     return;
  }

  /* We want to test if the _user_ is allowed to do certain privileged    */
  /* things, o check if the username connected to the get_orig_uid() is   */
  /* in the DOSEMU_USERS_FILE file (usually /etc/dosemu.users).           */
   
  uid = get_orig_uid();

  errno = 0; /* man says this is necessary?! */
  pwd = getpwuid(uid);

  /* Sanity Check, Shouldn't be anyone logged in without a userid */
  if (!pwd) 
     {
       error("Illegal User: uid=%i, error=%s\n", uid, strerror(errno));
       sprintf(buf, "Illegal DOSEMU user: uid=%i", uid);
       write_to_syslog(buf);
       exit(1);
     }

  /* preset DOSEMU_*USER env, such that a user can't fake it */
  setenv("DOSEMU_USER", "unknown", 1);
  setenv("DOSEMU_REAL_USER", pwd->pw_name, 1);

  {
       int can_have_privsetup = 0;
       fp = open_dosemu_users();
       if (fp) {
	   for(userok=0; fgets(buf, PBUFLEN, fp) != NULL && !userok; ) {
	     int l = strlen(buf);
	     if (l && (buf[l-1] == '\n')) buf[l-1] = 0;
	     ustr = strtok(buf, " \t\n,;:");
	     if (ustr && (ustr[0] != '#')) {
	       if (strcmp(ustr, pwd->pw_name)== 0) 
		 userok = 1;
	       else if (strcmp(ustr, ALL_USERS)== 0)
		 userok = 1;
	       if (userok) {
		 setenv("DOSEMU_USER", ustr, 1);
		 while ((ustr=strtok(0, " \t,;:")) !=0) {
		   if (ustr[0] == '#') break;
		   define_config_variable(ustr);
		   have_vars = 1;
                   if (!strcmp(ustr,"private_setup")) {
                     can_have_privsetup = 1;
                   }
		 }
	         if (!have_vars && !using_sudo)
		   define_config_variable("restricted");
	       }
	     }
	   }
           fclose(fp);
       }
       

       if (can_have_privsetup
              && (   get_config_variable("unrestricted")
                  || under_root_login || !can_do_root_stuff)) {
         /* this user is allowed to have a privat ~/.dosemu/lib
          * (which replaces DOSEMULIB_DEFAULT if existing).
          * Hence this user can have its own global.conf e.t.c.
          * However, this is only possible with non-suid-root
          * binary or when running under root loggin or when 'unrestricted'
          * also is set.       -- Hans
          */
         char *lpath = get_path_in_HOME(LOCALDIR_BASE_NAME "/lib");
         if (exists_dir(lpath)) move_dosemu_lib_dir(lpath);
         free(lpath);
       }
  }

  define_config_variable("c_all");
  if(userok==0 && !using_sudo) {
    define_config_variable("restricted");
  }
  if (get_config_variable("nosuidroot") || (get_config_variable("restricted") && !on_console())) {
    fprintf(stderr, "Dropping root privileges: guest or a restricted user not on console.\n");
    priv_drop();
    lax_user_checking();
    after_secure_check = 1;
    return;
  }

  /* now we setup up our local DOSEMU home directory, where we
   * have (among other things) all temporary stuff in
   * (since 0.97.10.2)
   */
  setup_home_directories();
  after_secure_check = 1;
}


char *commandline_statements=0;

static int has_dexe_magic(char *name)
{
  int fd, magic, ret;
  fd = open(name, O_RDONLY);
  if (fd <0) return 0;
  ret = (read(fd, &magic, 4) == 4) && (magic == DEXE_MAGIC);
  close(fd);
  return ret;
}

static int stat_dexe(char *name)
{
  struct stat s;
  if (stat(name, &s)) return 0;
  if ( ! S_ISREG(s.st_mode)) return 0;
  if ((s.st_mode & S_IXUSR) && (s.st_uid == get_orig_uid()))
    return has_dexe_magic(name);
  if ((s.st_mode & S_IXGRP) && (is_in_groups(s.st_gid)))
    return  has_dexe_magic(name); 
  if (s.st_mode & S_IXOTH) return has_dexe_magic(name);
  return 0;
}

static char *resolve_exec_path(char *dexename, char *ext)
{
  enum { maxn=0x255 };
  static char n[maxn+1];
  static char name[maxn+1];
  char *p, *path=getenv("PATH");

  strncpy(name,dexename,maxn);
  name[maxn] = 0;
  n[maxn] = 0;
  p = rindex(name, '.');
  if ( ext && ((p && strcmp(p, ext)) || !p) )
    strncat(name,ext,maxn);


  /* first try the pure file name */
  if (!path || (name[0] == '/') || (!strncmp(name, "./", 2))) {
    if (stat_dexe(name)) return name;
    return 0;
  }

  /* next try the standard path for DEXE files */
  snprintf(n, maxn, "%s/%s", dexe_load_path, name);
  if (stat_dexe(n)) return n;

  /* now search in the users normal PATH */
  path = strdup(path);
  p= strtok(path,":");
  while (p) {
    snprintf(n, maxn, "%s/%s", p, name);
    if (stat_dexe(n)) {
      free(path);
      return n;
    }
    p=strtok(0,":");
  }
  free(path);
  return 0;
}

void prepare_dexe_load(char *name)
{
  char *n, *cbuf;
  int fd, csize;
  struct image_header ihdr;

  n = resolve_exec_path(name, ".dexe");
  if (!n) {
    n = resolve_exec_path(name, 0);
    if (!n) {
      error("DEXE file not found or not executable\n");
      exit(1);
    }
  }

  /* now we extract the configuration file and the access flags */
  fd = open(n, O_RDONLY);
  if (read(fd, &ihdr, sizeof(struct image_header)) != sizeof(struct image_header)) {
    error("broken DEXE format, can't read image header\n");
    close(fd);
    exit(1);
  }

  lseek(fd, HEADER_SIZE + 0x200, SEEK_SET); /* just behind the MBR */
  if ((read(fd, &csize, 4) != 4) || (csize > 0x2000)) {
    error("broken DEXE format, configuration not found\n");
    close(fd);
    exit(1);
  }
  
  /* we use the -I option to feed in the configuration,
   * and we put ours in front of eventually existing options
   */
  if (commandline_statements) {
    cbuf = malloc(csize+1+strlen(commandline_statements)+1);
    read(fd, cbuf, csize);
    cbuf[csize] = '\n';
    strcpy(cbuf+csize+1, commandline_statements);
  }
  else {
    cbuf = malloc(csize+1);
    read(fd, cbuf, csize);
    cbuf[csize] = 0;
  }
  commandline_statements = cbuf;
  close(fd);

  start_disk();
  dptr->type = IMAGE;
  dptr->header = HEADER_SIZE;
  dptr->dev_name = n;
  dptr->dexeflags = ihdr.dexeflags | DISK_IS_DEXE;
  stop_disk(DISK);
  dexe_running = 1;
}


static void do_parse(FILE* fp, char *confname, char *errtx)
{
        yyin = fp;
        line_count = 1;
	include_stack_ptr = 0;
        c_printf("CONF: Parsing %s file.\n", confname);
	file_being_parsed = strdup(confname);
	include_fnames[include_stack_ptr] = file_being_parsed;
	yyrestart(fp);
        if (yyparse()) yyerror(errtx, confname);
        close_file(fp);
	include_stack_ptr = 0;
	include_fnames[include_stack_ptr] = 0;
	free(file_being_parsed);
}

int parse_config(char *confname, char *dosrcname)
{
  FILE *fd;
  int is_user_config;
#if YYDEBUG != 0
  yydebug  = 1;
#endif

  define_config_variable(PARSER_VERSION_STRING);

  /* Let's try confname if not null, and fail if not found */
  /* Else try the user's own .dosrc (old) or .dosemurc (new) */
  /* If that doesn't exist we will default to CONFIG_FILE */

  { 
    if (!dosrcname) {
      char *name = get_path_in_HOME(DOSEMU_RC);
      setenv("DOSEMU_RC", name, 1);
      free(name);
    }
    else {
      setenv("DOSEMU_RC",dosrcname,1);
    }

    /* privileged options allowed? */
    is_user_config = (confname && config_script_path && strcmp(confname, config_script_path));
    priv_lvl = !under_root_login && can_do_root_stuff && is_user_config;

    /* DEXE together with option F ? */
    if (priv_lvl && dexe_running) {
      /* for security reasons we cannot allow this */
      fprintf(stderr, "user cannot load DEXE file together with option -F\n");
      exit(1);
    }

    if (is_user_config) define_config_variable("c_user");
    else define_config_variable("c_system");
    if (dexe_running) define_config_variable("c_dexerun");

    yy_vbuffer = dosemu_conf;
    do_parse(NULL, "built-in dosemu.conf", "error in built-in dosemu.conf");
    yy_vbuffer = global_conf;
    do_parse(NULL, "built-in global.conf", "error in built-in global.conf");
    if (confname) {
      yy_vbuffer = NULL;
      fd = open_file(confname);
      if (!fd) {
        if (!dexe_running) {
          fprintf(stderr, "Cannot open base config file %s, Aborting DOSEMU.\n",confname);
          exit(1);
        }
      }
      do_parse(fd, confname, "error in configuration file %s");
    }

    if (priv_lvl) undefine_config_variable("c_user");
    else undefine_config_variable("c_system");

    if (!get_config_variable(CONFNAME_V3USED)) {
	/* we obviously have an old configuration file
         * ( or a too simple one )
	 * giving up
	 */
	yyerror("\nYour %s script or configuration file is obviously\n"
		"an old style or a too simple one\n"
		"Please read README.txt on how to upgrade\n", confname);
	exit(1);
    }

    /* privileged options allowed for user's config? */
    priv_lvl = !under_root_login && can_do_root_stuff;
    if (priv_lvl) define_config_variable("c_user");

    /* Now we parse any commandline statements from option '-I'
     * We do this under priv_lvl set above, so we have the same secure level
     * as with .dosrc
     */

    if (commandline_statements) {
      #define XX_NAME "commandline"

      open_file(0);
      define_config_variable("c_comline");
      c_printf("Parsing " XX_NAME  " statements.\n");
      yyin=0;				 /* say: we have no input file */
      yy_vbuffer=commandline_statements; /* this is the input to scan */
      do_parse(0, XX_NAME, "error in user's %s statement");
      undefine_config_variable("c_comline");
    }
  }

  /* check for global settings, that should know the whole settings
   * This we only can do, after having parsed all statements
   */

  if (dexe_running) {
    /* force a BootC,
     * regardless what ever was set in the config files
     */
    config.hdiskboot = 1;
  }
  else {
    if (get_config_variable("c_dexeonly")) {
       c_printf("CONF: only execution of DEXE files allowed\n");
       fprintf(stderr, "only execution of DEXE files allowed\n");
       exit(99);
    }
  }

#ifdef TESTING
  error("TESTING: parser is terminating program\n");
  exit(0);
#endif
  return 1;
}

#define MAX_CONFIGVARIABLES 128
char *config_variables[MAX_CONFIGVARIABLES+1] = {0};
static int config_variables_count = 0;
static int config_variables_last = 0;
static int allowed_classes = -1;
static int saved_allowed_classes = -1;



static int is_in_allowed_classes(int mask)
{
  if (!(allowed_classes & mask)) {
    yyerror("insufficient class privilege to use this configuration option\n");
    exit(99);
  }
  return 1;
}

struct config_classes {
	char *class;
	int mask;
} config_classes[] = {
	{"c_all", CL_ALL},
	{"c_normal", CL_ALL & (~(CL_VAR | CL_VPORT | CL_IRQ | CL_HARDRAM | CL_PCI | CL_NET))},
	{"c_var", CL_VAR},
	{"c_system", CL_ALL},
	{"c_vport", CL_VPORT},
	{"c_port", CL_PORT},
	{"c_irq", CL_IRQ},
	{"c_pci", CL_PCI},
	{"c_hardram", CL_HARDRAM},
	{"c_net", CL_NET},
	{0,0}
};

static int get_class_mask(char *name)
{
  struct config_classes *p = &config_classes[0];
  while (p->class) {
    if (!strcmp(p->class,name)) return p->mask;
    p++;
  }
  return 0;
}

static void update_class_mask(void)
{
  int i, m;
  allowed_classes = 0;
  for (i=0; i< config_variables_count; i++) {
    if ((m=get_class_mask(config_variables[i])) != 0) {
      allowed_classes |= m;
    }
  }
}

static void enter_user_scope(int incstackptr)
{
  if (user_scope_level) return;
  saved_priv_lvl = priv_lvl;
  priv_lvl = 1;
  saved_allowed_classes = allowed_classes;
  allowed_classes = 0;
  user_scope_level = incstackptr;
  c_printf("CONF: entered user scope, includelevel %d\n", incstackptr-1);
}

static void leave_user_scope(int incstackptr)
{
  if (user_scope_level != incstackptr) return;
  priv_lvl = saved_priv_lvl;
  allowed_classes = saved_allowed_classes;
  user_scope_level = 0;
  c_printf("CONF: left user scope, includelevel %d\n", incstackptr-1);
}

char *get_config_variable(char *name)
{
  int i;
  for (i=0; i< config_variables_count; i++) {
    if (!strcmp(name, config_variables[i])) {
      config_variables_last = i;
      return config_variables[i];
    }
  }
  return 0;
}

int define_config_variable(char *name)
{
  if (priv_lvl) {
    if (strcmp(name, CONFNAME_V3USED) && strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to define config variable %s\n", name);
      return 0;
    }
  }
  if (!get_config_variable(name)) {
    if (config_variables_count < MAX_CONFIGVARIABLES) {
      config_variables[config_variables_count++] = strdup(name);
      if (!priv_lvl) update_class_mask();
    }
    else {
      if (after_secure_check)
        c_printf("CONF: overflow on config variable list\n");
      return 0;
    }
  }
  if (after_secure_check)
    c_printf("CONF: config variable %s set\n", name);
  return 1;
}

static int undefine_config_variable(char *name)
{
  if (priv_lvl) {
    if (strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to undefine config variable %s\n", name);
      return 0;
    }
  }
  if (get_config_variable(name)) {
    int i;
    if (!strcmp(name, CONFNAME_V3USED)) parser_version_3_style_used = 0;
    free(config_variables[config_variables_last]);
    for (i=config_variables_last; i<(config_variables_count-1); i++) {
      config_variables[i] = config_variables[i+1];
    }
    config_variables_count--;
    if (!priv_lvl) update_class_mask();
    c_printf("CONF: config variable %s unset\n", name);
    return 1;
  }
  return 0;
}

char *checked_getenv(const char *name)
{
  if (user_scope_level) {
     char *s, *name_ = malloc(strlen(name)+sizeof(USERVAR_PREF));
     strcpy(name_, USERVAR_PREF);
     strcat(name_, name);
     s = getenv(name_);
     free(name_);
     if (s) return s;
  }
  return getenv(name);
}

static void check_user_var(char *name)
{
	char *name_;
	char *s;

	if (user_scope_level) return;
	name_ = malloc(strlen(name)+sizeof(USERVAR_PREF));
	strcpy(name_, USERVAR_PREF);
	strcat(name_, name);
	s = getenv(name_);
	if (s) {
		if (getenv(name))
			c_printf("CONF: variable %s replaced by user\n", name);
		setenv(name, s, 1);
		unsetenv(name_);
	}
	free(name_);
}


static char *run_shell(char *command)
{
	int pipefds[2];
	pid_t pid;
	char excode[16] = "1";

	setenv("DOSEMU_SHELL_RETURN", excode, 1);
	if (pipe(pipefds)) return strdup("");
	pid = fork();
	if (pid == -1) return strdup("");
	if (!pid) {
		/* child */
		int ret;
		close(pipefds[0]);	/* we won't read from the pipe */
		dup2(pipefds[1], 1);	/* make the pipe child's stdout */
		priv_drop();	/* drop any priviledges */
		ret = system(command);
			/* tell the parent: "we have finished",
			 * this way we need not to play games with select()
			 */
		if (ret == -1) ret = errno;
		else ret >>=8;
		write(pipefds[1],"\0\0\0",4);
		close(pipefds[1]);
		_exit(ret);
	}
	else {
		/* parent */
		char *buf = 0;
		int recsize = 128;
		int bufsize = 0;
		int ptr =0;
		int ret;
		int status;

		close(pipefds[1]);	/* we won't write to the pipe */
		do {
			bufsize = ptr + recsize;
			if (!buf) buf = malloc(bufsize);
			else buf = realloc(buf, bufsize);
			ret = read(pipefds[0], buf+ptr, recsize -1);
			if (ret > 0) {
				ptr += ret;
			}
		} while (ret >0 && (ret < 4 || memcmp(buf+ptr-4,"\0\0\0",4)));
		close(pipefds[0]);
		waitpid(pid, &status, 0);
		buf[ptr] = 0;
		if (!buf[0]) {
			free(buf);
			buf = strdup("");
		}
		sprintf(excode, "%d", WEXITSTATUS(status));
		setenv("DOSEMU_SHELL_RETURN", excode, 1);
		return buf;
	}
}


struct for_each_entry {
	char *list;
	char *ptr;
	int skip_restart;
};

#define FOR_EACH_DEPTH	16
static struct for_each_entry *for_each_list = 0;

static int for_each_handling(int loopid, char *varname, char *delim, char *list)
{
	struct for_each_entry *fe;
	char * new;
	char saved;
	if (!for_each_list) {
		int size = FOR_EACH_DEPTH * sizeof(struct for_each_entry);
		for_each_list = malloc(size);
		memset(for_each_list, 0, size);
	}
	if (loopid > FOR_EACH_DEPTH) {
		yyerror("too deeply nested foreach\n");
		return 0;
	}
	fe = for_each_list + loopid;
	if (!fe->list) {
		/* starting the loop */
		fe->ptr = fe->list = strdup(list);
		fe->skip_restart = 0;
		if (loopid) {
			/* in inner loops we need to skip the restart */
			fe->skip_restart = 1;
		}
	}
	else {
		if (fe->skip_restart) {
			fe->skip_restart = 0;
			return 1;
		}
	}
	while (fe->ptr[0] && strchr(delim,fe->ptr[0])) fe->ptr++;
	/* subsequent call */
	if (!fe->ptr[0]) {
		/* loop end */
		free(fe->list);
		fe->list = 0;
		return (0);
	}
	new = strpbrk(fe->ptr, delim);
	if (!new) new = strchr(fe->ptr,0);
	saved = *new;
	*new = 0;
	setenv(varname,fe->ptr,1);
	if (saved) new++;
	fe->ptr = new;
	return (1);
}

#ifdef TESTING_MAIN

static void die(char *reason)
{
  error("par dead: %s\n", reason);
  exit(0);
}

int
main(int argc, char **argv)
{
  if (argc != 2)
    die("no filename!");

  if (!parse_config(argv[1], argv[2] /* will be NULL if not given */))
    die("parse failed!\n");
}

#endif

	/* charset */
static struct char_set *get_charset(char *name)
{
	struct char_set *charset;

	charset = lookup_charset(name);
	if (!charset) {
		yyerror("Can't find charset %s", name);
	}
	return charset;

}

static void set_external_charset(char *charset_name)
{
	struct char_set *charset;
	charset = get_charset(charset_name);
	charset = get_terminal_charset(charset);
	if (charset) {
		if (!trconfig.output_charset) {
			trconfig.output_charset = charset;
		}
		if (!trconfig.keyb_charset) {
			trconfig.keyb_charset = charset;
		}
	}
	return;
}

static void set_internal_charset(char *charset_name)
{
	struct char_set *charset_video, *charset_config;
	charset_video = get_charset(charset_name);
	if (!is_display_charset(charset_video)) {
		yyerror("%s not suitable as an internal charset", charset_name);
	}
	charset_config = get_terminal_charset(charset_video);
	if (charset_video && !trconfig.video_mem_charset) {
		trconfig.video_mem_charset = charset_video;
	}
	if (charset_config && !trconfig.keyb_config_charset) {
		trconfig.keyb_config_charset = charset_config;
	}
	if (charset_config && !trconfig.dos_charset) {
		trconfig.dos_charset = charset_config;
	}
	return;
}


/* for keyboard plugin */



static void keyb_mod(int wich, t_keysym keynum, int unicode)
{
	static t_keysym *table = 0;
	static int count = 0;
	
	if (wich == ' ') {
		switch (keynum & 0xFF00) {
		case 0x000: wich = ' '; break;
		case 0x100: wich = 'S'; break;
		case 0x200: wich = 'A'; break;
		case 0x300: wich = 'N'; break;
		case 0x400: wich = 'C'; break;
		case 0x500: wich = 'a'; break;
		case 0x600: wich = 'c'; break;
		default: 
			/* It's a bad value ditch it */
			wich ='X'; table = 0; count = 0; break;
		}
		keynum &= 0xFF;
	}

	switch (wich) {
	case ' ': table = config.keytable->key_map;
		count=config.keytable->sizemap;
		break;
	case 'S': table = config.keytable->shift_map;
		count=config.keytable->sizemap;
		break;
	case 'A': table = config.keytable->alt_map;
		count=config.keytable->sizemap;
		break;
	case 'C': table = config.keytable->ctrl_map;
		count=config.keytable->sizemap;
		break;
	case 'a': table = config.keytable->shift_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'c': table = config.keytable->ctrl_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'N': table = config.keytable->num_table;
		count=config.keytable->sizepad;
		break;
	}


	if (!table || (count == 0) || (wich != 0 && keynum >= count)) {
		count = 0;
		table = 0;
		return;
	}
	if (wich != 0) {
		table += keynum;
		count -= keynum;
		return;
	}
	if (!unicode) {
		if (keynum == 0) {
			keynum = KEY_VOID;
		} else {
			keynum = keynum + 0xEF00;
		}
	}
	if (count > 0) {
		*table++ = keynum;
		count--;
	}
}


static char *get_key_name(t_keysym key)
{
	struct key_names {
		t_keysym key;
		char *name;
	};
	static struct key_names names[] =
	{
		{ KEY_DEAD_GRAVE,	"dgrave"},
		{ KEY_DEAD_ACUTE,	"dacute"},
		{ KEY_DEAD_CIRCUMFLEX,	"dcircum"},
		{ KEY_DEAD_TILDE,	"dtilde"},
		{ KEY_DEAD_BREVE,	"dbreve"},
		{ KEY_DEAD_ABOVEDOT,	"daboved"},
		{ KEY_DEAD_DIAERESIS,	"ddiares"},
		{ KEY_DEAD_ABOVERING,	"dabover"},
		{ KEY_DEAD_DOUBLEACUTE,	"ddacute"},
		{ KEY_DEAD_CEDILLA,	"dcedilla"},
		{ KEY_DEAD_OGONEK,	"dogonek"},
		{ KEY_DEAD_CARON,	"dcaron"},
	};
	int i;
	for(i = 0; i < sizeof(names)/sizeof(names[0]); i++) {
		if (names[i].key == key) {
			return names[i].name;
		}
	}
	return 0;
}

static void dump_keytable_part(FILE *f, t_keysym *map, int size)
{
  int i, in_string=0;
  t_keysym c;
  char *cc, comma=' ', buf[16];

  /* Note: This code assumes every font is a superset of ascii */
  if (!map) {
	  return;
  }
  size--;
  for (i=0; i<=size; i++) {
    c = map[i];
    if (!(i & 15)) fprintf(f,"    ");
    cc = get_key_name(c);
    if (!cc && (c < 128) && isprint(c) && !strchr("\\\"\'`", c)) {
      if (in_string) fputc(c,f);
      else {
        fprintf(f, "%c\"%c", comma, c);
        in_string = 1;
      }
    }
    else {
      if (!cc) {
	if (((c > 0) && (c < 128)) || ((c >= 0xEF00) && (c <= 0xEFFF))) {
	  sprintf(buf, "%d", c & 0xFF);
	} else if (c == KEY_VOID) {
	  strcpy(buf, "0");
	} else {
	  sprintf(buf, "\\u%04x", c);
	}
	cc = buf;
      }
      if (!in_string) fprintf(f, "%c%s", comma, cc);
      else {
        fprintf(f, "\",%s", cc);
        in_string = 0;
      }
    }
    if ((i & 15) == 15) {
      if (in_string) fputc('"', f);
      if (i < size) fputc(',', f);
      fputc('\n', f);
      in_string = 0;
      comma = ' ';
    }
    else comma = ',';
  }
  if (in_string) fputc('"', f);
  fputc('\n', f);
}


void dump_keytable(FILE *f, struct keytable_entry *kt)
{
    fprintf(f, "keytable %s {\n", kt->name);
    fprintf(f, "  0=\n");
    dump_keytable_part(f, kt->key_map, kt->sizemap);
    fprintf(f, "  shift 0=\n");
    dump_keytable_part(f, kt->shift_map, kt->sizemap);
    fprintf(f, "  alt 0=\n");
    dump_keytable_part(f, kt->alt_map, kt->sizemap);
    fprintf(f, "  numpad 0=\n");
    dump_keytable_part(f, kt->num_table, kt->sizepad-1);
    fprintf(f, "  ctrl 0=\n");
    dump_keytable_part(f, kt->ctrl_map, kt->sizemap);
    fprintf(f, "  shift-alt 0=\n");
    dump_keytable_part(f, kt->shift_alt_map, kt->sizemap);
    fprintf(f, "  ctrl-alt 0=\n");
    dump_keytable_part(f, kt->ctrl_alt_map, kt->sizemap);
    fprintf(f, "}\n\n\n");
}


